// C3Dlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "C3Dlg.h"
#include "C4Section.h"
#include "C7Section.h"
#include "PaxHelper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CC3Dlg 


CC3Dlg::CC3Dlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CC3Dlg::IDD, rEventDispatcher)
{
    this->m_pSHF = NULL;
	//{{AFX_DATA_INIT(CC3Dlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
	this->m_CtrlArray.Add( this->m_EditRevivals );
	this->m_CtrlArray.Add( this->m_EditName );
	this->m_CtrlArray.Add( this->m_EditLevel );
	this->m_CtrlArray.Add( this->m_EditGold );
	this->m_CtrlArray.Add( this->m_EditExp );
	this->m_CtrlArray.Add( this->m_ComboType );
	this->m_CtrlArray.Add( this->m_ComboMode );
	this->m_CtrlArray.Add( this->m_CheckTypeEqual );
	this->m_CtrlArray.Add( this->m_CheckSilver );
	this->m_CtrlArray.Add( this->m_CheckRevivalEqual );
	this->m_CtrlArray.Add( this->m_CheckPlatin );
	this->m_CtrlArray.Add( this->m_CheckNiob );
	this->m_CtrlArray.Add( this->m_CheckLevelEqual );
	this->m_CtrlArray.Add( this->m_CheckHardcore );
	this->m_CtrlArray.Add( this->m_CheckGoldEqual );
	this->m_CtrlArray.Add( this->m_CheckGold );
	this->m_CtrlArray.Add( this->m_CheckExpEqual );
	this->m_CtrlArray.Add( this->m_CheckCheat );
	this->m_CtrlArray.Add( this->m_CheckBronze );
    this->m_CtrlArray.Add( this->m_ComboSeverity );
}


void CC3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CC3Dlg)
	DDX_Control(pDX, IDC_COMBO_VERSION, m_ComboVersion);
	DDX_Control(pDX, IDC_COMBO_SEVERITY, m_ComboSeverity);
	DDX_Control(pDX, IDC_EDIT_REVIVALS, m_EditRevivals);
	DDX_Control(pDX, IDC_EDIT_NAME, m_EditName);
	DDX_Control(pDX, IDC_EDIT_LEVEL, m_EditLevel);
	DDX_Control(pDX, IDC_EDIT_GOLD, m_EditGold);
	DDX_Control(pDX, IDC_EDIT_EXP, m_EditExp);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_ComboType);
	DDX_Control(pDX, IDC_COMBO_MODE, m_ComboMode);
	DDX_Control(pDX, IDC_CHECK_TYPE_EQUAL, m_CheckTypeEqual);
	DDX_Control(pDX, IDC_CHECK_SILVER, m_CheckSilver);
	DDX_Control(pDX, IDC_CHECK_REVIVALS_EQUAL, m_CheckRevivalEqual);
	DDX_Control(pDX, IDC_CHECK_PLATIN, m_CheckPlatin);
	DDX_Control(pDX, IDC_CHECK_NIOB, m_CheckNiob);
	DDX_Control(pDX, IDC_CHECK_LEVEL_EQUAL, m_CheckLevelEqual);
	DDX_Control(pDX, IDC_CHECK_HARDCORE, m_CheckHardcore);
	DDX_Control(pDX, IDC_CHECK_GOLD_EQUAL, m_CheckGoldEqual);
	DDX_Control(pDX, IDC_CHECK_GOLD, m_CheckGold);
	DDX_Control(pDX, IDC_CHECK_EXP_EQUAL, m_CheckExpEqual);
	DDX_Control(pDX, IDC_CHECK_CHEAT, m_CheckCheat);
	DDX_Control(pDX, IDC_CHECK_BRONZE, m_CheckBronze);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CC3Dlg, CModelessDlg)
	//{{AFX_MSG_MAP(CC3Dlg)
	ON_BN_CLICKED(IDC_CHECK_TYPE_EQUAL, OnCheckTypeEqual)
	ON_BN_CLICKED(IDC_CHECK_LEVEL_EQUAL, OnCheckLevelEqual)
	ON_BN_CLICKED(IDC_CHECK_GOLD_EQUAL, OnCheckGoldEqual)
	ON_BN_CLICKED(IDC_CHECK_EXP_EQUAL, OnCheckExpEqual)
	ON_BN_CLICKED(IDC_CHECK_REVIVALS_EQUAL, OnCheckRevivalsEqual)
	ON_EN_CHANGE(IDC_EDIT_LEVEL, OnChangeEditLevel)
	ON_EN_CHANGE(IDC_EDIT_GOLD, OnChangeEditGold)
	ON_EN_CHANGE(IDC_EDIT_EXP, OnChangeEditExp)
	ON_EN_CHANGE(IDC_EDIT_REVIVALS, OnChangeEditRevivals)
	ON_EN_CHANGE(IDC_EDIT_NAME, OnChangeEditName)
	ON_CBN_SELCHANGE(IDC_COMBO_SEVERITY, OnSelchangeComboSeverity)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CC3Dlg::Refresh()
{
    this->m_bUW = false;
    CC4Section c4Section;
    CC7Section c7Section;

    bool bOK = (this->m_C3Section.SetHeroFile( this->m_pSHF ) && c4Section.SetHeroFile( this->m_pSHF ) && c7Section.SetHeroFile( this->m_pSHF ));
    this->m_CtrlArray.EnableWindow( bOK );
    if (bOK)
    {
        this->m_bUW = this->m_pSHF->IsUW();

        this->m_EditName.SetWindowText( (LPCTSTR)this->m_C3Section.GetName() );

        CC3Dlg::SetValues( this->m_C3Section.GetRevivals()  , c4Section.GetRevivals()   , this->m_EditRevivals  , this->m_CheckRevivalEqual , this->m_uiC4Revivals  );
        CC3Dlg::SetValues( this->m_C3Section.GetLevel()     , c7Section.GetLevel()      , this->m_EditLevel     , this->m_CheckLevelEqual   , this->m_uiC7Level     );
        CC3Dlg::SetValues( this->m_C3Section.GetGold()      , c7Section.GetGold()       , this->m_EditGold      , this->m_CheckGoldEqual    , this->m_uiC7Gold      );
        CC3Dlg::SetValues( this->m_C3Section.GetExp()       , c7Section.GetExp()        , this->m_EditExp       , this->m_CheckExpEqual     , this->m_uiC7Exp       );

        this->m_ComboMode.SetCurSel( (int)this->m_C3Section.GetPlayMode() );
        this->m_ComboSeverity.SetCurSel( (int)this->m_C3Section.GetLastPlaySeverity() );
        this->m_ComboVersion.SetCurSel( this->m_bUW ? 2 : 1 );

        UINT uiC3Type = this->m_C3Section.GetCharType();
        UINT uiC7Type = c7Section.GetCharType();
        this->m_ComboType.SetCurSel( uiC3Type );
        this->m_ComboType.EnableWindow( uiC3Type != uiC7Type );
	    this->m_CheckTypeEqual.SetCheck( uiC3Type == uiC7Type );
        this->m_uiC7Type = uiC7Type;

        this->m_CheckBronze.SetCheck( this->m_C3Section.IsSeverity( S_Bronze ) ) ;
        this->m_CheckSilver.SetCheck( this->m_C3Section.IsSeverity( S_Silver ) ) ;
	    this->m_CheckGold.SetCheck  ( this->m_C3Section.IsSeverity( S_Gold   ) ) ;
	    this->m_CheckPlatin.SetCheck( this->m_C3Section.IsSeverity( S_Platin ) ) ;
	    this->m_CheckNiob.SetCheck  ( this->m_C3Section.IsSeverity( S_Niob   ) ) ;

        this->m_CheckHardcore.SetCheck( this->m_C3Section.IsHardcore() );
	    this->m_CheckCheat.SetCheck( this->m_C3Section.IsCheated() );
    }
    else
    {
	    this->m_EditRevivals.SetWindowText( "" );
	    this->m_EditName.SetWindowText( "" );
	    this->m_EditLevel.SetWindowText( "" );
	    this->m_EditGold.SetWindowText( "" );
	    this->m_EditExp.SetWindowText( "" );

        this->m_ComboMode.SetCurSel( 0 );
	    this->m_ComboType.SetCurSel( 0 );
        this->m_ComboSeverity.SetCurSel( 0 );
        this->m_ComboVersion.SetCurSel( 0 );
	    
        this->m_CheckTypeEqual.SetCheck( 0 );
	    this->m_CheckSilver.SetCheck( 0 );
	    this->m_CheckRevivalEqual.SetCheck( 0 );
	    this->m_CheckPlatin.SetCheck( 0 );
	    this->m_CheckNiob.SetCheck( 0 );
	    this->m_CheckLevelEqual.SetCheck( 0 );
	    this->m_CheckHardcore.SetCheck( 0 );
	    this->m_CheckGoldEqual.SetCheck( 0 );
	    this->m_CheckGold.SetCheck( 0 );
	    this->m_CheckExpEqual.SetCheck( 0 );
	    this->m_CheckCheat.SetCheck( 0 );
	    this->m_CheckBronze.SetCheck( 0 );
    }
}

void CC3Dlg::Save()
{
//*
    if (this->m_C3Section.IsInitialized())
    {
        CString strTemp;

        this->m_EditName.GetWindowText( strTemp );
        this->m_C3Section.SetName( strTemp );
        this->m_C3Section.SetCharType( (CharType)this->m_ComboType.GetCurSel() );

        this->m_C3Section.SetRevivals   ( CHelper::ReadValue( this->m_EditRevivals  ) );
        this->m_C3Section.SetLevel      ( CHelper::ReadValue( this->m_EditLevel     ) );
        this->m_C3Section.SetGold       ( CHelper::ReadValue( this->m_EditGold      ) );
        this->m_C3Section.SetExp        ( CHelper::ReadValue( this->m_EditExp       ) );

        this->m_C3Section.SetSeverity( S_Bronze, this->m_CheckBronze.GetCheck() != 0 );
        this->m_C3Section.SetSeverity( S_Silver, this->m_CheckSilver.GetCheck() != 0 );
        this->m_C3Section.SetSeverity( S_Gold  , this->m_CheckGold.GetCheck()   != 0 );
        this->m_C3Section.SetSeverity( S_Platin, this->m_CheckPlatin.GetCheck() != 0 );
        this->m_C3Section.SetSeverity( S_Niob  , this->m_CheckNiob.GetCheck()   != 0 );

        this->m_C3Section.SetHardcore( this->m_CheckHardcore.GetCheck() != 0 );
        this->m_C3Section.SetCheated ( this->m_CheckCheat.GetCheck()    != 0 );

        this->m_C3Section.SetPlaymode( (PlayMode)this->m_ComboMode.GetCurSel() );
        this->m_C3Section.SetLastPlaySeverity( (Severity)this->m_ComboSeverity.GetCurSel() );
    }
//*/
}

/*static*/ void CC3Dlg::SetValues( UINT uiValue, UINT uiValueCheck, CEdit & rEdit, CButton & rCheckBox, UINT & uiValueBackup )
{
    rEdit.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiValue ) );
    rEdit.EnableWindow( uiValue != uiValueCheck );
    rCheckBox.SetCheck( uiValue == uiValueCheck );
    uiValueBackup = uiValueCheck;
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CC3Dlg 

BOOL CC3Dlg::OnInitDialog() 
{
	CModelessDlg::OnInitDialog();
	
    this->m_ComboMode.AddString( "" );
	this->m_ComboMode.AddString( "Singleplayer" );
    this->m_ComboMode.AddString( "Multiplayer Open" );
    this->m_ComboMode.AddString( "Multiplayer Closed" );

    this->m_ComboType.AddString( "" );
    this->m_ComboType.AddString( "Seraphim" );
    this->m_ComboType.AddString( "Gladiator" );
    this->m_ComboType.AddString( "Kampfmagier" );
    this->m_ComboType.AddString( "Dunkelelf" );
    this->m_ComboType.AddString( "Waldelfe" );
    this->m_ComboType.AddString( "Vampirin (Ritterform)" );
    this->m_ComboType.AddString( "Vampirin (Vampirform)" );
    this->m_ComboType.AddString( "Zwerg" );
    this->m_ComboType.AddString( "Dmonin" );

    for (int i = (int)S_None; i <= (int)S_Niob; ++i)
    {
        this->m_ComboSeverity.AddString( (LPCTSTR)CPaxHelper::GetSeverityString( (Severity)i ) );
    }

    this->m_ComboVersion.AddString( "" );
    this->m_ComboVersion.AddString( "Sacred Classic" );
    this->m_ComboVersion.AddString( "Sacred Underworld" );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/*virtual*/ void CC3Dlg::HandleChangeEvent( EventType eventType, UINT uiNewValue )
{
    switch (eventType)
    {
        case ET_LevelC7:
        {
            this->m_uiC7Level = uiNewValue;
            if (this->m_CheckLevelEqual.GetCheck() != 0)
            {
                this->m_EditLevel.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiNewValue ) );
            }
            break;
        }
        case ET_GoldC7:
        {
            this->m_uiC7Gold = uiNewValue;
            if (this->m_CheckGoldEqual.GetCheck() != 0)
            {
                this->m_EditGold.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiNewValue ) );
            }
            break;
        }
        case ET_ExpC7:
        {
            this->m_uiC7Exp = uiNewValue;
            if (this->m_CheckExpEqual.GetCheck() != 0)
            {
                this->m_EditExp.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiNewValue ) );
            }
            break;
        }
        case ET_RevivalC4:
        {
            this->m_uiC4Revivals = uiNewValue;
            if (this->m_CheckRevivalEqual.GetCheck() != 0)
            {
                this->m_EditRevivals.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiNewValue ) );
            }
            break;
        }
        default: break;
    }
}

void CC3Dlg::OnCheckTypeEqual() 
{
    bool bCheck = (this->m_CheckTypeEqual.GetCheck() != 0);

    if (!bCheck)
    {
        this->m_ComboType.SetCurSel( this->m_uiC7Type );
    }

    this->m_CheckTypeEqual.SetCheck( !bCheck );
    this->m_ComboType.EnableWindow( bCheck );
}

void CC3Dlg::OnCheckLevelEqual() 
{
    CHelper::HandleCheck( this->m_CheckLevelEqual, this->m_EditLevel, this->m_uiC7Level );
}

void CC3Dlg::OnCheckGoldEqual() 
{
    CHelper::HandleCheck( this->m_CheckGoldEqual, this->m_EditGold, this->m_uiC7Gold );
}

void CC3Dlg::OnCheckExpEqual() 
{
    CHelper::HandleCheck( this->m_CheckExpEqual, this->m_EditExp, this->m_uiC7Exp );
}

void CC3Dlg::OnCheckRevivalsEqual() 
{
    CHelper::HandleCheck( this->m_CheckRevivalEqual, this->m_EditRevivals, this->m_uiC4Revivals );
}

void CC3Dlg::OnChangeEditLevel() 
{
    CHelper::LimitValue( this->m_EditLevel, this->m_bUW ? MAX_LEVEL_UNDERWORLD : MAX_LEVEL_CLASSIC );
}

void CC3Dlg::OnChangeEditGold() 
{
    CHelper::LimitValue( this->m_EditGold, INT_MAX );
}

void CC3Dlg::OnChangeEditExp() 
{
    CHelper::LimitValue( this->m_EditExp, this->m_bUW ? MAX_EXP_UNDERWORLD : MAX_EXP_CLASSIC );
}

void CC3Dlg::OnChangeEditRevivals() 
{
    CHelper::LimitValue( this->m_EditRevivals, 255 );
}

void CC3Dlg::OnChangeEditName() 
{
    if (this->m_EditName.GetWindowTextLength() > 64)
    {
        CString strName;
        this->m_EditName.GetWindowText( strName );
        int iStart, iEnd;
        this->m_EditName.GetSel( iStart, iEnd );
        strName = strName.Left( 64 );
        this->m_EditName.SetWindowText( (LPCTSTR)strName );
        this->m_EditName.SetSel( iStart, iEnd );
    }
}

void CC3Dlg::OnSelchangeComboSeverity() 
{
    int iIndex = this->m_ComboSeverity.GetCurSel();
    if (iIndex >= 0)
    {
        this->SendEvent( ET_LastPlaySeverity, (UINT)iIndex );
    }
}


/*virtual*/ UINT CC3Dlg::GetChildMoveSize(UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
//*/
    return uiRet;
}
