// C3Section.h: Schnittstelle fr die Klasse CC3Section.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_C3SECTION_H__620CD7FB_9EE2_4A75_B578_0028A167E15B__INCLUDED_)
#define AFX_C3SECTION_H__620CD7FB_9EE2_4A75_B578_0028A167E15B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "SacredHeroFileEx.h"


typedef enum _PlayMode
{
    PM_Unknown,
    PM_SP,
    PM_MP_OPEN,
    PM_MP_CLOSED,
} PlayMode;

class CC3Section  
{
private:
    CSacredHeroFileEx* m_pSHF;

public:
	CC3Section();
	virtual ~CC3Section();

    bool SetHeroFile( CSacredHeroFileEx* pSHF );
    bool IsInitialized() { return this->m_pSHF != NULL; }

    CString GetName() const;
    UINT GetRevivals() const;
    UINT GetLevel() const;
    UINT GetGold() const;
    UINT GetExp() const;
    PlayMode GetPlayMode() const;
    CharType GetCharType() const;
    bool IsHardcore() const;
    bool IsSeverity( Severity severity ) const;
    bool IsCheated() const;
    Severity GetLastPlaySeverity() const;

    UINT GetItemID( ItemPosition itemPosition ) const;

    bool SetName( const CString & strName );
    bool SetRevivals( UINT uiRevivals );
    bool SetLevel( UINT uiLevel );
    bool SetGold( UINT uiGold );
    bool SetExp( UINT uiExp );
    bool SetPlaymode( PlayMode playMode );
    bool SetCharType( CharType charType );
    bool SetHardcore( bool bHardcore );
    bool SetSeverity( Severity severity, bool bSet );
    bool SetCheated( bool bCheated );
    bool SetLastPlaySeverity( Severity severity );
};

#endif // !defined(AFX_C3SECTION_H__620CD7FB_9EE2_4A75_B578_0028A167E15B__INCLUDED_)
