// C4Dlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "C4Dlg.h"
#include "PaxStructures.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CC4Dlg 


CC4Dlg::CC4Dlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CC4Dlg::IDD, rEventDispatcher)
{
    this->m_bUpdatingFightTime = false;
    this->m_pSHF = NULL;
	//{{AFX_DATA_INIT(CC4Dlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
	this->m_CtrlArray.Add( this->m_EditSurvivalBonus );
	this->m_CtrlArray.Add( this->m_EditRunes );
	this->m_CtrlArray.Add( this->m_EditRevivals );
	this->m_CtrlArray.Add( this->m_EditPlayTimeSeconds );
	this->m_CtrlArray.Add( this->m_EditPlayTimeMinutes );
	this->m_CtrlArray.Add( this->m_EditPlayTimeHours );
	this->m_CtrlArray.Add( this->m_EditKills );
	this->m_CtrlArray.Add( this->m_EditFightTimeSeconds );
	this->m_CtrlArray.Add( this->m_EditFightTimeMinutes );
	this->m_CtrlArray.Add( this->m_EditFightTimeHours );
}


void CC4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CC4Dlg)
	DDX_Control(pDX, IDC_EDIT_SURVIVALBONUS, m_EditSurvivalBonus);
	DDX_Control(pDX, IDC_EDIT_RUNES, m_EditRunes);
	DDX_Control(pDX, IDC_EDIT_REVIVALS, m_EditRevivals);
	DDX_Control(pDX, IDC_EDIT_PLAYTIME_SECONDS, m_EditPlayTimeSeconds);
	DDX_Control(pDX, IDC_EDIT_PLAYTIME_MINUTES, m_EditPlayTimeMinutes);
	DDX_Control(pDX, IDC_EDIT_PLAYTIME_HOURS, m_EditPlayTimeHours);
	DDX_Control(pDX, IDC_EDIT_KILLS, m_EditKills);
	DDX_Control(pDX, IDC_EDIT_FIGHTTIME_SECONDS, m_EditFightTimeSeconds);
	DDX_Control(pDX, IDC_EDIT_FIGHTTIME_MINUTES, m_EditFightTimeMinutes);
	DDX_Control(pDX, IDC_EDIT_FIGHTTIME_HOURS, m_EditFightTimeHours);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CC4Dlg, CModelessDlg)
	//{{AFX_MSG_MAP(CC4Dlg)
	ON_EN_CHANGE(IDC_EDIT_REVIVALS, OnChangeEditRevivals)
	ON_EN_CHANGE(IDC_EDIT_KILLS, OnChangeEditKills)
	ON_EN_CHANGE(IDC_EDIT_RUNES, OnChangeEditRunes)
	ON_EN_CHANGE(IDC_EDIT_SURVIVALBONUS, OnChangeEditSurvivalbonus)
	ON_EN_CHANGE(IDC_EDIT_FIGHTTIME_HOURS, OnChangeEditFighttimeHours)
	ON_EN_CHANGE(IDC_EDIT_FIGHTTIME_MINUTES, OnChangeEditFighttimeMinutes)
	ON_EN_CHANGE(IDC_EDIT_FIGHTTIME_SECONDS, OnChangeEditFighttimeSeconds)
	ON_EN_CHANGE(IDC_EDIT_PLAYTIME_HOURS, OnChangeEditPlaytimeHours)
	ON_EN_CHANGE(IDC_EDIT_PLAYTIME_MINUTES, OnChangeEditPlaytimeMinutes)
	ON_EN_CHANGE(IDC_EDIT_PLAYTIME_SECONDS, OnChangeEditPlaytimeSeconds)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CC4Dlg::Refresh()
{
    bool bOK = this->m_C4Section.SetHeroFile( this->m_pSHF );
    this->m_CtrlArray.EnableWindow( bOK );
    if (bOK)
    {
        this->m_EditKills.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C4Section.GetKills() ) );
	    this->m_EditRevivals.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C4Section.GetRevivals() ) );
	    this->m_EditRunes.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C4Section.GetRunes() ) );
	    this->m_EditPlayTimeHours.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C4Section.GetHours() ) );
	    this->m_EditPlayTimeMinutes.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C4Section.GetMinutes() ) );
	    this->m_EditPlayTimeSeconds.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C4Section.GetSeconds() ) );
	    this->m_EditSurvivalBonus.SetWindowText( (LPCTSTR)CHelper::UIntToString( CHelper::CalcSurvivalBonus( this->m_C4Section.GetSurvivalTime() ) ) );
        this->SetFightTime( this->m_C4Section.GetSurvivalTime() );
    }
    else
    {
	    this->m_EditSurvivalBonus.SetWindowText( "" );
	    this->m_EditRunes.SetWindowText( "" );
	    this->m_EditRevivals.SetWindowText( "" );
	    this->m_EditPlayTimeSeconds.SetWindowText( "" );
	    this->m_EditPlayTimeMinutes.SetWindowText( "" );
	    this->m_EditPlayTimeHours.SetWindowText( "" );
	    this->m_EditKills.SetWindowText( "" );
	    this->m_EditFightTimeSeconds.SetWindowText( "" );
	    this->m_EditFightTimeMinutes.SetWindowText( "" );
	    this->m_EditFightTimeHours.SetWindowText( "" );
    }
}

void CC4Dlg::SetFightTime( UINT uiSurvivalTime )
{
    if (!this->m_bUpdatingFightTime)
    {
        this->m_bUpdatingFightTime = true;

        this->m_EditFightTimeHours.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiSurvivalTime / 3600 ) );
	    this->m_EditFightTimeMinutes.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiSurvivalTime / 60 % 60 ) );
	    this->m_EditFightTimeSeconds.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiSurvivalTime % 60 ) );

        this->m_bUpdatingFightTime = false;
    }
}

void CC4Dlg::Save()
{
//*
    if (this->m_C4Section.IsInitialized())
    {
        this->m_C4Section.SetKills      ( CHelper::GetUIntValue( this->m_EditKills ) );
        this->m_C4Section.SetHours      ( CHelper::GetUIntValue( this->m_EditPlayTimeHours ) );
        this->m_C4Section.SetMinutes    ( CHelper::GetUIntValue( this->m_EditPlayTimeMinutes ) );
        this->m_C4Section.SetSeconds    ( CHelper::GetUIntValue( this->m_EditPlayTimeSeconds ) );
        this->m_C4Section.SetRevivals   ( CHelper::GetUIntValue( this->m_EditRevivals ) );
        this->m_C4Section.SetRunes      ( CHelper::GetUIntValue( this->m_EditRunes ) );
        this->m_C4Section.SetSurvivalTime( this->GetSurvivalTime() );
    }
//*/
}

UINT CC4Dlg::GetSurvivalTime()
{
    CString strTemp;

    UINT uiHours, uiMinutes, uiSeconds;

    this->m_EditFightTimeHours.GetWindowText( strTemp );
    sscanf( (LPCTSTR)strTemp, "%u", &uiHours );

    this->m_EditFightTimeMinutes.GetWindowText( strTemp );
    sscanf( (LPCTSTR)strTemp, "%u", &uiMinutes );

    this->m_EditFightTimeSeconds.GetWindowText( strTemp );
    sscanf( (LPCTSTR)strTemp, "%u", &uiSeconds );

    return (uiHours * 3600 + uiMinutes * 60 + uiSeconds);
}

void CC4Dlg::SetSurvivalBonus()
{
    if (!this->m_bUpdatingFightTime)
    {
        this->m_bUpdatingFightTime = true;

        CString strTemp;
        strTemp.Format( "%u", CHelper::CalcSurvivalBonus( this->GetSurvivalTime() ) );
	    this->m_EditSurvivalBonus.SetWindowText( (LPCTSTR)strTemp );

        this->m_bUpdatingFightTime = false;
    }
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CC4Dlg 

void CC4Dlg::OnChangeEditRevivals() 
{
    UINT uiRevivals = CHelper::LimitValue( this->m_EditRevivals );
    this->SendEvent( ET_RevivalC4, uiRevivals );
}

void CC4Dlg::OnChangeEditKills() 
{
    CHelper::LimitValue( this->m_EditKills );
}

void CC4Dlg::OnChangeEditRunes() 
{
    CHelper::LimitValue( this->m_EditRunes );
}

void CC4Dlg::OnChangeEditSurvivalbonus() 
{
    if (!this->m_bUpdatingFightTime)
    {
        UINT uiSB = CHelper::LimitValue( this->m_EditSurvivalBonus, 99 );
        UINT uiSurvivalTime = CHelper::CalcSurvivalTime( uiSB );
        this->SetFightTime( uiSurvivalTime );
    }
}

void CC4Dlg::OnChangeEditFighttimeHours() 
{
    if (!this->m_bUpdatingFightTime)
    {
        CHelper::LimitValue( this->m_EditFightTimeHours, UINT_MAX / 3600 - 1 );
        this->SetSurvivalBonus();
    }
}

void CC4Dlg::OnChangeEditFighttimeMinutes() 
{
    if (!this->m_bUpdatingFightTime)
    {
        CHelper::LimitValue( this->m_EditFightTimeMinutes, 59 );
        this->SetSurvivalBonus();
    }
}

void CC4Dlg::OnChangeEditFighttimeSeconds() 
{
    if (!this->m_bUpdatingFightTime)
    {
        CHelper::LimitValue( this->m_EditFightTimeSeconds, 59 );
    }
}

void CC4Dlg::OnChangeEditPlaytimeHours() 
{
    CHelper::LimitValue( this->m_EditPlayTimeHours );
}

void CC4Dlg::OnChangeEditPlaytimeMinutes() 
{
    CHelper::LimitValue( this->m_EditPlayTimeMinutes, 59 );
}

void CC4Dlg::OnChangeEditPlaytimeSeconds() 
{
    CHelper::LimitValue( this->m_EditPlayTimeSeconds, 59 );
}

/*virtual*/ UINT CC4Dlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
*/
    return uiRet;
}
