// C4Section.cpp: Implementierung der Klasse CC4Section.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "C4Section.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CC4Section::CC4Section()
{
    this->m_pSHF = NULL;
}

CC4Section::~CC4Section()
{
}

bool CC4Section::SetHeroFile( CSacredHeroFileEx* pSHF )
{
    bool bRet = false;
    if (pSHF != NULL)
    {
        LPSECTIONC4 pC4 = pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            this->m_pSHF = pSHF;
            bRet = true;
        }
    }
    return bRet;
}

//////////////////////////////////////////////////////////////////////
// Get-Funktionen
//////////////////////////////////////////////////////////////////////

UINT CC4Section::GetKills() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiKills;
        }
    }
    return 0;
}

UINT CC4Section::GetRevivals() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiRevivals;
        }
    }
    return 0;
}

UINT CC4Section::GetRunes() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiRunes;
        }
    }
    return 0;
}

UINT CC4Section::GetSurvivalTime() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiSurvivalTime;
        }
    }
    return 0;
}

UINT CC4Section::GetHours() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiPlayTimeHours;
        }
    }
    return 0;
}

UINT CC4Section::GetMinutes() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiPlayTimeMinutes;
        }
    }
    return 0;
}

UINT CC4Section::GetSeconds() const
{
    if (this->m_pSHF != NULL)
    {
        const LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if (pC4 != NULL)
        {
            return (UINT)pC4->uiPlayTimeSeconds;
        }
    }
    return 0;
}

//////////////////////////////////////////////////////////////////////
// Set-Funktionen
//////////////////////////////////////////////////////////////////////

bool CC4Section::SetKills( UINT uiKills )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiKills, uiKills, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC4Section::SetRevivals( UINT uiRevivals )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiRevivals, uiRevivals, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC4Section::SetRunes( UINT uiRunes )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiRunes, uiRunes, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC4Section::SetSurvivalTime( UINT uiSurvivalTime )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiSurvivalTime, uiSurvivalTime, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC4Section::SetHours( UINT uiHours )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiPlayTimeHours, uiHours, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC4Section::SetMinutes( UINT uiMinutes )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiPlayTimeMinutes, uiMinutes, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC4Section::SetSeconds( UINT uiSeconds )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC4Section = this->m_pSHF->GetC4Section();
        LPSECTIONC4 pC4 = this->m_pSHF->GetC4Struct();
        if ((pC4Section != NULL) && (pC4 != NULL))
        {
            CPaxSection::SetValue( pC4->uiPlayTimeSeconds, uiSeconds, *pC4Section );
            bRet = true;
        }
    }
    return bRet;
}
