// C7AttributeSkillDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "C7AttributeSkillDlg.h"
#include "paxhelper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CC7AttributeSkillDlg 


CC7AttributeSkillDlg::CC7AttributeSkillDlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CC7AttributeSkillDlg::IDD, rEventDispatcher)
{
	//{{AFX_DATA_INIT(CC7AttributeSkillDlg)
	//}}AFX_DATA_INIT
}


void CC7AttributeSkillDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_COMBO_SKILL1, m_aComboSkills[0]);
	DDX_Control(pDX, IDC_COMBO_SKILL2, m_aComboSkills[1]);
	DDX_Control(pDX, IDC_COMBO_SKILL3, m_aComboSkills[2]);
	DDX_Control(pDX, IDC_COMBO_SKILL4, m_aComboSkills[3]);
	DDX_Control(pDX, IDC_COMBO_SKILL5, m_aComboSkills[4]);
	DDX_Control(pDX, IDC_COMBO_SKILL6, m_aComboSkills[5]);
	DDX_Control(pDX, IDC_COMBO_SKILL7, m_aComboSkills[6]);
	DDX_Control(pDX, IDC_COMBO_SKILL8, m_aComboSkills[7]);

	DDX_Control(pDX, IDC_SPIN_SKILL1, m_aSpinSkills[0]);
	DDX_Control(pDX, IDC_SPIN_SKILL2, m_aSpinSkills[1]);
	DDX_Control(pDX, IDC_SPIN_SKILL3, m_aSpinSkills[2]);
	DDX_Control(pDX, IDC_SPIN_SKILL4, m_aSpinSkills[3]);
	DDX_Control(pDX, IDC_SPIN_SKILL5, m_aSpinSkills[4]);
	DDX_Control(pDX, IDC_SPIN_SKILL6, m_aSpinSkills[5]);
	DDX_Control(pDX, IDC_SPIN_SKILL7, m_aSpinSkills[6]);
	DDX_Control(pDX, IDC_SPIN_SKILL8, m_aSpinSkills[7]);

	DDX_Control(pDX, IDC_SPIN_STRENGTH,         m_aSpinAttribute[0]);
	DDX_Control(pDX, IDC_SPIN_REFRACTIVENESS,   m_aSpinAttribute[1]);
	DDX_Control(pDX, IDC_SPIN_DEXTERITY,        m_aSpinAttribute[2]);
	DDX_Control(pDX, IDC_SPIN_PHYS_REG,         m_aSpinAttribute[3]);
	DDX_Control(pDX, IDC_SPIN_MENT_REG,         m_aSpinAttribute[4]);
	DDX_Control(pDX, IDC_SPIN_CHARISMA,         m_aSpinAttribute[5]);

    //{{AFX_DATA_MAP(CC7AttributeSkillDlg)
    DDX_Control(pDX, IDC_EDIT_FREE_ATTRIBUTE_POINTS,    m_EditFreeAttributePoints);
	DDX_Control(pDX, IDC_EDIT_FREE_SKILL_POINTS,        m_EditFreeSkillPoints);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CC7AttributeSkillDlg, CModelessDlg)
	//{{AFX_MSG_MAP(CC7AttributeSkillDlg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_STRENGTH, OnDeltaposSpinStrength)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_REFRACTIVENESS, OnDeltaposSpinRefractiveness)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_DEXTERITY, OnDeltaposSpinDexterity)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_PHYS_REG, OnDeltaposSpinPhysReg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_MENT_REG, OnDeltaposSpinMentReg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_CHARISMA, OnDeltaposSpinCharisma)
	ON_EN_CHANGE(IDC_EDIT_FREE_ATTRIBUTE_POINTS, OnChangeEditFreeAttributePoints)
	ON_EN_CHANGE(IDC_EDIT_FREE_SKILL_POINTS, OnChangeEditFreeSkillPoints)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL1, OnSelchangeComboSkill1)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL2, OnSelchangeComboSkill2)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL3, OnSelchangeComboSkill3)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL4, OnSelchangeComboSkill4)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL5, OnSelchangeComboSkill5)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL6, OnSelchangeComboSkill6)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL7, OnSelchangeComboSkill7)
	ON_CBN_SELCHANGE(IDC_COMBO_SKILL8, OnSelchangeComboSkill8)
	//}}AFX_MSG_MAP
    ON_NOTIFY_RANGE( UDN_DELTAPOS, IDC_SPIN_SKILL1, IDC_SPIN_SKILL8, OnDeltaposSpinSkills )
END_MESSAGE_MAP()


static short aCharAttributeStartValues[CT_Last][ATTRIBUTE_COUNT] =
{
    /*  Strke, Widerstand, Geschick,   Phys.Reg.,  Ment.Reg.,  Charisma */
    {   0,      0,          0,          0,          0,          0   },  // CT_NoCharType
    {   22,     19,         24,         22,         19,         17  },  // CT_Seraphim
    {   33,     19,         20,         25,         0,          11  },  // CT_Gladiator
    {   16,     15,         20,         14,         30,         10  },  // CT_Mage
    {   26,     18,         26,         20,         0,          16  },  // CT_Darkelf
    {   13,     13,         29,         21,         24,         15  },  // CT_Woodelf
    {   26,     22,         21,         22,         0,          21  },  // CT_Vampire
    {   26,     22,         21,         22,         0,          21  },  // CT_Vampire2
    {   26,     18,         25,         24,         0,          8   },  // CT_Dwarf
    {   35,     15,         22,         18,         28,         15  },  // CT_Daemon
};

static Attribute aAttribute[ATTRIBUTE_COUNT] =
{
    A_Staerke,
    A_Widerstand,
    A_Geschick,
    A_PhysReg,
    A_MentReg,
    A_Charisma,
};

static SkillNumber aSkillNumber[MAX_SKILL_COUNT] =
{
    S_Skill1,
    S_Skill2,
    S_Skill3,
    S_Skill4,
    S_Skill5,
    S_Skill6,
    S_Skill7,
    S_Skill8,
};

void CC7AttributeSkillDlg::Refresh()
{
    bool bOK = this->m_C7Section.SetHeroFile( this->m_pSHF );

    int i;
    for (i = 0; i < ATTRIBUTE_COUNT; ++i)
    {
        this->m_aSpinAttribute[i].EnableWindow( bOK );
        this->m_aSpinAttribute[i].SetPos32( 0 );
    }
    for (i = 0; i < MAX_SKILL_COUNT; ++i)
    {
        this->m_aComboSkills[i].ResetContent();
        this->m_aComboSkills[i].EnableWindow( bOK );
        this->m_aSpinSkills[i].EnableWindow( bOK );
        this->m_aSpinSkills[i].SetPos32( 0 );
    }

    if (bOK)
    {
        // Char-Typ und Level auslesen
        this->m_Type = this->m_C7Section.GetCharType();
        this->m_uiC7Level = this->m_C7Section.GetLevel();

        // Basis-Punkte errechnen
        this->UpdateBaseValues();

        // Bonus-Punkte auslesen
        this->UpdateBonusValues();

        // verteilte Punkte ermitteln 
        int aDistribute[ATTRIBUTE_COUNT];
        aDistribute[0] = (int)this->m_C7Section.GetStrength();
        aDistribute[1] = (int)this->m_C7Section.GetRefractiveness();
        aDistribute[2] = (int)this->m_C7Section.GetDexterity();
        aDistribute[3] = (int)this->m_C7Section.GetPhysReg();
        aDistribute[4] = (int)this->m_C7Section.GetMentReg();
        aDistribute[5] = (int)this->m_C7Section.GetCharisma();

        for (i = 0; i < ATTRIBUTE_COUNT; ++i)
        {
            this->m_aDistribute[i] = aDistribute[i] - this->m_aBase[i] - this->m_aBonus[i];
            ASSERT( this->m_aDistribute[i] >= 0);
        }

        // noch nicht verteilte Punkte auslesen
        this->m_uiFreeAttributePoints = (UINT)this->m_C7Section.GetFreeAttributePoints();
        this->m_uiFreeSkillPoints     = (UINT)this->m_C7Section.GetFreeSkillPoints();

        bool bNotSel = false;

        // Skills setzen
        for (i = 0; i < MAX_SKILL_COUNT; ++i)
        {
            SkillType skillType = ST_NichtAusgewaehlt;
            BYTE bLevel, bBonus;
            this->m_C7Section.GetSkill( aSkillNumber[i], skillType, bLevel, bBonus );

            if (bNotSel || !CC7AttributeSkillDlg::CheckCharSkill( this->m_Type, skillType, i, this->m_uiC7Level ))
            {
                skillType = ST_NichtAusgewaehlt;
                if (bLevel > 1)
                {
                    --bLevel;
                    this->m_uiFreeSkillPoints += (UINT)bLevel;
                }
                bLevel = 0;
            }

            this->m_aSkillType[i] = skillType;
            this->m_aSkillLevel[i] = bLevel;

            bNotSel = (skillType == ST_NichtAusgewaehlt);
        }

        // SkillCombos aktualisieren
        this->UpdateSkills();

        // Anzeige aktualisieren
        this->UpdateShowing( true );
    }
    else
    {
        this->m_EditFreeAttributePoints.SetWindowText( "" );
        this->m_EditFreeSkillPoints.SetWindowText( "" );
    }
}

void CC7AttributeSkillDlg::Save()
{
//*
    if (this->m_C7Section.IsInitialized())
    {
        this->m_C7Section.SetStrength       ( (SHORT)this->m_aSpinAttribute[0].GetPos32() );
        this->m_C7Section.SetRefractiveness ( (SHORT)this->m_aSpinAttribute[1].GetPos32() );
        this->m_C7Section.SetDexterity      ( (SHORT)this->m_aSpinAttribute[2].GetPos32() );
        this->m_C7Section.SetPhysReg        ( (SHORT)this->m_aSpinAttribute[3].GetPos32() );
        this->m_C7Section.SetMentReg        ( (SHORT)this->m_aSpinAttribute[4].GetPos32() );
        this->m_C7Section.SetCharisma       ( (SHORT)this->m_aSpinAttribute[5].GetPos32() );

        this->m_C7Section.SetFreeAttributePoints( (BYTE)this->m_uiFreeAttributePoints );
        this->m_C7Section.SetFreeSkillPoints    ( (WORD)this->m_uiFreeSkillPoints );

        CItemList & rItemList = this->m_pSHF->GetItemList();

        for (int i = 0; i < MAX_SKILL_COUNT; ++i)
        {
            SkillType skillType = (SkillType)this->m_aComboSkills[i].GetItemData( this->m_aComboSkills[i].GetCurSel() );
            BYTE bLevel = this->m_aSkillLevel[i];
            BYTE bBonus = (BYTE)rItemList.GetCharBonus( skillType, this->m_Type );
            this->m_C7Section.SetSkill( aSkillNumber[i], skillType, bLevel, bBonus );
        }

        this->m_C7Section.UpdateUnusedSkillCount();
    }
//*/
}

void CC7AttributeSkillDlg::UpdateBonusValues()
{
    if (this->m_pSHF != NULL)
    {
        CItemList & rItemList = this->m_pSHF->GetItemList();

        for (int i = 0; i < ATTRIBUTE_COUNT; ++i)
        {
            this->m_aBonus[i] = rItemList.GetCharBonus( aAttribute[i], this->m_Type );
        }
    }
}

void CC7AttributeSkillDlg::UpdateBaseValues()
{
    for (int i = 0; i < ATTRIBUTE_COUNT; ++i)
    {
        this->m_aBase[i] = aCharAttributeStartValues[this->m_Type][i] + aCharAttributeStartValues[this->m_Type][i] * (this->m_uiC7Level - 1) / 10;
        ASSERT( this->m_aBase[i] >= 0);
    }
}

void CC7AttributeSkillDlg::UpdateShowing( bool bUpdateSpinControls )
{
    if (bUpdateSpinControls)
    {
        // Attribute anzeigen
        for (int i = 0; i < ATTRIBUTE_COUNT; ++i)
        {
            this->m_aSpinAttribute[i].SetPos32( this->m_aBase[i] + this->m_aDistribute[i] + this->m_aBonus[i] );
        }
    }

    // freie Punkte anzeigen
    this->m_EditFreeAttributePoints.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_uiFreeAttributePoints ) );
    this->m_EditFreeSkillPoints.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_uiFreeSkillPoints ) );
}

static SkillType vCharToSkill[CT_Last][15] =
{
/*CT_NoCharType */ { ST_NichtAusgewaehlt,   ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,
                     ST_NichtAusgewaehlt,   ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,
                     ST_NichtAusgewaehlt,   ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt,    ST_NichtAusgewaehlt
                    },
/*CT_Seraphim   */ { ST_Magiekunde,         ST_Waffenkunde,         ST_Meditation,          ST_Konzentration,       ST_Himmelsmagie,
                     ST_Stangenwaffen,      ST_Schwertkunde,        ST_Konstitution,        ST_Parade,              ST_Reiten,
                     ST_Zweiwaffenkampf,    ST_Ruestung,            ST_Fernkampf,           ST_Wendigkeit,          ST_Handel
                     },
/*CT_Gladiator  */ { ST_Waffenkunde,        ST_Konzentration,       ST_Axtkampf,            ST_Zweiwaffenkampf,     ST_Faustkampf,
                     ST_Fernkampf,          ST_Schwertkunde,        ST_Konstitution,        ST_Ruestung,            ST_Wendigkeit,
                     ST_Reiten,             ST_Entwaffnung,         ST_Stangenwaffen,       ST_Parade,              ST_Handel
                    },
/*CT_Mage       */ { ST_Magiekunde,         ST_Meditation,          ST_Feuermagie,          ST_Erdmagie,            ST_Wassermagie,
                     ST_Luftmagie,          ST_Waffenkunde,         ST_Schwertkunde,        ST_Stangenwaffen,       ST_Reiten,
                     ST_Wendigkeit,         ST_Handel,              ST_Konstitution,        ST_Entwaffnung,         ST_Parade
                    },
/*CT_Darkelf    */ { ST_Waffenkunde,        ST_Konzentration,       ST_Klingenkampf,        ST_Fallenkunst,         ST_Ballistik,
                     ST_Zweiwaffenkampf,    ST_Konstitution,        ST_Wendigkeit,          ST_Entwaffnung,         ST_Reiten,
                     ST_Faustkampf,         ST_Ruestung,            ST_Schwertkunde,        ST_Parade,              ST_Handel
                    },
/*CT_Woodelf    */ { ST_Wendigkeit,         ST_Waffenkunde,         ST_Magiekunde,          ST_Meditation,          ST_Mondmagie,
                     ST_Fernkampf,          ST_Konzentration,       ST_Konstitution,        ST_Reiten,              ST_Stangenwaffen,
                     ST_Handel,             ST_Schwertkunde,        ST_Ruestung,            ST_Entwaffnung,         ST_Parade
                    },
/*CT_Vampire    */ { ST_Waffenkunde,        ST_Vampirismus,         ST_Konstitution,        ST_Blutrausch,          ST_Konzentration,
                     ST_Schwertkunde,       ST_Axtkampf,            ST_Ruestung,            ST_Parade,              ST_Entwaffnung,
                     ST_Reiten,             ST_Wendigkeit,          ST_Stangenwaffen,       ST_Handel,              ST_Fernkampf
                    },
/*CT_Vampire2   */ { ST_Waffenkunde,        ST_Vampirismus,         ST_Konstitution,        ST_Blutrausch,          ST_Konzentration,
                     ST_Schwertkunde,       ST_Axtkampf,            ST_Ruestung,            ST_Parade,              ST_Entwaffnung,
                     ST_Reiten,             ST_Wendigkeit,          ST_Stangenwaffen,       ST_Handel,              ST_Fernkampf
                    },
/*CT_Dwarf      */ { ST_Waffenkunde,        ST_Konstitution,        ST_Waffentechnik,       ST_Zwergenkunde,        ST_Axtkampf,
                     ST_Handel,             ST_Ruestung,            ST_Fernkampf,           ST_Konzentration,       ST_Parade,
                     ST_Faustkampf,         ST_Schwertkunde,        ST_Schmiedekunst,       ST_Entwaffnung,         ST_Wendigkeit
                    },
/*CT_Daemon     */ { ST_Magiekunde,         ST_Waffenkunde,         ST_Hoellenmacht,        ST_Meditation,          ST_Schwertkunde,
                     ST_Axtkampf,           ST_Zweiwaffenkampf,     ST_Stangenwaffen,       ST_Konzentration,       ST_Konstitution,
                     ST_Wendigkeit,         ST_Reiten,              ST_Ruestung,            ST_Parade,              ST_Entwaffnung
                    },
};

static UINT vSkillMinLevel[MAX_SKILL_COUNT] = { 1, 1, 3, 6, 12, 20, 30, 50 };

void CC7AttributeSkillDlg::UpdateSkills()
{
    bool bNotSel = false;
    for (int iSkill = 0; iSkill < MAX_SKILL_COUNT; ++iSkill)
    {
        // Combobox komplett leeren
        this->m_aComboSkills[iSkill].ResetContent();

        // <nicht ausgewhlt> einfgen
        int iSel = -1;
        int iIndex = this->m_aComboSkills[iSkill].AddString( CPaxHelper::GetSkillString( ST_NichtAusgewaehlt ) );
        if (iIndex >= 0)
        {
            this->m_aComboSkills[iSkill].SetItemData( iIndex, (DWORD)ST_NichtAusgewaehlt );
            iSel = iIndex;
        }

        if (!bNotSel)
        {
            int i;
            // alle anderen mglichen Skills fr diesen Chartyp einfgen, wenn sie noch nicht in vorherigen Comboboxen ausgewhlt sind
            for (i = 0; i < (iSkill + 8); ++i)
            {
                bool bSelected = false;
                SkillType skill = vCharToSkill[this->m_Type][i];

                // prfen, ob Skill schon in vorherigen Comboboxen aktiviert ist
                for (int j = 0; j < iSkill; ++j)
                {
                    iIndex = this->m_aComboSkills[j].GetCurSel();
                    if (iIndex >= 0)
                    {
                        if (this->m_aComboSkills[j].GetItemData( iIndex ) == (DWORD)skill)
                        {
                            bSelected = true;
                            j = iSkill;
                        }
                    }
                }

                // wenn noch nicht ausgewhlt, dann in die Liste aufnehmen
                if (!bSelected)
                {
                    iIndex = this->m_aComboSkills[iSkill].AddString( CPaxHelper::GetSkillString( skill ) );
                    if (iIndex >= 0)
                    {
                        this->m_aComboSkills[iSkill].SetItemData( iIndex, (DWORD)skill );
                        if (skill == this->m_aSkillType[iSkill]) iSel = iIndex;
                    }
                }
                else
                {
                    if (skill == this->m_aSkillType[iSkill])
                    {
                        this->m_aSkillType[iSkill] = ST_NichtAusgewaehlt;
                        if (this->m_aSkillLevel[iSkill] > 1)
                        {
                            this->m_uiFreeSkillPoints += (UINT)this->m_aSkillLevel[iSkill];
                            --this->m_uiFreeSkillPoints;
                        }
                        this->m_aSkillLevel[iSkill] = 0;
                    }
                }
            }

            // diesen Skill aus den vorherigen Comboboxen entfernen
            for (i = 0; i < iSkill; ++i)
            {
                int iIndex = this->m_aComboSkills[i].FindStringExact( -1, CPaxHelper::GetSkillString( this->m_aSkillType[iSkill] ) );
                if (iIndex >= 0)
                {
                    this->m_aComboSkills[i].DeleteString( iIndex );
                }
            }

            bNotSel = (this->m_aSkillType[iSkill] == ST_NichtAusgewaehlt);
        }

        // Selektion setzen
        this->m_aComboSkills[iSkill].SetCurSel( iSel );
        this->m_aSpinSkills[iSkill].SetPos32( this->m_aSkillLevel[iSkill] );
    }
}

/*static*/ bool CC7AttributeSkillDlg::CheckCharSkill( CharType charType, SkillType skillType, int iSkill, UINT uiLevel )
{
    if (iSkill < 0) iSkill = 0;
    if (iSkill >= MAX_SKILL_COUNT) iSkill = 7;

    if (uiLevel < vSkillMinLevel[iSkill]) return false;

    iSkill += 8;

    for (int i = 0; i < iSkill; ++i)
    {
        if (vCharToSkill[charType][i] == skillType) return true;
    }

    return false;
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CC7AttributeSkillDlg 

BOOL CC7AttributeSkillDlg::OnInitDialog() 
{
	CModelessDlg::OnInitDialog();

    int i;
    for (i = 0; i < ATTRIBUTE_COUNT; ++i)
    {
        this->m_aSpinAttribute[i].SetRange32( INT_MIN, INT_MAX );
		this->m_aSpinAttribute[i].SetNoAccel();
    }

    for (i = 0; i < MAX_SKILL_COUNT; ++i)
    {
        this->m_aSpinSkills[i].SetRange32( 0, 255 );
		this->m_aSpinSkills[i].SetNoAccel();
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/*virtual*/ void CC7AttributeSkillDlg::HandleChangeEvent( EventType eventType, UINT uiNewValue )
{
    switch (eventType)
    {
        case ET_LevelC7:
        {
            // freie Punkte aktualisieren
            this->m_uiFreeAttributePoints += uiNewValue;
            this->m_uiFreeAttributePoints -= this->m_uiC7Level;

            UINT uiMax = this->m_uiC7Level > uiNewValue ? this->m_uiC7Level : uiNewValue;
            UINT uiMin = this->m_uiC7Level <= uiNewValue ? this->m_uiC7Level : uiNewValue;
            UINT uiValue = 0;

            while (uiMin < uiMax)
            {
                ++uiMin;
                uiValue += CHelper::CalcNewSkillPointsForLevel( uiMin );
            }

            if (this->m_uiC7Level > uiNewValue)
            {
                this->m_uiFreeSkillPoints -= uiValue;
            }
            else
            {
                this->m_uiFreeSkillPoints += uiValue;
            }

            this->m_uiC7Level = uiNewValue;

            this->UpdateBaseValues();
            this->UpdateShowing( true );

            break;
        }
        case ET_Items:
        {
            // Bonus-Punkte auslesen
            this->UpdateBonusValues();
            this->UpdateShowing( true );

            break;
        }
        default: break;
    }
}

void CC7AttributeSkillDlg::ChangeAttribute( NM_UPDOWN & nmUpDown, LRESULT & lResult, UINT uiAttributeIndex )
{
    bool bOK = false;

    if (nmUpDown.iDelta > 0)
    {
        if (this->m_uiFreeAttributePoints > 0)
        {
            if ((UINT)nmUpDown.iDelta > this->m_uiFreeAttributePoints)
            {
                nmUpDown.iDelta = (int)this->m_uiFreeAttributePoints;
            }
            this->m_aDistribute[uiAttributeIndex] += nmUpDown.iDelta;
            this->m_uiFreeAttributePoints -= (UINT)nmUpDown.iDelta;

            bOK = true;
        }
    }
    else
    {
        if (this->m_aDistribute[uiAttributeIndex] > 0)
        {
            int iDelta = -nmUpDown.iDelta;

            if (iDelta > this->m_aDistribute[uiAttributeIndex])
            {
                iDelta = this->m_aDistribute[uiAttributeIndex];
                nmUpDown.iDelta = -this->m_aDistribute[0];
            }

            this->m_aDistribute[uiAttributeIndex] -= iDelta;
            this->m_uiFreeAttributePoints += iDelta;

            bOK = true;
        }
    }

    if (bOK)
    {
        this->UpdateShowing( false );

        lResult = 0;
    }
    else
    {
	    lResult = 1;
    }
}

void CC7AttributeSkillDlg::OnDeltaposSpinStrength(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    this->ChangeAttribute( *pNMUpDown, *pResult, 0 );
}

void CC7AttributeSkillDlg::OnDeltaposSpinRefractiveness(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    this->ChangeAttribute( *pNMUpDown, *pResult, 1 );
}

void CC7AttributeSkillDlg::OnDeltaposSpinDexterity(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    this->ChangeAttribute( *pNMUpDown, *pResult, 2 );
}

void CC7AttributeSkillDlg::OnDeltaposSpinPhysReg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    this->ChangeAttribute( *pNMUpDown, *pResult, 3 );
}

void CC7AttributeSkillDlg::OnDeltaposSpinMentReg(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    this->ChangeAttribute( *pNMUpDown, *pResult, 4 );
}

void CC7AttributeSkillDlg::OnDeltaposSpinCharisma(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    this->ChangeAttribute( *pNMUpDown, *pResult, 5 );
}

void CC7AttributeSkillDlg::OnDeltaposSpinSkills( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    *pResult = 1;
    if (id >= IDC_SPIN_SKILL1 && id <= IDC_SPIN_SKILL8)
    {
        int iIndex = (int)(id - IDC_SPIN_SKILL1);

        if (this->m_aSkillType[iIndex] != ST_NichtAusgewaehlt)
        {
            NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

            if (pNMUpDown->iDelta < 0)
            {
                if (pNMUpDown->iPos > 1)
                {
                    if ((pNMUpDown->iPos + pNMUpDown->iDelta) < 1)
                    {
                        pNMUpDown->iDelta = 1 - pNMUpDown->iPos;
                    }

                    ASSERT((pNMUpDown->iPos + pNMUpDown->iDelta) >= 1);

                    this->m_uiFreeSkillPoints += (UINT)(-pNMUpDown->iDelta);
                    this->UpdateShowing( false );
                    ASSERT( (pNMUpDown->iPos + pNMUpDown->iDelta) < 256 );
                    this->m_aSkillLevel[iIndex] = (BYTE)(pNMUpDown->iPos + pNMUpDown->iDelta);
                    this->m_aSpinSkills[iIndex].SetPos32( this->m_aSkillLevel[iIndex] );
                }
            }
            else if ((pNMUpDown->iPos < (int)this->m_uiC7Level) && (this->m_uiFreeSkillPoints > 0))
            {
                if (pNMUpDown->iDelta > (int)this->m_uiFreeSkillPoints)
                {
                    pNMUpDown->iDelta = this->m_uiFreeSkillPoints;
                }

                if ((pNMUpDown->iPos + pNMUpDown->iDelta) > (int)this->m_uiC7Level)
                {
                    pNMUpDown->iDelta = this->m_uiC7Level - pNMUpDown->iPos;
                }

                this->m_uiFreeSkillPoints -= pNMUpDown->iDelta;
                this->UpdateShowing( false );
                ASSERT( (pNMUpDown->iPos + pNMUpDown->iDelta) < 256 );
                this->m_aSkillLevel[iIndex] = (BYTE)(pNMUpDown->iPos + pNMUpDown->iDelta);
                this->m_aSpinSkills[iIndex].SetPos32( this->m_aSkillLevel[iIndex] );
            }
        }
    }
}

void CC7AttributeSkillDlg::OnChangeEditFreeAttributePoints() 
{
    this->SendEvent( ET_FreeAttributePoints, this->m_uiFreeAttributePoints );
}

void CC7AttributeSkillDlg::OnChangeEditFreeSkillPoints() 
{
    this->SendEvent( ET_FreeSkillPoints, this->m_uiFreeSkillPoints );
}

void CC7AttributeSkillDlg::ChangeSkill( int iSkill )
{
    if (iSkill < 0) return;
    if (iSkill >= MAX_SKILL_COUNT) return;

    int iIndex = this->m_aComboSkills[iSkill].GetCurSel();
    if (iIndex >= 0)
    {
        SkillType skillTypeNew = (SkillType)this->m_aComboSkills[iSkill].GetItemData( iIndex );

        if (skillTypeNew == ST_NichtAusgewaehlt)
        {
            for (int i = iSkill; i < MAX_SKILL_COUNT; ++i)
            {
                this->m_aSkillType[i] = ST_NichtAusgewaehlt;
                if (this->m_aSkillLevel[i] > 1)
                {
                    this->m_uiFreeSkillPoints += (UINT)this->m_aSkillLevel[i];
                    --this->m_uiFreeSkillPoints;
                }
                this->m_aSkillLevel[i] = 0;
            }
        }
        else if (this->m_aSkillType[iSkill] == ST_NichtAusgewaehlt)
        {
            this->m_aSkillLevel[iSkill] = 1;
        }
        this->m_aSkillType[iSkill] = skillTypeNew;
        this->UpdateSkills();
        this->UpdateShowing( false );
    }
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill1() 
{
    this->ChangeSkill( 0 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill2() 
{
    this->ChangeSkill( 1 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill3() 
{
    this->ChangeSkill( 2 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill4() 
{
    this->ChangeSkill( 3 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill5() 
{
    this->ChangeSkill( 4 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill6() 
{
    this->ChangeSkill( 5 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill7() 
{
    this->ChangeSkill( 6 );
}

void CC7AttributeSkillDlg::OnSelchangeComboSkill8() 
{
    this->ChangeSkill( 7 );
}

/*virtual*/ UINT CC7AttributeSkillDlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
*/
    return uiRet;
}
