// C7CombatArtsDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "C7CombatArtsDlg.h"
#include "paxhelper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CC7CombatArtsDlg 


CC7CombatArtsDlg::CC7CombatArtsDlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CC7CombatArtsDlg::IDD, rEventDispatcher)
{
	//{{AFX_DATA_INIT(CC7CombatArtsDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CC7CombatArtsDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CC7CombatArtsDlg)
	DDX_Control(pDX, IDC_SPIN_LEVEL, m_SpinLevel);
	DDX_Control(pDX, IDC_LIST_COMBATARTS, m_ListCombatArts);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CC7CombatArtsDlg, CModelessDlg)
	//{{AFX_MSG_MAP(CC7CombatArtsDlg)
	ON_NOTIFY(NM_CLICK, IDC_LIST_COMBATARTS, OnClickListCombatarts)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_LEVEL, OnDeltaposSpinLevel)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_INSERT, OnInsert)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CC7CombatArtsDlg::Refresh()
{
    this->m_ListCombatArts.DeleteAllItems();
    if (this->m_C7Section.SetHeroFile( this->m_pSHF ))
    {
        CItemList & itemList = this->m_pSHF->GetItemList();
        UINT ui, uiCount = this->m_C7Section.GetCombatArtCount();
        for (ui = 0; ui < uiCount; ++ui)
        {
            CombatArt combatArt;
            BYTE bLevel, bBonus;
            if (this->m_C7Section.GetCombatArt( ui, combatArt, bLevel, bBonus ))
            {
                CString strCombatArt = CPaxHelper::GetCombatArtString( combatArt );
                if (!strCombatArt.IsEmpty())
                {
                    int iIndex = this->m_ListCombatArts.InsertItem( this->m_ListCombatArts.GetItemCount(), (LPCTSTR)strCombatArt  );
                    if (iIndex >= 0)
                    {
                        this->m_ListCombatArts.SetItemData( iIndex, (DWORD)combatArt );

                        this->SetLevel( iIndex, bLevel );
                        this->SetBonus( iIndex, bBonus );

                        int iBonus = (int)bBonus;
                        int iBonusCalc = itemList.GetCharBonus( combatArt, this->m_C7Section.GetCharType() );
                        if (iBonus != iBonusCalc)
                        {
                            TRACE("CombatArt %s: gespeicherter Bonus = %d  errechneter Bonus = %d\n", (LPCTSTR)strCombatArt, iBonus, iBonusCalc );
                        }
                    }
                }

                if (CA_None != CPaxHelper::GetAssociatedCombatArt( combatArt ))
                {
                    ++ui;
                }
            }
        }
    }
    else
    {
        this->m_SpinLevel.SetPos( 0 );
        this->m_SpinLevel.EnableWindow( false );
    }
}

void CC7CombatArtsDlg::Save()
{
//*
    if (this->m_C7Section.IsInitialized())
    {
        UINT ui = 0;
        int i, iCount = this->m_ListCombatArts.GetItemCount();
        for (i = 0; i < iCount; ++i)
        {
            CombatArt combatArt = (CombatArt)this->m_ListCombatArts.GetItemData( i );
            BYTE bLevel = this->GetLevel( i );
            BYTE bBonus = this->GetBonus( i );

            this->m_C7Section.SetCombatArt( ui++, combatArt, bLevel, bBonus );

            combatArt = CPaxHelper::GetAssociatedCombatArt( combatArt );
            if (combatArt != CA_None)
            {
                this->m_C7Section.SetCombatArt( ui++, combatArt, bLevel, bBonus );
            }
        }
    }
//*/
}

void CC7CombatArtsDlg::SetLevel( int iItemIndex, BYTE bLevel )
{
    this->m_ListCombatArts.SetItemText( iItemIndex, 1, (LPCTSTR)CHelper::UIntToString( (UINT)bLevel ) );
}

void CC7CombatArtsDlg::SetBonus( int iItemIndex, BYTE bBonus )
{
    this->m_ListCombatArts.SetItemText( iItemIndex, 2, (LPCTSTR)CHelper::UIntToString( (UINT)bBonus ) );
}

BYTE CC7CombatArtsDlg::GetLevel( int iItemIndex )
{
    BYTE bLevel = 0;
    if ((iItemIndex >= 0) && (iItemIndex < this->m_ListCombatArts.GetItemCount()))
    {
        CString strLevel = this->m_ListCombatArts.GetItemText( iItemIndex, 1 );
        UINT uiLevel = 0;
        sscanf( (LPCTSTR)strLevel, "%u", &uiLevel );
        if (uiLevel > 255)
        {
            uiLevel = 255;
        }
        bLevel = (BYTE)uiLevel;
    }
    return bLevel;
}

BYTE CC7CombatArtsDlg::GetBonus( int iItemIndex )
{
    BYTE bBonus = 0;
    if ((iItemIndex >= 0) && (iItemIndex < this->m_ListCombatArts.GetItemCount()))
    {
        CString strBonus = this->m_ListCombatArts.GetItemText( iItemIndex, 2 );
        UINT uiBonus = 0;
        sscanf( (LPCTSTR)strBonus, "%u", &uiBonus );
        if (uiBonus > 255)
        {
            uiBonus = 255;
        }
        bBonus = (BYTE)uiBonus;
    }
    return bBonus;
}

/*virtual*/ void CC7CombatArtsDlg::HandleChangeEvent( EventType eventType, UINT uiNewValue )
{
    UNUSED_ALWAYS( uiNewValue );

    if (ET_Items == eventType)
    {
        CItemList & itemList = this->m_pSHF->GetItemList();

        int i, iCount = this->m_ListCombatArts.GetItemCount();
        for (i = 0; i < iCount; ++i)
        {
            CombatArt combatArt = (CombatArt)this->m_ListCombatArts.GetItemData( i );
            int iBonus = itemList.GetCharBonus( combatArt, this->m_C7Section.GetCharType() );
            this->SetBonus( i, (BYTE)iBonus );
        }
    }
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CC7CombatArtsDlg 

BOOL CC7CombatArtsDlg::OnInitDialog() 
{
	CModelessDlg::OnInitDialog();
	
    this->m_ListCombatArts.SetExtendedStyle( this->m_ListCombatArts.GetExtendedStyle() | LVS_EX_FULLROWSELECT );

	this->m_ListCombatArts.InsertColumn( 0, "Kampfkunst/Zauber", LVCFMT_LEFT, 200 );
    this->m_ListCombatArts.InsertColumn( 1, "Level", LVCFMT_RIGHT, 50 );
    this->m_ListCombatArts.InsertColumn( 2, "Bonus", LVCFMT_RIGHT, 50 );

    this->m_SpinLevel.SetRange32( 1, 255 );
	this->m_SpinLevel.SetNoAccel();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CC7CombatArtsDlg::OnClickListCombatarts(NMHDR* pNMHDR, LRESULT* pResult) 
{
    UNUSED_ALWAYS( pNMHDR );

    POSITION pos = this->m_ListCombatArts.GetFirstSelectedItemPosition();
    if (pos == NULL)
    {
        this->m_SpinLevel.SetPos( 0 );
        this->m_SpinLevel.EnableWindow( false );
    }
    else
    {
        int iItem = this->m_ListCombatArts.GetNextSelectedItem(pos);
        BYTE bLevel = this->GetLevel( iItem );
        this->m_SpinLevel.SetPos( bLevel );
        this->m_SpinLevel.EnableWindow( true );
    }
	
	*pResult = 0;
}

void CC7CombatArtsDlg::OnDeltaposSpinLevel(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
    POSITION pos = this->m_ListCombatArts.GetFirstSelectedItemPosition();
    if (pos == NULL)
    {
        this->m_SpinLevel.SetPos( 0 );
        this->m_SpinLevel.EnableWindow( false );
	    *pResult = 1;
    }
    else
    {
        if ((pNMUpDown->iPos == 1) && (pNMUpDown->iDelta <= 0))
        {
            *pResult = 1;
        }
        else if ((pNMUpDown->iPos == 255) && (pNMUpDown->iDelta >= 0))
        {
            *pResult = 1;
        }
        else
        {
            int iLevel = pNMUpDown->iPos + pNMUpDown->iDelta;
            if (iLevel < 1)
            {
                iLevel = 1;
                pNMUpDown->iDelta = iLevel - pNMUpDown->iPos;
            }
            else if (iLevel > 255)
            {
                iLevel = 255;
                pNMUpDown->iDelta = iLevel - pNMUpDown->iPos;
            }

            int iItem = this->m_ListCombatArts.GetNextSelectedItem(pos);
            this->SetLevel( iItem, (BYTE)iLevel );

	        *pResult = 0;
        }
    }
}

/*virtual*/ UINT CC7CombatArtsDlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
*/
    return uiRet;
}

void CC7CombatArtsDlg::OnDelete() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	
}

void CC7CombatArtsDlg::OnInsert() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	
}
