// C7CommonDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "C7CommonDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CC7CommonDlg 


CC7CommonDlg::CC7CommonDlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CC7CommonDlg::IDD, rEventDispatcher)
{
	//{{AFX_DATA_INIT(CC7CommonDlg)
	//}}AFX_DATA_INIT
}


void CC7CommonDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CC7CommonDlg)
	DDX_Control(pDX, IDC_SPIN_LEVEL, m_SpinLevel);
	DDX_Control(pDX, IDC_EDIT_LEVEL, m_EditLevel);
	DDX_Control(pDX, IDC_EDIT_GOLD, m_EditGold);
	DDX_Control(pDX, IDC_EDIT_EXP, m_EditExp);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_ComboType);
	DDX_Control(pDX, IDC_CHECK_CHEAT, m_CheckCheat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CC7CommonDlg, CModelessDlg)
	//{{AFX_MSG_MAP(CC7CommonDlg)
	ON_EN_CHANGE(IDC_EDIT_LEVEL, OnChangeEditLevel)
	ON_EN_CHANGE(IDC_EDIT_EXP, OnChangeEditExp)
	ON_EN_CHANGE(IDC_EDIT_GOLD, OnChangeEditGold)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CC7CommonDlg::Refresh()
{
    if (this->m_C7Section.SetHeroFile( this->m_pSHF ))
    {
        this->m_EditGold.EnableWindow( true );
        this->m_EditExp.EnableWindow( true );
        this->m_CheckCheat.EnableWindow( true );

        this->m_ComboType.SetCurSel( this->m_C7Section.GetCharType() );
        this->m_CheckCheat.SetCheck( this->m_C7Section.IsCheated() );

        this->m_EditGold.SetWindowText( (LPCTSTR)CHelper::UIntToString( this->m_C7Section.GetGold() ) );

        this->m_SpinLevel.EnableWindow( true );
        this->m_SpinLevel.SetRange32( 1, this->m_pSHF->IsUW() ? MAX_LEVEL_UNDERWORLD : MAX_LEVEL_CLASSIC );
        this->m_SpinLevel.SetPos32( (int)this->m_C7Section.GetLevel() );

        this->m_uiFreeAttributePoints = (UINT)this->m_C7Section.GetFreeAttributePoints();
        this->m_uiFreeSkillPoints = (UINT)this->m_C7Section.GetFreeSkillPoints();

        this->SetExp( this->m_C7Section.GetExp() );
    }
    else
    {
        this->m_SpinLevel.SetRange32( 0, 0 );
        this->m_SpinLevel.SetPos( 0 );
        this->m_SpinLevel.EnableWindow( false );
        this->m_EditLevel.SetWindowText( "" );

        this->m_EditGold.EnableWindow( false );
        this->m_EditGold.SetWindowText( "" );

        this->m_CheckCheat.EnableWindow( false );
    }
}

void CC7CommonDlg::Save()
{
//*
    if (this->m_C7Section.IsInitialized())
    {
        this->m_C7Section.SetCheated( this->m_CheckCheat.GetCheck() != 0 );
        this->m_C7Section.SetGold( CHelper::ReadValue( this->m_EditGold ) );
        this->m_C7Section.SetLevel( this->m_SpinLevel.GetPos32() );
        this->m_C7Section.SetExp( CHelper::ReadValue( this->m_EditExp ) );
    }
//*/
}

void CC7CommonDlg::SetExp( UINT uiExp )
{
    this->m_EditExp.SetWindowText( (LPCTSTR)CHelper::UIntToString( uiExp ) );
}

void CC7CommonDlg::SetMinLevel()
{
    if (this->m_pSHF != NULL)
    {
        int iMinLevel = this->m_SpinLevel.GetPos32();

        UINT uiFreeAttributePoints = this->m_uiFreeAttributePoints;
        int iMinLevelAttribute = iMinLevel - (int)uiFreeAttributePoints;
        UINT uiFreeSkillPoints = this->m_uiFreeSkillPoints;
        int iMinLevelSkill = iMinLevel;
        while ( (iMinLevelSkill > 1) && (uiFreeSkillPoints > 0) && (uiFreeSkillPoints >= CHelper::CalcNewSkillPointsForLevel( iMinLevelSkill )))
        {
            uiFreeSkillPoints -= CHelper::CalcNewSkillPointsForLevel( iMinLevelSkill );
            --iMinLevelSkill;
        }

        iMinLevel = iMinLevelAttribute > iMinLevelSkill ? iMinLevelAttribute : iMinLevelSkill;

        this->m_SpinLevel.SetRange32( (int)iMinLevel, this->m_pSHF->IsUW() ? MAX_LEVEL_UNDERWORLD : MAX_LEVEL_CLASSIC );
    }
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CC7CommonDlg 

BOOL CC7CommonDlg::OnInitDialog() 
{
	CModelessDlg::OnInitDialog();

    this->m_ComboType.AddString( "" );
    this->m_ComboType.AddString( "Seraphim" );
    this->m_ComboType.AddString( "Gladiator" );
    this->m_ComboType.AddString( "Kampfmagier" );
    this->m_ComboType.AddString( "Dunkelelf" );
    this->m_ComboType.AddString( "Waldelfe" );
    this->m_ComboType.AddString( "Vampirin (Ritterform)" );
    this->m_ComboType.AddString( "Vampirin (Vampirform)" );
    this->m_ComboType.AddString( "Zwerg" );
    this->m_ComboType.AddString( "Dmonin" );

	this->m_SpinLevel.SetNoAccel();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/*virtual*/ void CC7CommonDlg::HandleChangeEvent( EventType eventType, UINT uiNewValue )
{
    switch (eventType)
    {
        case ET_FreeAttributePoints:
        {
            this->m_uiFreeAttributePoints = uiNewValue;
            this->SetMinLevel();
            break;
        }
        case ET_FreeSkillPoints:
        {
            this->m_uiFreeSkillPoints = uiNewValue;
            this->SetMinLevel();
            break;
        }
        default: break;
    }
}

void CC7CommonDlg::OnChangeEditLevel() 
{
    if (this->m_C7Section.IsInitialized())
    {
        this->SendEvent( ET_LevelC7, (UINT)this->m_SpinLevel.GetPos32() );

        UINT uiExp = CHelper::ReadValue( this->m_EditExp );
        UINT uiLevel = this->m_SpinLevel.GetPos32();

        if ((uiExp < CHelper::CalcLevelExp( uiLevel )) || (uiExp >= CHelper::CalcLevelExp( uiLevel + 1)))
        {
            this->SetExp( CHelper::CalcLevelExp( uiLevel ) );
        }
    }
}

void CC7CommonDlg::OnChangeEditExp() 
{
    if (this->m_C7Section.IsInitialized())
    {
        // Maximal mgliche Erfahrung ermitteln und Wert im Editfeld auf Begrenzung prfen
        UINT uiMaxExp = this->m_pSHF->IsUW() ? MAX_EXP_UNDERWORLD : MAX_EXP_CLASSIC;
        UINT uiExp = CHelper::LimitValue( this->m_EditExp, uiMaxExp );

        // Ober- und Untergrenze fr Level ermitteln
        int iLower, iUpper;
        this->m_SpinLevel.GetRange32( iLower, iUpper );

        if (uiExp < CHelper::CalcLevelExp( iLower ))
        {
            // Erfahrung ist unterhalb des kleinst-mglichen Levels
            // -> Erfahrung auf den minimalen Wert der Level-Untergrenze setzen
            this->SetExp( CHelper::CalcLevelExp( iLower ) );
        }
        else if (uiExp >= CHelper::CalcLevelExp( iUpper + 1 ))
        {
            // Erfahrung ist oberhalb des grt-mglichen Levels
            // -> Erfahrung auf den maximalen Wert der Level-Obergrenze setzen 
            uiExp = CHelper::CalcLevelExp( iUpper + 1 ) - 1;
            this->SetExp( uiExp );
        }
        else
        {
            // nderungsevent senden
            this->SendEvent( ET_ExpC7, uiExp );

            // Anpassung des Levels notwendig?
            UINT uiLevel = this->m_SpinLevel.GetPos32();
            if (uiExp < CHelper::CalcLevelExp( uiLevel ))
            {
                // Erfahrung ist kleiner als der Wert fr aktuelles Level
                do
                {
                    // Level reduzieren, bis Erfahrung innerhalb des Bereiches
                    --uiLevel;
                }
                while (uiExp < CHelper::CalcLevelExp( uiLevel ));
                this->m_SpinLevel.SetPos32( uiLevel );
            }
            else if (uiExp >= CHelper::CalcLevelExp( uiLevel + 1))
            {
                // Erfahrung ist grer oder gleich dem Wert fr das nchst-hhere Level
                do
                {
                    // Level erhhen, bis Erfahrung kleiner dem Wert fr das nchst-hhere Level
                    ++uiLevel;
                }
                while (uiExp >= CHelper::CalcLevelExp( uiLevel + 1));
                this->m_SpinLevel.SetPos32( uiLevel );
            }
        }
    }
}

void CC7CommonDlg::OnChangeEditGold() 
{
    UINT uiGold = CHelper::LimitValue( this->m_EditGold, INT_MAX );
    this->SendEvent( ET_GoldC7, uiGold );
}

/*virtual*/ UINT CC7CommonDlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
*/
    return uiRet;
}
