// C7Section.cpp: Implementierung der Klasse CC7Section.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "C7Section.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CC7Section::CC7Section()
{
    this->m_pSHF = NULL;
}

CC7Section::~CC7Section()
{
}

bool CC7Section::SetHeroFile( CSacredHeroFileEx* pSHF )
{
    bool bRet = false;
    if (pSHF != NULL)
    {
        LPSECTIONC7 pC7 = pSHF->GetC7Struct();
        if (pC7 != NULL)
        {
            this->m_pSHF = pSHF;
            bRet = true;
        }
    }
    return bRet;
}

//////////////////////////////////////////////////////////////////////
// Get-Methoden
//////////////////////////////////////////////////////////////////////

CharType CC7Section::GetCharType() const
{
    CharType charType = CT_NoCharType;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7 pC7 = this->m_pSHF->GetC7Struct();
        if (pC7 != NULL)
        {
            if ((pC7->uiType >= CT_Seraphim) && (pC7->uiType <= CT_Daemon))
            {
                charType = (CharType)pC7->uiType;
            }
        }
    }
    return charType;
}

CharType CC7Section::GetCharTypeSub() const
{
    CharType charType = CT_NoCharType;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            if ((pC7Sub->uiType >= CT_Seraphim) && (pC7Sub->uiType <= CT_Daemon))
            {
                charType = (CharType)pC7Sub->uiType;
            }
        }
    }
    return charType;
}

bool CC7Section::IsCheated() const
{
    bool bCheated = false;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7 pC7 = this->m_pSHF->GetC7Struct();
        if (pC7 != NULL)
        {
            bCheated = (pC7->wCheatFlag != 0);
        }
    }
    return bCheated;
}

bool CC7Section::IsPortalActivated( Portal portal ) const
{
    bool bActivated = false;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            switch (portal)
            {
                case P_CL_Schoenblick:   // Schnblick
                case P_CL_PortoVallum:   // Porto Vallum
                case P_CL_Eisbachpass:   // Eisbachpass
                case P_CL_EbeneUrkuk:    // Ebene von Urkuk
                case P_CL_Biberingen:    // Biberingen
                case P_CL_Mascarell:     // Mascarell
                case P_CL_KhoradNur:     // Khorad-Nur
                case P_CL_Hohenmut:      // Burg Hohenmut
                case P_CL_Klosterfeste:  // Klosterfeste der Seraphim
                case P_CL_Heckenheim:    // Heckenheim
                case P_CL_ZhuragNar:     // Tal von Zhurag-Nar
                case P_CL_Sternental:    // Burg Sternental
                case P_CL_ShaddarNur:    // Shaddar-Nur
                case P_UW_Zwergenruinen: // Zwergenruinen
                case P_UW_Purgatori:     // Purgatori
                case P_UW_NukNukWald:    // Nuk-Nuk Wald
                case P_UW_PiratenInseln: // Piraten Inseln
                case P_UW_Dryadenwald:   // Dryaden-Wald
                case P_UW_GratDerHoelle: // Grat der Hlle
                case P_UW_TalDerTraenen: // Tal der Trnen
                {
                    bActivated = ((pC7Sub->uiPortals & (UINT)portal) == (UINT)portal);
                    break;
                }
                default: break;
            }
        }
    }
    return bActivated;
}

UINT CC7Section::GetExp() const
{
    UINT uiExp = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            uiExp = pC7Sub->uiExp;
        }
    }
    return uiExp;
}

SHORT CC7Section::GetStrength() const
{
    SHORT sStrength = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            sStrength = pC7Sub->sStrength;
        }
    }
    return sStrength;
}

SHORT CC7Section::GetRefractiveness() const
{
    SHORT sRefractiveness = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            sRefractiveness = pC7Sub->sRefractiveness;
        }
    }
    return sRefractiveness;
}

SHORT CC7Section::GetDexterity() const
{
    SHORT sDexterity = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            sDexterity = pC7Sub->sDexterity;
        }
    }
    return sDexterity;
}

SHORT CC7Section::GetPhysReg() const
{
    SHORT sPhysReg = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            sPhysReg = pC7Sub->sPhysReg;
        }
    }
    return sPhysReg;
}

SHORT CC7Section::GetMentReg() const
{
    SHORT sMentReg = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            sMentReg = pC7Sub->sMentReg;
        }
    }
    return sMentReg;
}

SHORT CC7Section::GetCharisma() const
{
    SHORT sCharisma = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            sCharisma = pC7Sub->sCharisma;
        }
    }
    return sCharisma;
}

BYTE CC7Section::GetFreeAttributePoints() const
{
    BYTE bFreeAttributePoints = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            bFreeAttributePoints = pC7Sub->bFreeAttributePoints;
        }
    }
    return bFreeAttributePoints;
}

WORD CC7Section::GetFreeSkillPoints() const
{
    WORD wFreeSkillPoints = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            wFreeSkillPoints = pC7Sub->wFreeSkillPoints;
        }
    }
    return wFreeSkillPoints;
}

UINT CC7Section::GetGold() const
{
    UINT uiGold = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            uiGold = pC7Sub->uiGold;
        }
    }
    return uiGold;
}

UINT CC7Section::GetLevel() const
{
    UINT uiLevel = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            uiLevel = pC7Sub->uiLevel;
        }
    }
    return uiLevel;
}


void CC7Section::GetSkill( SkillNumber skillNumber, SkillType & skillType, BYTE & bLevel, BYTE & bBonus ) const
{
    skillType = ST_NichtAusgewaehlt;
    bLevel = 0;
    bBonus = 0;

    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            switch (skillNumber)
            {
                case S_Skill1:
                case S_Skill2:
                case S_Skill3:
                case S_Skill4:
                case S_Skill5:
                case S_Skill6:
                case S_Skill7:
                case S_Skill8:
                {
                    skillType = (SkillType)pC7Sub->aSkillType[skillNumber];
                    bLevel = pC7Sub->aSkillLevel[skillNumber];
                    bBonus = pC7Sub->aSkillBonus[skillNumber];
                    break;
                }
                default: break;
            }
        }
    }
}

UINT CC7Section::GetCombatArtCount() const
{
    UINT uiCount = 0;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            uiCount = (UINT)pC7Sub->bCountKK;
        }
    }
    return uiCount;
}

bool CC7Section::GetCombatArt( UINT uiCombatArt, CombatArt & combatArt, BYTE & bLevel, BYTE & bBonus ) const
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if (pC7Sub != NULL)
        {
            if (uiCombatArt < (UINT)pC7Sub->bCountKK)
            {
                combatArt = (CombatArt)pC7Sub->kkEntries[uiCombatArt].usType;
                bLevel = pC7Sub->kkEntries[uiCombatArt].bLevel;
                bBonus = pC7Sub->kkEntries[uiCombatArt].bBonus;
                bRet = true;
            }
        }
    }
    return bRet;
}


//////////////////////////////////////////////////////////////////////
// Set-Methoden
//////////////////////////////////////////////////////////////////////

bool CC7Section::SetCharType( CharType charType )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7 pC7 = this->m_pSHF->GetC7Struct();
        if ((pC7Section != NULL) && (pC7 != NULL))
        {
            switch (charType)
            {
                case CT_Seraphim:
                case CT_Gladiator:
                case CT_Mage:
                case CT_Darkelf:
                case CT_Woodelf:
                case CT_Vampire:
                case CT_Vampire2:
                case CT_Dwarf:
                case CT_Daemon:
                {
                    UINT uiType =(UINT)charType;
                    CPaxSection::SetValue( pC7->uiType, uiType, *pC7Section );
                    bRet = true;
                    break;
                }
                default: break;
            }
        }
    }
    return bRet;
}

bool CC7Section::SetCharTypeSub( CharType charType )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            switch (charType)
            {
                case CT_Seraphim:
                case CT_Gladiator:
                case CT_Mage:
                case CT_Darkelf:
                case CT_Woodelf:
                case CT_Vampire:
                case CT_Vampire2:
                case CT_Dwarf:
                case CT_Daemon:
                {
                    UINT uiType = (UINT)charType;
                    CPaxSection::SetValue( pC7Sub->uiType, uiType, *pC7Section );
                    break;
                }
                default: break;
            }
        }
    }
    return bRet;
}

bool CC7Section::SetCheated( bool bCheated )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7 pC7 = this->m_pSHF->GetC7Struct();
        if ((pC7Section != NULL) && (pC7 != NULL))
        {
            WORD wCheatFlag = pC7->wCheatFlag;
            if (bCheated)
            {
                wCheatFlag = 0xFFFF;
            }
            else
            {
                wCheatFlag = 0;
            }

            CPaxSection::SetValue( pC7->wCheatFlag, wCheatFlag, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetPortalActivated( Portal portal, bool bActivated )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            switch (portal)
            {
                case P_CL_Schoenblick:   // Schnblick
                case P_CL_PortoVallum:   // Porto Vallum
                case P_CL_Eisbachpass:   // Eisbachpass
                case P_CL_EbeneUrkuk:    // Ebene von Urkuk
                case P_CL_Biberingen:    // Biberingen
                case P_CL_Mascarell:     // Mascarell
                case P_CL_KhoradNur:     // Khorad-Nur
                case P_CL_Hohenmut:      // Burg Hohenmut
                case P_CL_Klosterfeste:  // Klosterfeste der Seraphim
                case P_CL_Heckenheim:    // Heckenheim
                case P_CL_ZhuragNar:     // Tal von Zhurag-Nar
                case P_CL_Sternental:    // Burg Sternental
                case P_CL_ShaddarNur:    // Shaddar-Nur
                case P_UW_Zwergenruinen: // Zwergenruinen
                case P_UW_Purgatori:     // Purgatori
                case P_UW_NukNukWald:    // Nuk-Nuk Wald
                case P_UW_PiratenInseln: // Piraten Inseln
                case P_UW_Dryadenwald:   // Dryaden-Wald
                case P_UW_GratDerHoelle: // Grat der Hlle
                case P_UW_TalDerTraenen: // Tal der Trnen
                {
                    UINT uiPortals = pC7Sub->uiPortals;
                    if (bActivated)
                    {
                        uiPortals |= portal;
                    }   
                    else
                    {
                        uiPortals &= ~portal;
                    }
                    CPaxSection::SetValue( pC7Sub->uiPortals, uiPortals, *pC7Section );
                    bRet = true;
                    break;
                }
                default: break;
            }
        }
    }
    return bRet;
}

bool CC7Section::SetExp( UINT uiExp )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->uiExp, uiExp, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetStrength( SHORT sStrength )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->sStrength, sStrength, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetRefractiveness( SHORT sRefractiveness )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->sRefractiveness, sRefractiveness, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetDexterity( SHORT sDexterity )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->sDexterity, sDexterity, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetPhysReg( SHORT sPhysReg )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->sPhysReg, sPhysReg, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetMentReg( SHORT sMentReg )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->sMentReg, sMentReg, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetCharisma( SHORT sCharisma )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->sCharisma, sCharisma, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetFreeAttributePoints( BYTE bFreeAttributePoints )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->bFreeAttributePoints, bFreeAttributePoints, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetFreeSkillPoints( WORD wFreeSkillPoints )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->wFreeSkillPoints, wFreeSkillPoints, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetGold( UINT uiGold )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->uiGold, uiGold, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetLevel( UINT uiLevel )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            CPaxSection::SetValue( pC7Sub->uiLevel, uiLevel, *pC7Section );
            bRet = true;
        }
    }
    return bRet;
}

bool CC7Section::SetSkill( SkillNumber skillNumber, SkillType skillType, BYTE bLevel, BYTE bBonus )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            switch (skillNumber)
            {
                case S_Skill1:
                case S_Skill2:
                case S_Skill3:
                case S_Skill4:
                case S_Skill5:
                case S_Skill6:
                case S_Skill7:
                case S_Skill8:
                {
                    BYTE bSkillType = (BYTE)skillType;
                    CPaxSection::SetValue( pC7Sub->aSkillType[skillNumber], bSkillType, *pC7Section );
                    CPaxSection::SetValue( pC7Sub->aSkillLevel[skillNumber], bLevel, *pC7Section );
                    CPaxSection::SetValue( pC7Sub->aSkillBonus[skillNumber], bBonus, *pC7Section );
                    bRet = true;
                    break;
                }
                default: break;
            }
        }
    }
    return bRet;
}

bool CC7Section::SetCombatArt( UINT uiCombatArt, CombatArt combatArt, BYTE bLevel, BYTE bBonus )
{
    bool bRet = false;
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            if (uiCombatArt < (UINT)pC7Sub->bCountKK)
            {
                pC7Sub->kkEntries[uiCombatArt].usType = (USHORT)combatArt;
                pC7Sub->kkEntries[uiCombatArt].bLevel = bLevel;
                pC7Sub->kkEntries[uiCombatArt].bBonus = bBonus;
                pC7Section->SetChanged();
                bRet = true;
            }
        }
    }
    return bRet;
}

void CC7Section::UpdateUnusedSkillCount()
{
    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC7Section = this->m_pSHF->GetC7Section();
        LPSECTIONC7SUB pC7Sub = this->m_pSHF->GetC7SubStruct();
        if ((pC7Section != NULL) && (pC7Sub != NULL))
        {
            WORD w, wUnusedSkillCount = 0, wSkillCount = 2, wAdditionalFreeSkillPoints = 0;

            // weitere Skills gibt es bei den Stufen 3, 6, 12, 20, 30, 50
            if (pC7Sub->uiLevel >= 50) wSkillCount = 8;
            else if (pC7Sub->uiLevel >= 30) wSkillCount = 7;
            else if (pC7Sub->uiLevel >= 20) wSkillCount = 6;
            else if (pC7Sub->uiLevel >= 12) wSkillCount = 5;
            else if (pC7Sub->uiLevel >= 6) wSkillCount = 4;
            else if (pC7Sub->uiLevel >= 3) wSkillCount = 3;

            wUnusedSkillCount = wSkillCount;

            // Verwendete Skills "zhlen"
            for (w = 0; (w < wSkillCount) && (pC7Sub->aSkillType[w] != (BYTE)ST_NichtAusgewaehlt); ++w)
            {
                --wUnusedSkillCount;
            }

            // Alle anderen sind nicht verwendet, wenn doch, dann werden sie gelscht
            // dafr schon vergebene Skillpunkte knnen neu vergeben werden
            for (; w < MAX_SKILL_COUNT; ++w)
            {
                if (pC7Sub->aSkillType[w] != (BYTE)ST_NichtAusgewaehlt)
                {
                    if (pC7Sub->aSkillLevel[w] > 1)
                    {
                        wAdditionalFreeSkillPoints += pC7Sub->aSkillLevel[w] - 1;
                    }
                    pC7Sub->aSkillType[w] = (BYTE)ST_NichtAusgewaehlt;
                    pC7Sub->aSkillLevel[w] = 0;
                    pC7Sub->aSkillBonus[w] = 0;
                    pC7Section->SetChanged();
                }
            }

            if (wAdditionalFreeSkillPoints > 0)
            {
                pC7Sub->wFreeSkillPoints += wAdditionalFreeSkillPoints;
                pC7Section->SetChanged();
            }

            if (wUnusedSkillCount != pC7Sub->wUnusedSkillCount)
            {
                pC7Sub->wUnusedSkillCount = wUnusedSkillCount;
                pC7Section->SetChanged();
            }
        }
    }
}
