// C7Section.h: Schnittstelle fr die Klasse CC7Section.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_C7SECTION_H__9605D0C7_2A76_4298_8B1A_F6699A7D7040__INCLUDED_)
#define AFX_C7SECTION_H__9605D0C7_2A76_4298_8B1A_F6699A7D7040__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "SacredHeroFileEx.h"


class CC7Section  
{
private:
    CSacredHeroFileEx* m_pSHF;

public:
	CC7Section();
	virtual ~CC7Section();

    bool SetHeroFile( CSacredHeroFileEx* pSHF );
    bool IsInitialized() { return this->m_pSHF != NULL; }

    CharType GetCharType        () const;
    CharType GetCharTypeSub     () const;
    bool IsCheated              () const;
    bool IsPortalActivated      ( Portal portal ) const;
    UINT GetExp                 () const;
    SHORT GetStrength           () const;
    SHORT GetRefractiveness     () const;
    SHORT GetDexterity          () const;
    SHORT GetPhysReg            () const;
    SHORT GetMentReg            () const;
    SHORT GetCharisma           () const;
    BYTE GetFreeAttributePoints () const;
    WORD GetFreeSkillPoints     () const;
    UINT GetGold                () const;
    UINT GetLevel               () const;

    void GetSkill( SkillNumber skillNumber, SkillType & skillType, BYTE & bLevel, BYTE & bBonus ) const;

    UINT GetCombatArtCount() const;
    bool GetCombatArt( UINT uiCombatArt, CombatArt & combatArt, BYTE & bLevel, BYTE & bBonus ) const;

    bool SetCharType            ( CharType charType                 );
    bool SetCharTypeSub         ( CharType charType                 );
    bool SetCheated             ( bool bCheated                     );
    bool SetPortalActivated     ( Portal portal, bool bActivated    );
    bool SetExp                 ( UINT uiExp                        );
    bool SetStrength            ( SHORT sStrength                   );
    bool SetRefractiveness      ( SHORT sRefractiveness             );
    bool SetDexterity           ( SHORT sDexterity                  );
    bool SetPhysReg             ( SHORT sPhysReg                    );
    bool SetMentReg             ( SHORT sMentReg                    );
    bool SetCharisma            ( SHORT sCharisma                   );
    bool SetFreeAttributePoints ( BYTE bFreeAttributePoints         );
    bool SetFreeSkillPoints     ( WORD wFreeSkillPoints             );
    bool SetGold                ( UINT uiGold                       );
    bool SetLevel               ( UINT uiLevel                      );

    bool SetSkill( SkillNumber skillNumber, SkillType skillType, BYTE bLevel, BYTE bBonus );

    bool SetCombatArt( UINT uiCombatArt, CombatArt combatArt, BYTE bLevel, BYTE bBonus );

    void UpdateUnusedSkillCount();
};

#endif // !defined(AFX_C7SECTION_H__9605D0C7_2A76_4298_8B1A_F6699A7D7040__INCLUDED_)
