// C8Dlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "C8Dlg.h"
#include "paxhelper.h"
#include "ItemDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define INI_SECTION_NAME    "Items"
#define INI_FILENAME        "items.ini"

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CC8Dlg 


CC8Dlg::CC8Dlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CC8Dlg::IDD, rEventDispatcher)
{
    this->m_IniFileName = _pgmptr;
    int iBackslash = this->m_IniFileName.ReverseFind( '\\' );
    if (iBackslash >= 0)
    {
        this->m_IniFileName = this->m_IniFileName.Left( iBackslash );
    }
    CHelper::AppendBackslash( this->m_IniFileName );
    this->m_IniFileName += INI_FILENAME;
    TRACE ("ItemIniFileName = %s\n", (LPCTSTR)this->m_IniFileName );
	//{{AFX_DATA_INIT(CC8Dlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CC8Dlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CC8Dlg)
	DDX_Control(pDX, IDC_LIST_ITEMS, m_ListItems);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CC8Dlg, CModelessDlg)
	//{{AFX_MSG_MAP(CC8Dlg)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_ITEMS, OnDblclkListItems)
	ON_NOTIFY(HDN_ITEMCLICKA, 0, OnItemclickListItems)
	ON_NOTIFY(HDN_ITEMCLICKW, 0, OnItemclickListItems)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CC8Dlg::Refresh()
{
    this->m_ListItems.DeleteAllItems();

    if (this->m_pSHF != NULL)
    {
        CItemList & rItemList = this->m_pSHF->GetItemList();

        UINT ui, uiCount = rItemList.GetItemCount();
        for (ui = 0; ui < uiCount; ++ui)
        {
            CItem* pItem = rItemList.GetItem( ui );
            if ((pItem != NULL) && !pItem->IsHorse())
            {
                int iIndex = this->m_ListItems.InsertItem( this->m_ListItems.GetItemCount(), "" );
                if (iIndex >= 0)
                {
                    CString strItemName;
					this->GetItemName( pItem->GetItemID1(),  pItem->GetItemID(), strItemName );

                    CString strItemClass = CPaxHelper::GetItemClassString( pItem->GetItemClass() );
                    CString strType;
                    strType.Format( "%u (%X)", pItem->GetColor(), pItem->GetColor() );

                    this->m_ListItems.SetItemData( iIndex, (DWORD)pItem );
                    this->m_ListItems.SetItemText( iIndex, 0, (LPCTSTR)CHelper::UIntToString( pItem->GetItemID() ) );
                    if (pItem->GetItemID() != pItem->GetItemID1())
                    {
                        this->m_ListItems.SetItemText( iIndex, 1, (LPCTSTR)CHelper::UIntToString( pItem->GetItemID1() ) );
                    }
                    this->m_ListItems.SetItemText( iIndex, 2, (LPCTSTR)strItemName );
                    this->m_ListItems.SetItemText( iIndex, 3, (LPCTSTR)strItemClass );
                    this->m_ListItems.SetItemText( iIndex, 4, (LPCTSTR)strType );
                    this->m_ListItems.SetItemText( iIndex, 5, (LPCTSTR)CHelper::UIntToString( pItem->GetLevel() ) );
                    this->m_ListItems.SetItemText( iIndex, 6, (LPCTSTR)CPaxHelper::GetSeverityString( pItem->GetSeverity() ) );
                    this->m_ListItems.SetItemText( iIndex, 7, (LPCTSTR)CPaxHelper::GetCharClassString( pItem->GetCharClass() ) );
                    this->m_ListItems.SetItemText( iIndex, 8, (LPCTSTR)CPaxHelper::GetItemPositionString( pItem->GetPosition() ) );

                    if (pItem->GetUnknown() != 0)
                    {
                        TRACE( "Unbekannter Wert gesetzt: Item-ID = %u  Name = %s\n", pItem->GetItemID(), (LPCTSTR)strItemName );
                    }
                }
            }
        }
    }
}

void CC8Dlg::Save()
{
}

void CC8Dlg::GetItemName(UINT uiItemId1, UINT uiItemId, CString & strItemName)
{
    if (this->m_SortParameter.mapItemNames.Lookup( uiItemId1, strItemName ))
    {
		return;
	}
	if (this->LoadItemName(uiItemId1, strItemName))
	{
		return;
	}
    if (this->m_SortParameter.mapItemNames.Lookup( uiItemId, strItemName ))
	{
		return;
	}
	if (this->LoadItemName(uiItemId, strItemName))
	{
		return;
	}
    TRACE( "ItemID %u und %u wurden nicht in Liste gefunden\n", uiItemId1, uiItemId);
	strItemName = "?";
}

BOOL CC8Dlg::LoadItemName(UINT uiItemId, CString & strItemName)
{
	// TODO: Itemnamen aus Global.res laden???
    CString strKey;
    strKey.Format( "%u", uiItemId );
    ::GetPrivateProfileString( INI_SECTION_NAME, (LPCTSTR)strKey, "", strItemName.GetBuffer( 1024), 1024, (LPCTSTR)this->m_IniFileName );
    strItemName.ReleaseBuffer();

    strItemName.TrimLeft();
    strItemName.TrimRight();

	BOOL ret = strItemName.GetLength();
	if (ret)
    {
        this->m_SortParameter.mapItemNames.SetAt( uiItemId, strItemName );
    }
	return ret;
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CC8Dlg 

BOOL CC8Dlg::OnInitDialog() 
{
	CModelessDlg::OnInitDialog();

    this->m_ListItems.SetExtendedStyle( this->m_ListItems.GetExtendedStyle() | LVS_EX_FULLROWSELECT );
    this->m_ListItems.InsertColumn( 0, "ID1", LVCFMT_LEFT, 36 );
    this->m_ListItems.InsertColumn( 1, "ID2", LVCFMT_LEFT, 36 );
    this->m_ListItems.InsertColumn( 2, "Name", LVCFMT_LEFT, 100 );
    this->m_ListItems.InsertColumn( 3, "Klasse", LVCFMT_LEFT, 80 );
    this->m_ListItems.InsertColumn( 4, "Typ", LVCFMT_LEFT, 40 );
    this->m_ListItems.InsertColumn( 5, "Level", LVCFMT_LEFT, 40 );
    this->m_ListItems.InsertColumn( 6, "Grad", LVCFMT_LEFT, 45 );
    this->m_ListItems.InsertColumn( 7, "Char-Klasse", LVCFMT_LEFT, 70 );
    this->m_ListItems.InsertColumn( 8, "Position", LVCFMT_LEFT, 80 );

    this->m_SortParameter.bReverse = false;
    this->m_SortParameter.iSortColumn = -1;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CC8Dlg::OnDblclkListItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
    UNUSED_ALWAYS( pNMHDR );

    POSITION pos = this->m_ListItems.GetFirstSelectedItemPosition();
    if (NULL != pos)
    {
        int iIndex = this->m_ListItems.GetNextSelectedItem( pos );
        CItem* pItem = (CItem*)this->m_ListItems.GetItemData( iIndex );
        if (NULL != pItem)
        {
            // Dialog zur nderung des Items ffnen
            CItemDlg dlg( this->m_rEventDispatcher, *pItem, this );
            dlg.DoModal();
        }
    }
	
	*pResult = 0;
}

/*virtual*/ UINT CC8Dlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;

    switch (uiID)
    {
        case IDC_LIST_ITEMS: uiRet = SIZE_X | SIZE_Y; break;
		case IDC_HINT: uiRet = MOVE_Y | SIZE_X; break;
        default: TRACE("CC8Dlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }

    return uiRet;
}

void CC8Dlg::OnItemclickListItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
	HD_NOTIFY *phdn = (HD_NOTIFY *) pNMHDR;
    if ((NULL != phdn) &&  (0 == phdn->iButton))
    {
        if (phdn->iItem == this->m_SortParameter.iSortColumn)
        {
            this->m_SortParameter.bReverse = !this->m_SortParameter.bReverse;
        }
        else
        {
            this->m_SortParameter.iSortColumn = phdn->iItem;
            this->m_SortParameter.bReverse = false;
        }

        CWaitCursor wait();
        this->m_ListItems.SortItems( CC8Dlg::CompareFunc, (LPARAM)(&this->m_SortParameter) );
    }

	*pResult = 0;
}

/*static*/ int CALLBACK CC8Dlg::CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
    int iRet = 0;
    CItem* pItem1 = (CItem*)lParam1;
    CItem* pItem2 = (CItem*)lParam2;
    LPSORTPARAMETER pSortParameter = (LPSORTPARAMETER)lParamSort;

    if (NULL == pItem1)
    {
        if (NULL != pItem2)
        {
            iRet = 1;
        }
    }
    else if (NULL == pItem2)
    {
        iRet = -1;
    }
    else if (NULL != pSortParameter)
    {
        switch (pSortParameter->iSortColumn)
        {
            case 8: iRet = stricmp( (LPCTSTR)CPaxHelper::GetItemPositionString( pItem1->GetPosition() ), (LPCTSTR)CPaxHelper::GetItemPositionString( pItem2->GetPosition() ) ); break;
            case 7: iRet = stricmp( (LPCTSTR)CPaxHelper::GetCharClassString( pItem1->GetCharClass() ), (LPCTSTR)CPaxHelper::GetCharClassString( pItem2->GetCharClass() ) ); break;
            case 6: iRet = (int)(pItem1->GetSeverity()) - (int)(pItem2->GetSeverity()); break;
            case 5: iRet = (int)(pItem1->GetLevel()) - (int)(pItem2->GetLevel()); break;
            case 4: iRet = (int)(pItem1->GetColor()) - (int)(pItem2->GetColor()); break;
            case 3: iRet = stricmp( (LPCTSTR)CPaxHelper::GetItemClassString( pItem1->GetItemClass() ), (LPCTSTR)CPaxHelper::GetItemClassString( pItem2->GetItemClass() ) ); break;
            case 2:
            {
                CString strItemName1, strItemName2;
                if (!pSortParameter->mapItemNames.Lookup( pItem1->GetItemID1(), strItemName1 ))
                {
                    pSortParameter->mapItemNames.Lookup( pItem1->GetItemID(), strItemName1 );
                }
                if (!pSortParameter->mapItemNames.Lookup( pItem2->GetItemID1(), strItemName2 ))
                {
                    pSortParameter->mapItemNames.Lookup( pItem2->GetItemID(), strItemName2 );
                }

                iRet = stricmp( (LPCTSTR)strItemName1, (LPCTSTR)strItemName2 );

                break;
            }
            case 1: iRet = (int)(pItem1->GetItemID1()) - (int)(pItem2->GetItemID1()); break;
            case 0: iRet = (int)(pItem1->GetItemID()) - (int)(pItem2->GetItemID()); break;
            default: break;
        }

        if (pSortParameter->bReverse)
        {
            iRet *= -1;
        }
    }

    return iRet;
}
