// C8Section.cpp: Implementierung der Klasse CC8Section.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "C8Section.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CC8Section::CC8Section()
{
    this->m_pSHF = NULL;
}

CC8Section::~CC8Section()
{
}

bool CC8Section::SetHeroFile( CSacredHeroFileEx* pSHF )
{
    bool bRet = false;
    if (pSHF != NULL)
    {
        CPaxSection* pC8Section = pSHF->GetC8Section();
        if (pC8Section != NULL)
        {
            this->m_pSHF = pSHF;
            bRet = true;
        }
    }
    return bRet;
}

POSITION CC8Section::GetFirstItemPosition()
{
    POSITION pos = NULL;

    if (this->m_pSHF != NULL)
    {
        CPaxSection* pC8Section = this->m_pSHF->GetC8Section();
        if (pC8Section != NULL)
        {
            pos = (POSITION)CC8Section::FindNextOffset( *pC8Section, 4 );
        }
    }

    return pos;
}

CItem* CC8Section::GetNextItemPosition( POSITION & rPosition )
{
    CItem* pItem = NULL;

    if ((rPosition != NULL) && (this->m_pSHF != NULL))
    {
        CPaxSection* pC8Section = this->m_pSHF->GetC8Section();
        if (pC8Section != NULL)
        {
            POSITION posCurr = (POSITION)CC8Section::FindNextOffset( *pC8Section, (UINT)rPosition );
            if (posCurr != rPosition)
            {
                rPosition = NULL;
            }
            else
            {
                UINT uiOffset = (UINT)rPosition;
                pItem = new CItem( *pC8Section, uiOffset );
                rPosition = (POSITION)CC8Section::FindNextOffset( *pC8Section, uiOffset );
            }
        }
    }

    return pItem;
}

/*static*/ UINT CC8Section::FindNextOffset( CPaxSection & rC8Section, UINT uiStartOffset )
{
    // die nchsten Bytes testen
    UINT* pNext = (UINT*)(rC8Section.GetData() + uiStartOffset);
    if (*pNext == SACREDITEM_BADSIG)
    {
        // 5 * 4 Bytes = 5 UINT-Werte
        uiStartOffset += 20;
        pNext += 5;
    }

    while ((rC8Section.GetLength() >= (uiStartOffset + sizeof( SACREDITEM1 ))) && (*pNext == 0))
    {
        uiStartOffset += 4;
        ++pNext;
    }

    if (rC8Section.GetLength() >= (uiStartOffset + sizeof( SACREDITEM1 )))
    {
        LPSACREDITEM1 pItem1 = (LPSACREDITEM1)(rC8Section.GetData() + uiStartOffset);
        if (pItem1->uiStartSig == SACREDITEM_STARTSIG)
        {
            return uiStartOffset;
        }
    }

    // Kein weiteres Item gefunden
    return 0;
}
