// CASection.cpp: Implementierung der Klasse CCASection.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CASection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CCASection::CCASection()
{
    this->m_pSHF = NULL;
}

CCASection::~CCASection()
{
}

bool CCASection::SetHeroFile( CSacredHeroFileEx* pSHF )
{
    bool bRet = false;
    if (pSHF != NULL)
    {
        LPSECTIONCA pCA = pSHF->GetCAStruct();
        if (pCA != NULL)
        {
            this->m_pSHF = pSHF;
            bRet = true;
        }
    }
    return bRet;
}

bool CCASection::FillItemPositionMap( CItemPositionMap & rIPM ) const
{
    bool bRet = false;

    if (this->m_pSHF != NULL)
    {
        const LPSECTIONCA pCA = this->m_pSHF->GetCAStruct();
        if (pCA != NULL)
        {
            UINT ui, uiCount = COUNTOF(pCA->aInventory);

            for (ui = 0; ui < uiCount; ++ui)
            {
                if (pCA->aInventory[ui].uiItemSig > 1)
                {
                    rIPM.SetAt( pCA->aInventory[ui].uiItemSig, IP_Inventory );
                }
            }

            const ItemPosition aPositions[10] =
            {
                IP_Slot1,
                IP_Slot1,
                IP_Slot2,
                IP_Slot2,
                IP_Slot3,
                IP_Slot3,
                IP_Slot4,
                IP_Slot4,
                IP_Slot5,
                IP_Slot5,
            };

            // Waffenslots durchsuchen
            for (int i = 0; i < 10; ++i)
            {
                if (pCA->aWeaponSlots[i].uiItemSig > 1)
                {
                    rIPM.SetAt( pCA->aWeaponSlots[i].uiItemSig, aPositions[i] );
                }
            }

            bRet = true;
        }
    }

    return bRet;
}

ItemPosition CCASection::GetActiveSlot() const
{
    ItemPosition pos = IP_Unknown;

    if (this->m_pSHF != NULL)
    {
        const LPSECTIONCA pCA = this->m_pSHF->GetCAStruct();
        if (pCA != NULL)
        {
            switch (pCA->bActiveSlot)
            {
                case 0: pos = IP_Slot1; break;
                case 1: pos = IP_Slot2; break;
                case 2: pos = IP_Slot3; break;
                case 3: pos = IP_Slot4; break;
                case 4: pos = IP_Slot5; break;
                default: break;
            }
        }
    }

    return pos;
}

bool CCASection::SetActiveSlot( ItemPosition itemPosition )
{
    bool bRet = false;

    if (this->m_pSHF != NULL)
    {
        CPaxSection* pCASection = this->m_pSHF->GetCASection();
        LPSECTIONCA pCA = this->m_pSHF->GetCAStruct();
        if ((pCASection != NULL) && (pCA != NULL))
        {
            switch (itemPosition)
            {
                case IP_Slot1:
                case IP_Slot2:
                case IP_Slot3:
                case IP_Slot4:
                case IP_Slot5:
                {
                    BYTE bSlot = (BYTE)(itemPosition - IP_Slot1);
                    CPaxSection::SetValue( pCA->bActiveSlot, bSlot, *pCASection );
                    break;
                }
                default:
                {
                    bRet = false;
                    break;
                }
            }
        }
    }

    return bRet;
}
