// CBSection.cpp: Implementierung der Klasse CCBSection.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CBSection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CCBSection::CCBSection()
{
    this->m_pSHF = NULL;
}

CCBSection::~CCBSection()
{
}

bool CCBSection::SetHeroFile( CSacredHeroFileEx* pSHF )
{
    bool bRet = false;
    if (pSHF != NULL)
    {
        LPSECTIONCB pCB = pSHF->GetCBStruct();
        if (pCB != NULL)
        {
            this->m_pSHF = pSHF;
            bRet = true;
        }
    }
    return bRet;
}

bool CCBSection::FillItemPositionMap( CItemPositionMap & rIPM ) const
{
    bool bRet = false;

    if (this->m_pSHF != NULL)
    {
        const LPSECTIONCB pCB = this->m_pSHF->GetCBStruct();
        if (pCB != NULL)
        {
            UINT ui, uiCount = COUNTOF(pCB->aChest);

            for (ui = 0; ui < uiCount; ++ui)
            {
                if (pCB->aChest[ui].uiItemSig > 1)
                {
                    rIPM.SetAt( pCB->aChest[ui].uiItemSig, IP_Chest );
                }
            }

            bRet = true;
        }
    }

    return bRet;
}
