// CDDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "CDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CCDDlg 


CCDDlg::CCDDlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CCDDlg::IDD, rEventDispatcher)
{
	//{{AFX_DATA_INIT(CCDDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
	this->m_CtrlArray.Add( this->m_ButtonShow );
	this->m_CtrlArray.Add( this->m_ButtonHide );
	this->m_CtrlArray.Add( this->m_CheckWoodElf );
	this->m_CtrlArray.Add( this->m_CheckVamp );
	this->m_CtrlArray.Add( this->m_CheckSera );
	this->m_CtrlArray.Add( this->m_CheckMage );
	this->m_CtrlArray.Add( this->m_CheckIsland );
	this->m_CtrlArray.Add( this->m_CheckGladi );
	this->m_CtrlArray.Add( this->m_CheckDwarf );
	this->m_CtrlArray.Add( this->m_CheckDeamon );
	this->m_CtrlArray.Add( this->m_CheckDarkelf );
}


void CCDDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDDlg)
	DDX_Control(pDX, IDC_EDIT_VISIBLE, m_EditVisible);
	DDX_Control(pDX, IDC_EDIT_EXPLORED, m_EditExplored);
	DDX_Control(pDX, IDC_SHOW, m_ButtonShow);
	DDX_Control(pDX, IDC_HIDE, m_ButtonHide);
	DDX_Control(pDX, IDC_CHECK_WOODELF, m_CheckWoodElf);
	DDX_Control(pDX, IDC_CHECK_VAMPYRE, m_CheckVamp);
	DDX_Control(pDX, IDC_CHECK_SERAPHIM, m_CheckSera);
	DDX_Control(pDX, IDC_CHECK_MAGICIAN, m_CheckMage);
	DDX_Control(pDX, IDC_CHECK_ISLAND, m_CheckIsland);
	DDX_Control(pDX, IDC_CHECK_GLADIATOR, m_CheckGladi);
	DDX_Control(pDX, IDC_CHECK_DWARF, m_CheckDwarf);
	DDX_Control(pDX, IDC_CHECK_DEAMON, m_CheckDeamon);
	DDX_Control(pDX, IDC_CHECK_DARKELF, m_CheckDarkelf);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCDDlg, CModelessDlg)
	//{{AFX_MSG_MAP(CCDDlg)
	ON_BN_CLICKED(IDC_HIDE, OnHide)
	ON_BN_CLICKED(IDC_SHOW, OnShow)
	ON_BN_CLICKED(IDC_CHECK_ISLAND, OnCheckIsland)
	ON_BN_CLICKED(IDC_CHECK_SERAPHIM, OnCheckSeraphim)
	ON_BN_CLICKED(IDC_CHECK_GLADIATOR, OnCheckGladiator)
	ON_BN_CLICKED(IDC_CHECK_MAGICIAN, OnCheckMagician)
	ON_BN_CLICKED(IDC_CHECK_DARKELF, OnCheckDarkelf)
	ON_BN_CLICKED(IDC_CHECK_WOODELF, OnCheckWoodelf)
	ON_BN_CLICKED(IDC_CHECK_VAMPYRE, OnCheckVampyre)
	ON_BN_CLICKED(IDC_CHECK_DWARF, OnCheckDwarf)
	ON_BN_CLICKED(IDC_CHECK_DEAMON, OnCheckDeamon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CCDDlg::Refresh()
{
    bool bOK = this->m_CDSection.SetHeroFile( this->m_pSHF );
    this->m_CtrlArray.EnableWindow( bOK );
	this->RefreshInternal( bOK );
}

void CCDDlg::RefreshInternal(bool bOK)
{
    if (bOK)
    {
        this->m_CheckWoodElf.SetCheck   ( this->m_CDSection.IsExplored( R_Woodelf   ) );
	    this->m_CheckVamp.SetCheck      ( this->m_CDSection.IsExplored( R_Vampyre   ) );
	    this->m_CheckSera.SetCheck      ( this->m_CDSection.IsExplored( R_Seraphim  ) );
	    this->m_CheckMage.SetCheck      ( this->m_CDSection.IsExplored( R_Magician  ) );
	    this->m_CheckIsland.SetCheck    ( this->m_CDSection.IsExplored( R_Island    ) );
	    this->m_CheckGladi.SetCheck     ( this->m_CDSection.IsExplored( R_Gladiator ) );
	    this->m_CheckDwarf.SetCheck     ( this->m_CDSection.IsExplored( R_Dwarf     ) );
	    this->m_CheckDeamon.SetCheck    ( this->m_CDSection.IsExplored( R_Deamon    ) );
	    this->m_CheckDarkelf.SetCheck   ( this->m_CDSection.IsExplored( R_Darkelf   ) );

        this->m_EditExplored.SetWindowText( (LPCTSTR)this->m_CDSection.GetExplored() );
	    this->m_EditVisible.SetWindowText( (LPCTSTR)this->m_CDSection.GetVisible() );
    }
    else
    {
	    this->m_EditVisible.SetWindowText( "" );
	    this->m_EditExplored.SetWindowText( "" );

	    this->m_CheckWoodElf.SetCheck( 0 );
	    this->m_CheckVamp.SetCheck( 0 );
	    this->m_CheckSera.SetCheck( 0 );
	    this->m_CheckMage.SetCheck( 0 );
	    this->m_CheckIsland.SetCheck( 0 );
	    this->m_CheckGladi.SetCheck( 0 );
	    this->m_CheckDwarf.SetCheck( 0 );
	    this->m_CheckDeamon.SetCheck( 0 );
	    this->m_CheckDarkelf.SetCheck( 0 );
    }
}

void CCDDlg::Save()
{
//*
	this->m_CDSection.Save();
//*/
}

void CCDDlg::HandleCheck( CButton & rCheckBox, Region region )
{
    if (rCheckBox.GetCheck() != 0)
    {
        this->m_CDSection.HideRegion( region );
    }
    else
    {
        this->m_CDSection.ShowRegion( region );
    }
    this->RefreshInternal(true);
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CCDDlg 

void CCDDlg::OnHide() 
{
    this->m_CDSection.HideRegion( R_All );
    this->RefreshInternal(true);
}

void CCDDlg::OnShow() 
{
    this->m_CDSection.ShowRegion( R_All );
    this->RefreshInternal(true);
}

void CCDDlg::OnCheckIsland() 
{
    this->HandleCheck( this->m_CheckIsland, R_Island );
}

void CCDDlg::OnCheckSeraphim() 
{
    this->HandleCheck( this->m_CheckSera, R_Seraphim );
}

void CCDDlg::OnCheckGladiator() 
{
    this->HandleCheck( this->m_CheckGladi, R_Gladiator );
}

void CCDDlg::OnCheckMagician() 
{
    this->HandleCheck( this->m_CheckMage, R_Magician );
}

void CCDDlg::OnCheckDarkelf() 
{
    this->HandleCheck( this->m_CheckDarkelf, R_Darkelf );
}

void CCDDlg::OnCheckWoodelf() 
{
    this->HandleCheck( this->m_CheckWoodElf, R_Woodelf );
}

void CCDDlg::OnCheckVampyre() 
{
    this->HandleCheck( this->m_CheckVamp, R_Vampyre );
}

void CCDDlg::OnCheckDwarf() 
{
    this->HandleCheck( this->m_CheckDwarf, R_Dwarf );
}

void CCDDlg::OnCheckDeamon() 
{
    this->HandleCheck( this->m_CheckDeamon, R_Deamon );
}

/*virtual*/ UINT CCDDlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
*/
    return uiRet;
}
