// CDSection.h: Schnittstelle fr die Klasse CCDSection.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CDSECTION_H__62EFF0C0_424D_4298_B5DD_45593EC7E234__INCLUDED_)
#define AFX_CDSECTION_H__62EFF0C0_424D_4298_B5DD_45593EC7E234__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "SacredHeroFileEx.h"


typedef enum _Region
{
    R_All,
    R_Island,
    R_Hero00,   // Gladiator
    R_Hero01,   // Seraphim
    R_Hero02,   // Dmonin
    R_Hero03,   // Zwerg
    R_Hero04,   // Waldelfe
    R_Hero05,   // Kampfmagier
    R_Hero06,   // Dunkelelf
    R_Hero07,   // Vampirin
    R_Gladiator = R_Hero00,
    R_Seraphim  = R_Hero01,
    R_Deamon    = R_Hero02,
    R_Dwarf     = R_Hero03,
    R_Woodelf   = R_Hero04,
    R_Magician  = R_Hero05,
    R_Darkelf   = R_Hero06,
    R_Vampyre   = R_Hero07
} Region;


class CCDSection  
{
private:
    CSacredHeroFileEx* m_pSHF;
	LPSECTIONCD m_pCD;
    CString m_strExplored;
    CString m_strVisible;
    bool m_bCalculated;

    void Calculate();
	void Delete();

    static bool GetExplored( LPSECTIONCD pSectionCD, /*UINT uiLength,*/ UINT & uiExplored, UINT & uiMaxExplored, UINT & uiExploredSub, UINT & uiMaxExploredSub );

    static int IsExplored( LPSECTIONCD pSectionCD, Region region );
    static void ShowRegion( LPSECTIONCD pSectionCD, Region region );
    static void HideRegion( LPSECTIONCD pSectionCD, Region region );

    static int IsExplored( LPSECTIONCD pSectionCD, UINT uiSectionNumber, const BYTE * pBytes );
    static void ShowRegion( LPSECTIONCD pSectionCD, UINT uiSectionNumber, const BYTE * pBytes );
    static void HideRegion( LPSECTIONCD pSectionCD, UINT uiSectionNumber, const BYTE * pBytes );

    static int IsExplored( SECTIONCDENTRY & entry, const BYTE * pBytes );
    static void ShowRegion( SECTIONCDENTRY & entry, const BYTE * pBytes );
    static void HideRegion( SECTIONCDENTRY & entry, const BYTE * pBytes );

    static UINT CalcExplored( UINT uiExploredSectors, UINT uiMaxSectors, UINT uiFactor = 1 );
    static CString CalcExploredString( UINT uiExploredSectors, UINT uiMaxSectors, UINT uiCountPostDecimalPositions = 2 );

	static LPSECTIONCD CreateCopy( LPSECTIONCD pSectionCD );
	static void DeleteCopy( LPSECTIONCD pSectionCD );

    static const UINT s_uiIslandSector;
    static const UINT s_uiHero00Sector;
    static const UINT s_uiHero01Sector;
    static const UINT s_uiHero02Sector1;
    static const UINT s_uiHero02Sector2;
    static const UINT s_uiHero03Sector;
    static const UINT s_uiHero04Sector;
    static const UINT s_uiHero05Sector1;
    static const UINT s_uiHero05Sector2;
    static const UINT s_uiHero06Sector1;
    static const UINT s_uiHero06Sector2;
    static const UINT s_uiHero06Sector3;
    static const UINT s_uiHero07Sector;

    static const BYTE s_aIslandBits[128];
    static const BYTE s_aHero00Bits[128];
    static const BYTE s_aHero01Bits[128];
    static const BYTE s_aHero02Bits1[128];
    static const BYTE s_aHero02Bits2[128];
    static const BYTE s_aHero03Bits[128];
    static const BYTE s_aHero04Bits[128];
    static const BYTE s_aHero05Bits1[128];
    static const BYTE s_aHero05Bits2[128];
    static const BYTE s_aHero06Bits1[128];
    static const BYTE s_aHero06Bits2[128];
    static const BYTE s_aHero06Bits3[128];
    static const BYTE s_aHero07Bits[128];

public:
	CCDSection();
	virtual ~CCDSection();

    bool SetHeroFile( CSacredHeroFileEx* pSHF );
    bool IsInitialized() { return this->m_pSHF != NULL; }

    CString GetExplored();
    CString GetVisible();
    int IsExplored( Region region ) const;

    void HideRegion( Region region );
    void ShowRegion( Region region );

	bool Save();
};

#endif // !defined(AFX_CDSECTION_H__62EFF0C0_424D_4298_B5DD_45593EC7E234__INCLUDED_)
