// EventDispatcher.cpp: Implementierung der Klasse CEventDispatcher.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EventDispatcher.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CEventDispatcher::CEventDispatcher( UINT uiID, CWnd* pParent /*=NULL*/ ) : EVENTDISPATCHER_PARENT_CLASS( uiID, pParent )
{
    this->m_bSuppressEvents = false;
}

CEventDispatcher::~CEventDispatcher()
{
}

void CEventDispatcher::DispatchEvent( EventType eventType, UINT uiNewValue )
{
    if (this->m_bSuppressEvents) return;

    int i, iCount = this->m_EventHandlerArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        this->m_EventHandlerArray[i]->HandleChangeEvent( eventType, uiNewValue );
    }
}

void CEventDispatcher::AddEventHandler( CEventHandler & rEventHandler )
{
    this->m_EventHandlerArray.Add( &rEventHandler );
}

bool CEventDispatcher::RemoveEventHandler( CEventHandler & rEventHandler )
{
    int i, iCount = this->m_EventHandlerArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_EventHandlerArray[i] == &rEventHandler)
        {
            this->m_EventHandlerArray.RemoveAt( i );
            return true;
        }
    }
    return false;
}
