
#include "stdafx.h"
#include "helper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/*static*/ void CHelper::AppendBackslash( CString & strPath )
{
    if (!strPath.IsEmpty())
    {
        if (strPath[strPath.GetLength() - 1] != '\\')
        {
            strPath += '\\';
        }
    }
}

/*static*/ void CHelper::RemoveBackslash( CString & strPath )
{
    if (!strPath.IsEmpty())
    {
        int iLast = strPath.GetLength() - 1;
        if (strPath[iLast] == '\\')
        {
            strPath.SetAt( iLast, 0 );
        }
    }
}

/*static*/ UINT CHelper::LimitValue( CEdit & rEditCtrl, UINT uiMaxValue /*=UINT_MAX*/ )
{
    UINT uiValue = 0;

    CString strText;
    rEditCtrl.GetWindowText( strText );

    if (strText.GetLength() > 0)
    {
        ULONGLONG ull;
        sscanf( (LPCTSTR)strText, "%I64u", &ull );
        if (ull > (ULONGLONG)uiMaxValue)
        {
            strText.Format( "%u", uiMaxValue );
            rEditCtrl.SetWindowText( (LPCTSTR)strText );
            uiValue = uiMaxValue;
        }
        else
        {
            uiValue = (UINT)ull;
        }
    }

    return uiValue;
}

/*static*/ UINT CHelper::CalcSurvivalBonus( UINT uiSurvivalTime )
{
    return (uiSurvivalTime < 120) ? 0 : (100 * (uiSurvivalTime / 60 - 1))/(uiSurvivalTime / 60 + 119);
}

/*static*/ UINT CHelper::CalcSurvivalTime( UINT uiSurvivalBonus )
{
    if ((uiSurvivalBonus > 0) && (uiSurvivalBonus < 100))
    {
        return (118 * uiSurvivalBonus + 199) / (100 - uiSurvivalBonus) * 60;
    }

    return 0;
}

/*static*/ UINT CHelper::ReadValue( CEdit & rEdit )
{
    CString strTemp;
    UINT uiValue = 0;

    rEdit.GetWindowText( strTemp );
    sscanf( (LPCTSTR)strTemp, "%u", &uiValue );

    return uiValue;
}

/*static*/ void CHelper::HandleCheck( CButton & rCheckBox, CEdit & rEdit, UINT uiDefaultValue )
{
    bool bCheck = (rCheckBox.GetCheck() != 0);

    if (!bCheck)
    {
        CString strTemp;
        strTemp.Format( "%u", uiDefaultValue );
        rEdit.SetWindowText( (LPCTSTR)strTemp );
    }

    rCheckBox.SetCheck( !bCheck );
    rEdit.EnableWindow( bCheck );
}

/*static*/ CString CHelper::UIntToString( UINT uiValue )
{
    CString strValue;
    strValue.Format( "%u", uiValue );
    return strValue;
}

/*static*/ CString CHelper::IntToString( INT iValue )
{
    CString strValue;
    strValue.Format( "%d", iValue );
    return strValue;
}

/*static*/ UINT CHelper::GetUIntValue( CEdit & rEdit )
{
    CString strTemp;
    UINT uiTemp = 0;

    rEdit.GetWindowText( strTemp );
    sscanf( (LPCTSTR)strTemp, "%u", &uiTemp );

    return uiTemp;
}

/*static*/ INT CHelper::GetIntValue( CEdit & rEdit )
{
    CString strTemp;
    INT iTemp = 0;

    rEdit.GetWindowText( strTemp );
    sscanf( (LPCTSTR)strTemp, "%d", &iTemp );

    return iTemp;
}

/*static*/ UINT CHelper::CalcLevelExp( UINT uiLevel )
{
    if (uiLevel <= 1) return 0;
    return (uiLevel*uiLevel*uiLevel*uiLevel + 36 * uiLevel*uiLevel*uiLevel + 36 * uiLevel*uiLevel + 16 * uiLevel - 166)/100*100;
}

/*static*/ UINT CHelper::CalcNewSkillPointsForLevel( UINT uiLevel )
{
    // Ab Level 30 gibt es 4 Punkte pro Level
    if (uiLevel > 29) return 4;

    // Ab Level 12 gibt es 3 Punkte pro Level
    if (uiLevel > 11) return 3;

    // Ab Level 3 gibt es 2 Punkte pro Level
    if (uiLevel > 2) return 2;

    // Fr Level 2 gibt es 1 Punkt
    if (uiLevel == 2) return 1;

    // Ansonsten gibt es keine Punkte
    return 0;
}
