/* -----------------------------------------------------------------------------
 *  Project: BHVS
 *  Class:   CIconLoader
 *  Description: Caches icons in 2 sizes (small: 16x16, great: 32x32)
 * -----------------------------------------------------------------------------
 * $Log: $
 * 
 * -----------------------------------------------------------------------------
 * Copyright: Copyright (c) SacredVault Team
 * developed by Uwe Posselt
 * -----------------------------------------------------------------------------
 */


#if !defined(AFX_ICONLOADER_H__A842151E_DFCF_4E62_991D_8B6314FBEB37__INCLUDED_)
#define AFX_ICONLOADER_H__A842151E_DFCF_4E62_991D_8B6314FBEB37__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <afxtempl.h>


typedef struct IconStruct
{
    UINT nID;
	CString szFileName;
	HICON hIcon;
} ICONSTRUCT,*LPICONSTRUCT;

class CIconLoader  
{
public:
	virtual ~CIconLoader();

	static HICON GetIcon( const CString & szFileName, bool bSmall = false );
    static HICON GetIcon( UINT nID, bool bSmall = false );

private:
    static CIconLoader s_Singleton;

	CIconLoader();

	void Empty();

	CArray<LPICONSTRUCT,LPICONSTRUCT> m_IconArray;
	CArray<LPICONSTRUCT,LPICONSTRUCT> m_SmallIconArray;
};

#endif // !defined(AFX_ICONLOADER_H__A842151E_DFCF_4E62_991D_8B6314FBEB37__INCLUDED_)
