// ItemDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "ItemDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CItemDlg 


CItemDlg::CItemDlg( CEventDispatcher & rEventDispatcher, CItem & rItem, CWnd* pParent /*=NULL*/ ) : m_rItem( rItem ), CEventHandler( rEventDispatcher ), CDialog(CItemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CItemDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
    UINT ui, uiCount = this->m_rItem.GetFilledSlotCount();

    this->m_DlgArray.Add( new CItemSlotDlg( this->m_rItem, uiCount, false, this ) );

    for (ui = 0; ui < uiCount; ++ui)
    {
        CSlotItem* pSlotItem = this->m_rItem.GetSlotItem( ui );
        if (NULL != pSlotItem)
        {
            this->m_DlgArray.Add( new CItemSlotDlg( *pSlotItem, 0, true, this ) );
        }
    }
}

CItemDlg::~CItemDlg()
{
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_DlgArray[i] != NULL)
        {
            delete this->m_DlgArray[i];
        }
    }
}

void CItemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CItemDlg)
	DDX_Control(pDX, IDC_RESTORE, m_ButtonRestore);
	DDX_Control(pDX, IDC_SAVE, m_ButtonSave);
	DDX_Control(pDX, IDC_TAB1, m_TabCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CItemDlg, CDialog)
	//{{AFX_MSG_MAP(CItemDlg)
	ON_BN_CLICKED(IDC_RESTORE, OnRestore)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CItemDlg 

void CItemDlg::OnOK() 
{
    this->OnCancel();
}

void CItemDlg::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	CDialog::OnCancel();
}

BOOL CItemDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    int i, iCount = this->m_DlgArray.GetSize();
    if (iCount > 0)
    {
        RECT rectTab, rectDlg;
        this->m_TabCtrl.GetWindowRect( &rectTab );
        this->m_TabCtrl.GetWindowRect( &rectDlg );

        for (i = 0; i < iCount; ++i)
        {
            if (this->m_DlgArray[i] != NULL)
            {
                this->m_DlgArray[i]->CreateModeless( &this->m_TabCtrl );
                this->m_DlgArray[i]->GetWindowRect( &rectDlg );
            }
        }

        rectDlg.top += rectTab.bottom - rectDlg.bottom - 5;
        rectDlg.bottom = rectTab.bottom - 2;
        rectDlg.left++;
        rectDlg.right++;
        this->m_TabCtrl.ScreenToClient( &rectDlg );

	    TC_ITEM tcItem;
        CString strCaption;
        for (i = 0; i < iCount; ++i)
        {
            if (this->m_DlgArray[i] != NULL)
            {
                if (0 == i)
                {
                    strCaption = "Item";
                }
                else
                {
                    strCaption.Format( "Sockel %d", i );
                }
		        tcItem.mask = TCIF_TEXT;
                tcItem.pszText = (LPTSTR)(LPCTSTR)strCaption;
		        tcItem.cchTextMax = strCaption.GetLength();
		        this->m_TabCtrl.InsertItem(i,&tcItem);
                this->m_DlgArray[i]->MoveWindow( &rectDlg );
                this->m_TabCtrl.AttachControlToTab( this->m_DlgArray[i], i );
            }
        }

        this->m_TabCtrl.SetCurSel(0);
    }
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CItemDlg::OnRestore() 
{
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_DlgArray[i] != NULL)
        {
            this->m_DlgArray[i]->Restore();
        }
    }
}

void CItemDlg::OnSave() 
{
/*
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_DlgArray[i] != NULL)
        {
            this->m_DlgArray[i]->Save();
        }
    }

    this->SendEvent( ET_Items, 0 );
//*/
}

void CItemDlg::OnDestroy() 
{
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if ((this->m_DlgArray[i] != NULL) && (this->m_DlgArray[i]->GetSafeHwnd() != NULL))
        {
            this->m_DlgArray[i]->DestroyWindow();
        }
    }

    CDialog::OnDestroy();
}

BOOL CItemDlg::PreTranslateMessage(MSG* pMsg) 
{
    if (pMsg->message == WM_KEYDOWN)
    {
        // ESC soll nicht dazu fhren, dass sich das Programm schliesst
        // Da wir die Taste nicht brauchen, wird sie einfach ignoriert.
        if (pMsg->wParam == VK_ESCAPE)
        {
            return TRUE;
        }

        // ENTER ist nur fr die 2 Buttons zulssig
        if (pMsg->wParam == VK_RETURN)
        {
            if (    (pMsg->hwnd != this->m_ButtonRestore.GetSafeHwnd())
                &&  (pMsg->hwnd != this->m_ButtonSave.GetSafeHwnd())
                )
            {
                return TRUE;
            }
        }
    }
	
	return CDialog::PreTranslateMessage(pMsg);
}
