// ItemList.h: Schnittstelle fr die Klasse CItemList.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ITEMLIST_H__D3D5A814_697F_4EC4_8D49_F13E8ACB5603__INCLUDED_)
#define AFX_ITEMLIST_H__D3D5A814_697F_4EC4_8D49_F13E8ACB5603__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CItemList;    // Forward-Deklaration


#include "Item.h"


typedef CArray<CItem*,CItem*> CItemArray;


class CItemList  
{
private:
    CItemArray m_Items;
    ItemPosition m_ActiveSlot;

    void RemoveAllItems();

    static int GetItemBonus( const CSlotItem* pSlotItem, BonusType bonusType, CharType charType );

    // Nur die Klasse CSacredHeroFileEx darf ein Objekt davon anlegen
    friend class CSacredHeroFileEx;

	CItemList();

public:
	virtual ~CItemList();

    bool SetHeroFile( CSacredHeroFileEx* pSHF );
    bool IsInitialized() { return this->GetItemCount() > 0; }

    UINT GetItemCount() const;
    const CItem * GetItem( UINT uiItem ) const;
    CItem * GetItem( UINT uiItem );

    ItemPosition GetActiveSlot() const;

    int GetCharBonus( Attribute attribute, CharType charType );
    int GetCharBonus( BonusType bonusType, CharType charType );
    int GetCharBonus( CombatArt combatArt, CharType charType );
    int GetCharBonus( SkillType skillType, CharType charType );
};


#endif // !defined(AFX_ITEMLIST_H__D3D5A814_697F_4EC4_8D49_F13E8ACB5603__INCLUDED_)
