// ItemSlotDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "ItemSlotDlg.h"
#include "PaxHelper.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CItemSlotDlg 


CItemSlotDlg::CItemSlotDlg( CSlotItem & rSlotItem, UINT uiSlotsFilled, bool bSlotted, CWnd* pParent /*=NULL*/) : CDialog(CItemSlotDlg::IDD, pParent), m_rSlotItem( rSlotItem )
{
    this->m_uiSlotsFilled = uiSlotsFilled;
    this->m_bSlotted = bSlotted;

	//{{AFX_DATA_INIT(CItemSlotDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CItemSlotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

    int i;
    for (i = 0; i < MAX_SLOT_COUNT; ++i)
    {
	    DDX_Control(pDX, i + IDC_COMBO_SLOT1, m_aComboSlot[i]);
    }
    for (i = 0; i < MAX_BONUS_COUNT; ++i)
    {
	    DDX_Control(pDX, i + IDC_COMBO_BONUS1_ACT_FOR       , m_aComboBonusActsFor[i]        );
	    DDX_Control(pDX, i + IDC_COMBO_BONUS1_ACT_AGAINST   , m_aComboBonusCounterActsFor[i]    );
	    DDX_Control(pDX, i + IDC_COMBO_BONUS1_TYPE          , m_aComboBonusType[i]          );
	    DDX_Control(pDX, i + IDC_SPIN_BONUS1_VALUE          , m_aSpinBonusValue[i]          );
	    DDX_Control(pDX, i + IDC_CHECK_BONUS1_FOR_WEAPON    , m_aCheckBonusForWeapon[i]     );
	    DDX_Control(pDX, i + IDC_CHECK_BONUS1_FOR_SPELLS    , m_aCheckBonusForSpells[i]     );
	    DDX_Control(pDX, i + IDC_CHECK_BONUS1_FOR_RESISTENCE, m_aCheckBonusForResistance[i] );
	    DDX_Control(pDX, i + IDC_CHECK_BONUS1_FOR_DAMAGE    , m_aCheckBonusForDamage[i]     );
    }

	//{{AFX_DATA_MAP(CItemSlotDlg)
	DDX_Control(pDX, IDC_SPIN_RESISTANCE_POISON, m_SpinResistancePoison);
	DDX_Control(pDX, IDC_SPIN_RESISTANCE_PHYS, m_SpinResistancePhys);
	DDX_Control(pDX, IDC_SPIN_RESISTANCE_MAGIC, m_SpinResistanceMagic);
	DDX_Control(pDX, IDC_SPIN_RESISTANCE_FIRE, m_SpinResistanceFire);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_POISON_MIN, m_SpinDamagePoisonMin);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_POISON_MAX, m_SpinDamagePoisonMax);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_PHYS_MIN, m_SpinDamagePhysMin);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_PHYS_MAX, m_SpinDamagePhysMax);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_MAGIC_MIN, m_SpinDamageMagicMin);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_MAGIC_MAX, m_SpinDamageMagicMax);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_FIRE_MIN, m_SpinDamageFireMin);
	DDX_Control(pDX, IDC_SPIN_DAMAGE_FIRE_MAX, m_SpinDamageFireMax);
	DDX_Control(pDX, IDC_SPIN_UNKNOWN, m_SpinUnknown);
	DDX_Control(pDX, IDC_SPIN_MIN_SKILL, m_SpinMinSkill);
	DDX_Control(pDX, IDC_SPIN_MIN_RESISTANCE, m_SpinMinResistance);
	DDX_Control(pDX, IDC_SPIN_MIN_CHARISMA, m_SpinMinCharisma);
	DDX_Control(pDX, IDC_SPIN_MIN_DEXTERITY, m_SpinMinDexterity);
	DDX_Control(pDX, IDC_SPIN_MIN_STRENGTH, m_SpinMinStrength);
	DDX_Control(pDX, IDC_SPIN_DEFENSE, m_SpinDefense);
	DDX_Control(pDX, IDC_SPIN_ATTACK, m_SpinAttack);
	DDX_Control(pDX, IDC_SPIN_LEVEL_MIN, m_SpinLevelMin);
	DDX_Control(pDX, IDC_SPIN_LEVEL, m_SpinLevel);
	DDX_Control(pDX, IDC_SPIN_PRICE, m_SpinPrice);
	DDX_Control(pDX, IDC_COMBO_MIN_SKILL, m_ComboMinSkill);
	DDX_Control(pDX, IDC_COMBO_SEVERITY, m_ComboSeverity);
	DDX_Control(pDX, IDC_COMBO_ITEMCLASS, m_ComboItemClass);
	DDX_Control(pDX, IDC_COMBO_CHARCLASS, m_ComboCharClass);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CItemSlotDlg, CDialog)
	//{{AFX_MSG_MAP(CItemSlotDlg)
	ON_CONTROL_RANGE(CBN_SELCHANGE, IDC_COMBO_BONUS1_TYPE, IDC_COMBO_BONUS8_TYPE, OnSelchangeComboBonusType)
	ON_CONTROL_RANGE(CBN_SELCHANGE, IDC_COMBO_SLOT1, IDC_COMBO_SLOT8, OnSelchangeComboSlot)
	ON_CBN_SELCHANGE(IDC_COMBO_MIN_SKILL, OnSelchangeComboMinSkill)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CItemSlotDlg 

BOOL CItemSlotDlg::CreateModeless( CWnd* pParent /*=NULL*/ )
{
    return this->Create( CItemSlotDlg::IDD, pParent );
}


BOOL CItemSlotDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    int i, j, iIndex;

    // CharClass
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_All        ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_All );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Seraphim   ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Seraphim );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Gladiator  ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Gladiator );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Mage       ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Mage );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Darkelf    ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Darkelf );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Woodelf    ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Woodelf );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Vampire    ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Vampire );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Dwarf      ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Dwarf );
    iIndex = this->m_ComboCharClass.AddString( (LPCTSTR)CPaxHelper::GetCharClassString( CC_Daemon     ) );
    if (iIndex >= 0) this->m_ComboCharClass.SetItemData( iIndex, CC_Daemon );

    // ItemClass
    for (i = (int)IC_Bad; i <= (int)IC_Kanone; ++i)
    {
        iIndex = this->m_ComboItemClass.AddString( (LPCTSTR)CPaxHelper::GetItemClassString( (ItemClass)i ) );
        if (iIndex >= 0)
        {
            this->m_ComboItemClass.SetItemData( iIndex, i );
        }
    }

    // Severity
    for (i = (int)S_None; i <= (int)S_Niob; ++i)
    {
        this->m_ComboSeverity.AddString( (LPCTSTR)CPaxHelper::GetSeverityString( (Severity)i ) );
    }

    // Price
    this->m_SpinPrice.SetRange32( 0, INT_MAX );
    this->m_SpinPrice.SetPos32( 0 );

    // Level und Minimum Level
    this->m_SpinLevel.SetRange32( 0, 255 );
    this->m_SpinLevelMin.SetRange32( 0, 255 );

    // Attacke und Verteidigung
    this->m_SpinAttack.SetRange32( 0, USHRT_MAX );
    this->m_SpinDefense.SetRange32( 0, USHRT_MAX );

    // Minimum: Strke, Geschicklichkeit, Charisma, Widerstand
    this->m_SpinMinCharisma.SetRange32( 0, 255 );
    this->m_SpinMinStrength.SetRange32( 0, 255 );
    this->m_SpinMinDexterity.SetRange32( 0, 255 );
    this->m_SpinMinResistance.SetRange32( 0, 255 );

    // Minimum Skill
    for (i = (int)ST_NichtAusgewaehlt; i < (int)ST_LastSkill; ++i)
    {
        int iIndex = this->m_ComboMinSkill.AddString( (LPCTSTR)CPaxHelper::GetSkillString( (SkillType)i ) );
        if (iIndex >= 0)
        {
            this->m_ComboMinSkill.SetItemData( iIndex, i );
        }
    }
    this->m_SpinMinSkill.SetRange32( 0, 255 );

    // Unbekannt
    this->m_SpinUnknown.SetRange32( 0, USHRT_MAX );

    // Schaden
    this->m_SpinDamagePhysMax.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamagePhysMin.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamageFireMax.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamageFireMin.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamageMagicMax.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamageMagicMin.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamagePoisonMax.SetRange32( 0, USHRT_MAX );
    this->m_SpinDamagePoisonMin.SetRange32( 0, USHRT_MAX );

    // Resistenzen
    this->m_SpinResistancePhys.SetRange32( 0, USHRT_MAX );
    this->m_SpinResistanceFire.SetRange32( 0, USHRT_MAX );
    this->m_SpinResistanceMagic.SetRange32( 0, USHRT_MAX );
    this->m_SpinResistancePoison.SetRange32( 0, USHRT_MAX );

    // Sockel
    for (i = (int)ST_None; i <= (int)ST_Platinum; ++i)
    {
        CString strSeverity = CPaxHelper::GetSlotTypeString( (SlotType)i );

        for (j = (int)((i == ST_None)?this->m_uiSlotsFilled:0); j < MAX_SLOT_COUNT; ++j)
        {
            iIndex = this->m_aComboSlot[j].AddString( strSeverity );
            if (iIndex >= 0)
            {
                this->m_aComboSlot[j].SetItemData( iIndex, i );
            }
        }
    }

    // Boni
    // BonusTypes
    POSITION pos = CPaxHelper::GetFirstBonusType();
    while (NULL != pos)
    {
        BonusType bonusType;
        CString strBonusType = CPaxHelper::GetBonusTypeString( pos, bonusType );
        for (i = 0; i < MAX_BONUS_COUNT; ++i)
        {
            iIndex = this->m_aComboBonusType[i].AddString( (LPCTSTR)strBonusType );
            if (iIndex >= 0)
            {
                this->m_aComboBonusType[i].SetItemData( iIndex, (DWORD)bonusType );
            }
        }
    }

    // Bonus acts for
    for (i = (int)BAF_All; i <= (int)BAF_Daemonin; ++i)
    {
        CString strBAF = CPaxHelper::GetBonusActsForString( (BonusActsFor)i );
        if (strBAF.IsEmpty() || (strBAF.GetAt( 0 ) != '?'))
        {
            for (j = 0; j < MAX_BONUS_COUNT; ++j)
            {
                iIndex = this->m_aComboBonusActsFor[j].AddString( (LPCTSTR)strBAF );
                if (iIndex >= 0)
                {
                    this->m_aComboBonusActsFor[j].SetItemData( iIndex, i );
                }
            }
        }
    }
    // Bonus acts against
    for (i = (int)BCAF_None; i <= (int)BCAF_Berittene; ++i)
    {
        CString strBCAF = CPaxHelper::GetBonusCounterActsForString( (BonusCounterActsFor)i );
        if (strBCAF.IsEmpty() || (strBCAF.GetAt( 0 ) != '?'))
        {
            for (j = 0; j < MAX_BONUS_COUNT; ++j)
            {
                iIndex = this->m_aComboBonusCounterActsFor[j].AddString( (LPCTSTR)strBCAF );
                if (iIndex >= 0)
                {
                    this->m_aComboBonusCounterActsFor[j].SetItemData( iIndex, i );
                }
            }
        }
    }
    // Bonus-Spin
    for (i = 0; i < MAX_BONUS_COUNT; ++i)
    {
        this->m_aSpinBonusValue[i].SetRange32( SHRT_MIN, SHRT_MAX );
    }



	this->Restore();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CItemSlotDlg::Save()
{
/*
    // CharClass
    int iIndex = this->m_ComboCharClass.GetCurSel();
    if (iIndex >= 0)
    {
        this->m_rSlotItem.SetCharClass( (CharClass)this->m_ComboCharClass.GetItemData( iIndex ) );
    }

    // ItemClass
    iIndex = this->m_ComboItemClass.GetCurSel();
    if (iIndex >= 0)
    {
        this->m_rSlotItem.SetItemClass( (ItemClass)this->m_ComboItemClass.GetItemData( iIndex ) );
    }

    // Severity
    this->m_rSlotItem.SetSeverity( (Severity)this->m_ComboSeverity.GetCurSel() );

    // Price
    this->m_rSlotItem.SetPrice( (UINT)this->m_SpinPrice.GetPos32() );

    // Level und Minimum Level
    this->m_rSlotItem.SetLevel( (BYTE)this->m_SpinLevel.GetPos32() );
    this->m_rSlotItem.SetMinLevel( (BYTE)this->m_SpinLevelMin.GetPos32() );

    // Attacke und Verteidigung
    this->m_rSlotItem.SetAttack( (USHORT)this->m_SpinAttack.GetPos32() );
    this->m_rSlotItem.SetDefense( (USHORT)this->m_SpinDefense.GetPos32() );

    // Minimum: Strke, Geschicklichkeit, Charisma, Widerstand
    this->m_rSlotItem.SetMinCharisma( (BYTE)this->m_SpinMinCharisma.GetPos32() );
    this->m_rSlotItem.SetMinStrength( (BYTE)this->m_SpinMinStrength.GetPos32() );
    this->m_rSlotItem.SetMinDexterity( (BYTE)this->m_SpinMinDexterity.GetPos32() );
    this->m_rSlotItem.SetMinRefractiveness( (BYTE)this->m_SpinMinResistance.GetPos32() );

    // Minimum Skill
    iIndex = this->m_ComboMinSkill.GetCurSel();
    if (iIndex >= 0)
    {
        SkillType skillType = (SkillType)this->m_ComboMinSkill.GetItemData( iIndex );
        if (ST_NichtAusgewaehlt == skillType)
        {
            this->m_rSlotItem.SetMinSkillLevel( 0 );
        }
        else
        {
            this->m_rSlotItem.SetMinSkillLevel( (BYTE)this->m_SpinMinSkill.GetPos32() );
        }
        this->m_rSlotItem.SetMinSkillType( skillType );
    }

    // Unbekannt
    this->m_rSlotItem.SetUnknown( (USHORT)this->m_SpinUnknown.GetPos32() );

    // Schaden
    this->m_rSlotItem.SetPhysDamageMax( (USHORT)this->m_SpinDamagePhysMax.GetPos32() );
    this->m_rSlotItem.SetPhysDamageMin( (USHORT)this->m_SpinDamagePhysMin.GetPos32() );
    this->m_rSlotItem.SetFireDamageMax( (USHORT)this->m_SpinDamageFireMax.GetPos32() );
    this->m_rSlotItem.SetFireDamageMin( (USHORT)this->m_SpinDamageFireMin.GetPos32() );
    this->m_rSlotItem.SetMagicDamageMax( (USHORT)this->m_SpinDamageMagicMax.GetPos32() );
    this->m_rSlotItem.SetMagicDamageMin( (USHORT)this->m_SpinDamageMagicMin.GetPos32() );
    this->m_rSlotItem.SetPoisonDamageMax( (USHORT)this->m_SpinDamagePoisonMax.GetPos32() );
    this->m_rSlotItem.SetPoisonDamageMin( (USHORT)this->m_SpinDamagePoisonMin.GetPos32() );

    // Resistenzen
    this->m_rSlotItem.SetPhysResi( (USHORT)this->m_SpinResistancePhys.GetPos32() );
    this->m_rSlotItem.SetFireResi( (USHORT)this->m_SpinResistanceFire.GetPos32() );
    this->m_rSlotItem.SetMagicResi( (USHORT)this->m_SpinResistanceMagic.GetPos32() );
    this->m_rSlotItem.SetPoisonResi( (USHORT)this->m_SpinResistancePoison.GetPos32() );

    // Sockel
    for (UINT ui = 0; ui < MAX_SLOT_COUNT; ++ui)
    {
        iIndex = this->m_aComboSlot[ui].GetCurSel();
        if (iIndex >= 0)
        {
            this->m_rSlotItem.SetSlotType( ui, (SlotType)this->m_aComboSlot[ui].GetItemData( iIndex ) );
        }
    }

    // Boni
    for (ui = 0; ui < MAX_BONUS_COUNT; ++ui)
    {
        BYTE bCounterActsFor = 0, bActsFor = 0;
        short sBonusValue = 0;
        BonusType bonusType = BT_None;

        int iIndex = this->m_aComboBonusType[ui].GetCurSel();
        if (iIndex >= 0)
        {
            bonusType = (BonusType)this->m_aComboBonusType[ui].GetItemData( iIndex );
            if (BT_None != bonusType)
            {
                sBonusValue = (short)this->m_aSpinBonusValue[ui].GetPos32();
                
                iIndex = this->m_aComboBonusCounterActsFor[ui].GetCurSel();
                if (iIndex >= 0)
                {
                    bCounterActsFor = (BYTE)this->m_aComboBonusCounterActsFor[ui].GetItemData( iIndex );
                }

                iIndex = this->m_aComboBonusActsFor[ui].GetCurSel();
                if (iIndex >= 0)
                {
                    bActsFor = (BYTE)this->m_aComboBonusActsFor[ui].GetItemData( iIndex );
                }

                if (0 != this->m_aCheckBonusForDamage[ui].GetCheck())
                {
                    bActsFor |= BAF_Schaden;
                }
                if (0 != this->m_aCheckBonusForResistance[ui].GetCheck())
                {
                    bActsFor |= BAF_Resistenz;
                }
                if (0 != this->m_aCheckBonusForSpells[ui].GetCheck())
                {
                    bActsFor |= BAF_Zauber;
                }
                if (0 != this->m_aCheckBonusForWeapon[ui].GetCheck())
                {
                    bActsFor |= BAF_Waffe;
                }
            }
        }

        this->m_rSlotItem.SetBonus( ui, bCounterActsFor, bActsFor, (UINT)bonusType, sBonusValue );
    }
//*/
}

void CItemSlotDlg::Restore()
{
    UINT ui;

    // TODO: Namen setzen
    // TODO: Set-Namen setzen

    // CharClass
    this->m_ComboCharClass.SelectString( -1, (LPCTSTR)CPaxHelper::GetCharClassString( this->m_rSlotItem.GetCharClass() ) );
    
    // ItemClass
    this->m_ComboItemClass.SelectString( -1, (LPCTSTR)CPaxHelper::GetItemClassString( this->m_rSlotItem.GetItemClass() ) );

    // Severity
    this->m_ComboSeverity.SetCurSel( (int)this->m_rSlotItem.GetSeverity() );

    // Price
    this->m_SpinPrice.SetPos32( (int)this->m_rSlotItem.GetPrice() );

    // Level und Minimum Level
    this->m_SpinLevel.SetPos32( (int)this->m_rSlotItem.GetLevel() );
    this->m_SpinLevelMin.SetPos32( (int)this->m_rSlotItem.GetMinLevel() );

    // Attacke und Verteidigung
    this->m_SpinAttack.SetPos32( (int)this->m_rSlotItem.GetAttack() );
    this->m_SpinDefense.SetPos32( (int)this->m_rSlotItem.GetDefense() );

    // Minimum: Strke, Geschicklichkeit, Charisma, Widerstand
    this->m_SpinMinCharisma.SetPos32( (int)this->m_rSlotItem.GetMinCharisma() );
    this->m_SpinMinStrength.SetPos32( (int)this->m_rSlotItem.GetMinStrength() );
    this->m_SpinMinDexterity.SetPos32( (int)this->m_rSlotItem.GetMinDexterity() );
    this->m_SpinMinResistance.SetPos32( (int)this->m_rSlotItem.GetMinRefractiveness() );

    // Minimum Skill
    SkillType skillType = this->m_rSlotItem.GetMinSkillType();
    if (ST_NichtAusgewaehlt == skillType)
    {
        this->m_SpinMinSkill.SetPos32( 0 );
        this->m_SpinMinSkill.EnableWindow( FALSE );
    }
    else
    {
        this->m_SpinMinSkill.SetPos32( (int)this->m_rSlotItem.GetMinSkillLevel() );
        this->m_SpinMinSkill.EnableWindow( TRUE );
    }
    this->m_ComboMinSkill.SelectString( -1, (LPCTSTR)CPaxHelper::GetSkillString( skillType ) );

    // Unbekannt
    this->m_SpinUnknown.SetPos32( (int)this->m_rSlotItem.GetUnknown() );

    // Schaden
    this->m_SpinDamagePhysMax.SetPos32( (int)this->m_rSlotItem.GetPhysDamageMax() );
    this->m_SpinDamagePhysMin.SetPos32( (int)this->m_rSlotItem.GetPhysDamageMin() );
    this->m_SpinDamageFireMax.SetPos32( (int)this->m_rSlotItem.GetFireDamageMax() );
    this->m_SpinDamageFireMin.SetPos32( (int)this->m_rSlotItem.GetFireDamageMin() );
    this->m_SpinDamageMagicMax.SetPos32( (int)this->m_rSlotItem.GetMagicDamageMax() );
    this->m_SpinDamageMagicMin.SetPos32( (int)this->m_rSlotItem.GetMagicDamageMin() );
    this->m_SpinDamagePoisonMax.SetPos32( (int)this->m_rSlotItem.GetPoisonDamageMax() );
    this->m_SpinDamagePoisonMin.SetPos32( (int)this->m_rSlotItem.GetPoisonDamageMin() );

    // Resistenzen
    this->m_SpinResistancePhys.SetPos32( (int)this->m_rSlotItem.GetPhysResi() );
    this->m_SpinResistanceFire.SetPos32( (int)this->m_rSlotItem.GetFireResi() );
    this->m_SpinResistanceMagic.SetPos32( (int)this->m_rSlotItem.GetMagicResi() );
    this->m_SpinResistancePoison.SetPos32( (int)this->m_rSlotItem.GetPoisonResi() );

    // Sockel
    bool bLast = false;
    for (ui = 0; ui < MAX_SLOT_COUNT; ++ui)
    {
        SlotType slotType = this->m_rSlotItem.GetSlotType( ui );
        this->m_aComboSlot[ui].SelectString( -1, (LPCTSTR)CPaxHelper::GetSlotTypeString( slotType ) );
        this->m_aComboSlot[ui].EnableWindow( !this->m_bSlotted && !bLast );
        bLast = (ST_None == slotType);
    }

    // Boni
    for (ui = 0; ui < MAX_BONUS_COUNT; ++ui)
    {
        BYTE bCounterActsFor, bActsFor;
        UINT uiBonusType;
        short sBonusValue;
        if (this->m_rSlotItem.GetBonus( ui, bCounterActsFor, bActsFor, uiBonusType, sBonusValue ))
        {
            // Bonus anzeigen
            bool bFound = false;
            bool bSelected = false;
            int iSearchStart = -1;
            do
            {
                int iSel = this->m_aComboBonusType[ui].SelectString( iSearchStart, (LPCTSTR)CPaxHelper::GetBonusTypeString( (BonusType)uiBonusType ) );
                if (iSel < 0)
                {
                    bSelected = true;
                }
                else
                {
                    BonusType bonusType = (BonusType)this->m_aComboBonusType[ui].GetItemData( iSel );
                    if (bonusType == (BonusType)uiBonusType)
                    {
                        bSelected = true;
                        bFound = true;
                    }
                    else if (iSel > iSearchStart)
                    {
                        iSearchStart = iSel;
                    }
                    else
                    {
                        // Suche begann wieder von oben -> String ist zwar in der Liste,
                        // aber keiner der Strings hat den korrekten BonusTyp
                        bSelected = true;
                    }
                }
            }
            while (!bSelected);

            if (0 == uiBonusType)
            {
                bFound = false;
            }

            if (!bFound)
            {
                sBonusValue = 0;
            }

            // die anderen Controls fr den Bonus aktivieren/deaktivieren
            this->m_aComboBonusActsFor[ui].EnableWindow( bFound );
            this->m_aComboBonusCounterActsFor[ui].EnableWindow( bFound );
            this->m_aSpinBonusValue[ui].EnableWindow( bFound );
            this->m_aCheckBonusForWeapon[ui].EnableWindow( bFound );
            this->m_aCheckBonusForSpells[ui].EnableWindow( bFound );
            this->m_aCheckBonusForDamage[ui].EnableWindow( bFound );
            this->m_aCheckBonusForResistance[ui].EnableWindow( bFound );

            // BonusWert setzen
            this->m_aSpinBonusValue[ui].SetPos32( (int)sBonusValue );

            // CounterActsFor
            this->m_aComboBonusCounterActsFor[ui].SelectString( -1, (LPCTSTR)CPaxHelper::GetBonusCounterActsForString( (BonusCounterActsFor)bCounterActsFor ) );

            // ActsFor
            this->m_aComboBonusActsFor[ui].SelectString( -1, (LPCTSTR)CPaxHelper::GetBonusActsForString( (BonusActsFor)(bActsFor & 0x0F) ) );

            this->m_aCheckBonusForDamage[ui].SetCheck( (bActsFor & BAF_Schaden) == BAF_Schaden );
            this->m_aCheckBonusForResistance[ui].SetCheck( (bActsFor & BAF_Resistenz) == BAF_Resistenz );
            this->m_aCheckBonusForSpells[ui].SetCheck( (bActsFor & BAF_Zauber) == BAF_Zauber );
            this->m_aCheckBonusForWeapon[ui].SetCheck( (bActsFor & BAF_Waffe) == BAF_Waffe );
        }
    }
}

BOOL CItemSlotDlg::PreTranslateMessage(MSG* pMsg) 
{
    if (pMsg->message == WM_KEYDOWN)
    {
        // ESC und ENTER sollen nicht dazu fhren, dass sich der Dialog schliesst
        // Da wir die Tasten nicht brauchen, werden sie einfach ignoriert.
        if (pMsg->wParam == VK_ESCAPE)
        {
            return TRUE;
        }
        if (pMsg->wParam == VK_RETURN)
        {
            return TRUE;
        }
    }
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CItemSlotDlg::OnSelchangeComboMinSkill() 
{
    int iIndex = this->m_ComboMinSkill.GetCurSel();
    if (iIndex >= 0)
    {
        SkillType skillType = (SkillType)this->m_ComboMinSkill.GetItemData( iIndex );

        bool bEnable = (ST_NichtAusgewaehlt != skillType);
        this->m_SpinMinSkill.EnableWindow( bEnable );

        // Range anpassen
        this->m_SpinMinSkill.SetRange32( bEnable ? 1 : 0, 255 );

        // Position setzen
        this->m_SpinMinSkill.SetPos32( bEnable ? 1 : 0 );
    }
}

void CItemSlotDlg::OnSelchangeComboSlot( UINT nID ) 
{
    UINT uiIndex = nID - IDC_COMBO_SLOT1;
    if (uiIndex < MAX_SLOT_COUNT)
    {
        int iIndex = this->m_aComboSlot[uiIndex].GetCurSel();
        if (iIndex >= 0)
        {
            if (ST_None == this->m_aComboSlot[uiIndex].GetItemData( iIndex ))
            {
                // Sockel wird entfernt

                // Nichts enthalten -> alle nachfolgenden Sockel mssen ebenfalls entfernt und deaktiviert werden
                for (UINT ui = uiIndex + 1; ui < MAX_SLOT_COUNT; ++ui)
                {
                    this->m_aComboSlot[ui].SetCurSel( ST_None );
                    this->m_aComboSlot[ui].EnableWindow( FALSE );
                }
            }
            else
            {
                // Sockel wurde gesetzt -> nachfolgender Sockel wird aktiviert
                ++uiIndex;
                if (uiIndex < MAX_SLOT_COUNT)
                {
                    this->m_aComboSlot[uiIndex].EnableWindow( TRUE );
                }
            }
        }
    }
}

void CItemSlotDlg::OnSelchangeComboBonusType( UINT nID )
{
    UINT uiIndex = nID - IDC_COMBO_BONUS1_TYPE;
    if (uiIndex < MAX_BONUS_COUNT)
    {
        int iIndex = this->m_aComboBonusType[uiIndex].GetCurSel();
        if (iIndex >= 0)
        {
            bool bEnable = (BT_None != this->m_aComboBonusType[uiIndex].GetItemData( iIndex ));

            // bei Deaktivierung die Werte auf Standard zurcksetzen
            if (!bEnable)
            {
                this->m_aSpinBonusValue[uiIndex].SetPos32( 0 );
                this->m_aComboBonusActsFor[uiIndex].SelectString( -1, (LPCTSTR)CPaxHelper::GetBonusActsForString( BAF_All ) );
                this->m_aComboBonusCounterActsFor[uiIndex].SelectString( -1, (LPCTSTR)CPaxHelper::GetBonusCounterActsForString( BCAF_None ) );
                this->m_aCheckBonusForWeapon[uiIndex].SetCheck( 0 );
                this->m_aCheckBonusForSpells[uiIndex].SetCheck( 0 );
                this->m_aCheckBonusForDamage[uiIndex].SetCheck( 0 );
                this->m_aCheckBonusForResistance[uiIndex].SetCheck( 0 );
            }

            this->m_aComboBonusActsFor[uiIndex].EnableWindow( bEnable );
            this->m_aComboBonusCounterActsFor[uiIndex].EnableWindow( bEnable );
            this->m_aSpinBonusValue[uiIndex].EnableWindow( bEnable );
            this->m_aCheckBonusForWeapon[uiIndex].EnableWindow( bEnable );
            this->m_aCheckBonusForSpells[uiIndex].EnableWindow( bEnable );
            this->m_aCheckBonusForDamage[uiIndex].EnableWindow( bEnable );
            this->m_aCheckBonusForResistance[uiIndex].EnableWindow( bEnable );
        }
    }
}
