
#include "stdafx.h"
#include "paxhelper.h"


////////////////////////////////////
// Items
////////////////////////////////////

/*static*/ CString CPaxHelper::GetSlotTypeString( SlotType slotType )
{
    CString strSlotType;

    switch (slotType)
    {
        case ST_None    : break;
        case ST_Bronze  : strSlotType = "Bronze"; break;
        case ST_Silver  : strSlotType = "Silber"; break;
        case ST_Gold    : strSlotType = "Gold"; break;
        case ST_Green   : strSlotType = "Grn"; break;
        case ST_Platinum: strSlotType = "Platin"; break;
        default         : strSlotType.Format( "? (%u = 0x%X)", slotType, slotType ); break;
    }

    return strSlotType;
}

/*static*/ CString CPaxHelper::GetItemPositionString( ItemPosition itemPosition )
{
    CString strItemPosition;

    switch (itemPosition)
    {
        case IP_Slot1           : strItemPosition = "Waffenslot 1"; break;
        case IP_Slot2           : strItemPosition = "Waffenslot 2"; break;
        case IP_Slot3           : strItemPosition = "Waffenslot 3"; break;
        case IP_Slot4           : strItemPosition = "Waffenslot 4"; break;
        case IP_Slot5           : strItemPosition = "Waffenslot 5"; break;
        case IP_Inventory       : strItemPosition = "Inventar"; break;
        case IP_Chest           : strItemPosition = "Truhe"; break;
        case IP_Helmet          : strItemPosition = "Helm"; break;
        case IP_Cuirass         : strItemPosition = "Rstung"; break;
        case IP_Belt            : strItemPosition = "Grtel"; break;
        case IP_Shoes           : strItemPosition = "Schuhe"; break;
        case IP_Gloves          : strItemPosition = "Handschuhe"; break;
        case IP_Bracers         : strItemPosition = "Armschienen"; break;
        case IP_Amulet1         : strItemPosition = "Amulett 1"; break;
        case IP_Amulet2         : strItemPosition = "Amulett 2"; break;
        case IP_Ring1           : strItemPosition = "Ring 1"; break;
        case IP_Ring2           : strItemPosition = "Ring 2"; break;
        case IP_Ring3           : strItemPosition = "Ring 3"; break;
        case IP_Ring4           : strItemPosition = "Ring 4"; break;
        case IP_WeaponSlotRight : strItemPosition = "Waffenslot rechts"; break;
        case IP_WeaponSlotLeft  : strItemPosition = "Waffenslot links"; break;
        case IP_Gun             : strItemPosition = "Kanone"; break;
        case IP_Shoulder        : strItemPosition = "Schulterpanzer"; break;
        case IP_Greaves         : strItemPosition = "Beinschienen"; break;
        case IP_Swing           : strItemPosition = "Schwingen"; break;
        case IP_Horse           : strItemPosition = "Pferd"; break;
        case IP_Saddle          : strItemPosition = "gesattelelt"; break;
        case IP_Unknown         : strItemPosition = "unbekannt"; break;
        default                 : strItemPosition.Format( "? (%u = 0x%X)", itemPosition, itemPosition ); break;
    }

    return strItemPosition;
}

/*static*/ CString CPaxHelper::GetCharClassString( CharClass charClass )
{
    CString strCharClass;

    switch (charClass)
    {
        case CC_None        : break;
        case CC_Seraphim    : strCharClass = "Seraphim"; break;
        case CC_Gladiator   : strCharClass = "Gladiator"; break;
        case CC_Mage        : strCharClass = "Kampfmagier"; break;
        case CC_Darkelf     : strCharClass = "Dunkelelf"; break;
        case CC_Woodelf     : strCharClass = "Waldelfe"; break;
        case CC_Vampire     : strCharClass = "Vampirin"; break;
        case CC_Dwarf       : strCharClass = "Zwerg"; break;
        case CC_Daemon      : strCharClass = "Dmonin"; break;
        case CC_All         : strCharClass = "Alle"; break;
        default             : strCharClass.Format( "? (%u = 0x%X)", charClass, charClass ); break;
    }

    return strCharClass;
}

/*static*/ CString CPaxHelper::GetSeverityString( Severity severity )
{
    CString strSeverity;

    switch (severity)
    {
        case S_None     : break;
        case S_Bronze   : strSeverity = "Bronze"; break;
        case S_Silver   : strSeverity = "Silber"; break;
        case S_Gold     : strSeverity = "Gold"; break;
        case S_Platin   : strSeverity = "Platin"; break;
        case S_Niob     : strSeverity = "Niob"; break;
        default         : strSeverity.Format( "? (%u = 0x%X)", severity, severity ); break;
    }

    return strSeverity;
}

/*static*/ CString CPaxHelper::GetItemClassString( ItemClass itemClass )
{
    CString strItemClass;

    switch (itemClass)
    {
        case IC_Bad             : strItemClass = "!BAD ITEM!"; break;
        case IC_Dolch           : strItemClass = "Dolch"; break;
        case IC_Schwert         : strItemClass = "Schwert"; break;
        case IC_Zweihandschwert : strItemClass = "Zweihandschwert"; break;
        case IC_Axt             : strItemClass = "Axt"; break;
        case IC_Zweihandaxt     : strItemClass = "Zweihandaxt"; break;
        case IC_Schild          : strItemClass = "Schild"; break;
        case IC_Bogen           : strItemClass = "Bogen"; break;
        case IC_Armbrust        : strItemClass = "Armbrust"; break;
        case IC_Faustwaffe      : strItemClass = "Faustwaffe"; break;
        case IC_Ruestung        : strItemClass = "Rstung"; break;
        case IC_Ring            : strItemClass = "Ring"; break;
        case IC_Amulett         : strItemClass = "Amulett"; break;
        case IC_Helm            : strItemClass = "Helm"; break;
        case IC_Armschutz       : strItemClass = "Armschutz"; break;
        case IC_Beinschutz      : strItemClass = "Beinschutz"; break;
        case IC_Guertel         : strItemClass = "Grtel"; break;
        case IC_Schulterpanzer  : strItemClass = "Schulterpanzer"; break;
        case IC_Stangenwaffe1   : strItemClass = "Stangenwaffe1"; break;
        case IC_Wuchtwaffe      : strItemClass = "Wuchtwaffe"; break;
        case IC_Stangenwaffe2   : strItemClass = "Stangenwaffe2"; break;
        case IC_Stab            : strItemClass = "Stab"; break;
        case IC_Zaumzeug        : strItemClass = "Zaumzeug"; break;
        case IC_Schuhe          : strItemClass = "Schuhe"; break;
        case IC_Handschuhe      : strItemClass = "Handschuhe"; break;
        case IC_Fluegel         : strItemClass = "Flgel"; break;
        case IC_Sonderitem      : strItemClass = "!SONDERITEM!"; break;
        case IC_Pistole         : strItemClass = "Pistole"; break;
        case IC_Gewehr          : strItemClass = "?Gewehr?"; break;
        case IC_Kanone          : strItemClass = "Kanone"; break;
        default                 : strItemClass.Format( "? (%u = 0x%X)", itemClass, itemClass ); break;
    }

    return strItemClass;
}

////////////////////////////////////
// Skills
////////////////////////////////////

/*static*/ CString CPaxHelper::GetSkillString( SkillType skillType )
{
    CString strSkillString;

    switch (skillType)
    {
        case ST_NichtAusgewaehlt: strSkillString = "<nicht ausgewhlt>";    break;
        case ST_Himmelsmagie    : strSkillString = "Himmelsmagie";          break;
        case ST_Waffenkunde     : strSkillString = "Waffenkunde";           break;
        case ST_Stangenwaffen   : strSkillString = "Stangenwaffen";         break;
        case ST_Schwertkunde    : strSkillString = "Schwertkunde";          break;
        case ST_Axtkampf        : strSkillString = "Axtkampf";              break;
        case ST_Zweiwaffenkampf : strSkillString = "Zweiwaffenkampf";       break;
        case ST_Fernkampf       : strSkillString = "Fernkampf";             break;
        case ST_Wendigkeit      : strSkillString = "Wendigkeit";            break;
        case ST_Parade          : strSkillString = "Parade";                break;
        case ST_Konstitution    : strSkillString = "Konstitution";          break;
        case ST_Ruestung        : strSkillString = "Rstung";               break;
        case ST_Meditation      : strSkillString = "Meditation";            break;
        case ST_Klingenkampf    : strSkillString = "Klingenkampf";          break;
        case ST_Magiekunde      : strSkillString = "Magiekunde";            break;
        case ST_Feuermagie      : strSkillString = "Feuermagie";            break;
        case ST_Wassermagie     : strSkillString = "Wassermagie";           break;
        case ST_Erdmagie        : strSkillString = "Erdmagie";              break;
        case ST_Luftmagie       : strSkillString = "Luftmagie";             break;
        case ST_Mondmagie       : strSkillString = "Mondmagie";             break;
        case ST_Vampirismus     : strSkillString = "Vampirismus";           break;
        case ST_Handel          : strSkillString = "Handel";                break;
        case ST_Reiten          : strSkillString = "Reiten";                break;
        case ST_Entwaffnung     : strSkillString = "Entwaffnung";           break;
        case ST_Faustkampf      : strSkillString = "Faustkampf";            break;
        case ST_Konzentration   : strSkillString = "Konzentration";         break;
        case ST_Ballistik       : strSkillString = "Ballistik";             break;
        case ST_Fallenkunst     : strSkillString = "Fallenkunst";           break;
        case ST_Blutrausch      : strSkillString = "Blutrausch";            break;
        case ST_Waffentechnik   : strSkillString = "Waffentechnik";         break;
        case ST_Zweihandwaffen  : strSkillString = "Zweihandwaffen";        break;
        case ST_Zwergenkunde    : strSkillString = "Zwergenkunde";          break;
        case ST_Hoellenmacht    : strSkillString = "Hllenmacht";           break;
        case ST_Schmiedekunst   : strSkillString = "Schmiedekunst";         break;
        default                 :                                           break;
    }

    return strSkillString;
}

////////////////////////////////////
// CombatArts
////////////////////////////////////

/*static*/ CCombatArtToStringMap CPaxHelper::s_CombatArtMap;

/*static*/ CombatArt CPaxHelper::GetAssociatedCombatArt( CombatArt combatArt )
{
    CombatArt retCombatArt = CA_None;
    switch (combatArt)
    {
        case CA_Vampire_TurnIntoVampire_Knight  : retCombatArt = CA_Vampire_TurnIntoVampire_Knight2 ; break;
        case CA_Vampire_TurnIntoVampire_Knight2 : retCombatArt = CA_Vampire_TurnIntoVampire_Knight  ; break;
        case CA_Vampire_MindControl             : retCombatArt = CA_Vampire_MindControl2            ; break;
        case CA_Vampire_MindControl2            : retCombatArt = CA_Vampire_MindControl             ; break;
        case CA_Vampire_WolfCall                : retCombatArt = CA_Vampire_WolfCall2               ; break;
        case CA_Vampire_WolfCall2               : retCombatArt = CA_Vampire_WolfCall                ; break;
        case CA_Vampire_TimeControl             : retCombatArt = CA_Vampire_TimeControl2            ; break;
        case CA_Vampire_TimeControl2            : retCombatArt = CA_Vampire_TimeControl             ; break;
        case CA_Vampire_WhirlingClaws_MultiHit  : retCombatArt = CA_Vampire_WhirlingClaws_MultiHit2 ; break;
        case CA_Vampire_WhirlingClaws_MultiHit2 : retCombatArt = CA_Vampire_WhirlingClaws_MultiHit  ; break;
        case CA_Vampire_ClawsOfDeath_HardHit    : retCombatArt = CA_Vampire_ClawsOfDeath_HardHit2   ; break;
        case CA_Vampire_ClawsOfDeath_HardHit2   : retCombatArt = CA_Vampire_ClawsOfDeath_HardHit    ; break;
        case CA_Vampire_RippingClaws_Attack     : retCombatArt = CA_Vampire_RippingClaws_Attack2    ; break;
        case CA_Vampire_RippingClaws_Attack2    : retCombatArt = CA_Vampire_RippingClaws_Attack     ; break;
        case CA_Vampire_CombatKick              : retCombatArt = CA_Vampire_CombatKick2             ; break;
        case CA_Vampire_CombatKick2             : retCombatArt = CA_Vampire_CombatKick              ; break;

        case CA_Deamon_BattleDaemon             : retCombatArt = CA_Deamon_BattleDaemon2            ; break;
        case CA_Deamon_BattleDaemon2            : retCombatArt = CA_Deamon_BattleDaemon             ; break;
        case CA_Deamon_SoaringDaemon            : retCombatArt = CA_Deamon_SoaringDaemon2           ; break;
        case CA_Deamon_SoaringDaemon2           : retCombatArt = CA_Deamon_SoaringDaemon            ; break;
        case CA_Deamon_FireDaemon               : retCombatArt = CA_Deamon_FireDaemon2              ; break;
        case CA_Deamon_FireDaemon2              : retCombatArt = CA_Deamon_FireDaemon               ; break;
        case CA_Deamon_PoisonDaemon             : retCombatArt = CA_Deamon_PoisonDaemon2            ; break;
        case CA_Deamon_PoisonDaemon2            : retCombatArt = CA_Deamon_PoisonDaemon             ; break;
        case CA_Deamon_EnergyDaemon             : retCombatArt = CA_Deamon_EnergyDaemon2            ; break;
        case CA_Deamon_EnergyDaemon2            : retCombatArt = CA_Deamon_EnergyDaemon             ; break;

        default: break;
    }
    return retCombatArt;
}

/*static*/ void CPaxHelper::InitCombatArtMap()
{
    s_CombatArtMap.SetAt( CA_Seraphim_LightningStrike             , CString( "Blitzschlag" ));
    s_CombatArtMap.SetAt( CA_Seraphim_CelestialLight              , CString( "Himmelsleuchten" ));
    s_CombatArtMap.SetAt( CA_Seraphim_RotatingBladesOfLight       , CString( "Rotierende Lichtklingen" ));
    s_CombatArtMap.SetAt( CA_Seraphim_Irritation                  , CString( "Irritation" ));
    s_CombatArtMap.SetAt( CA_Seraphim_Conversion                  , CString( "Bekehrung" ));
    s_CombatArtMap.SetAt( CA_Seraphim_Light                       , CString( "Licht" ));
    s_CombatArtMap.SetAt( CA_Seraphim_StrengthOfFaith             , CString( "Glaubensstrke" ));
    s_CombatArtMap.SetAt( CA_Seraphim_ShieldOfLight               , CString( "Lichtschild" ));
    s_CombatArtMap.SetAt( CA_Seraphim_CombatJump                  , CString( "Kampfsprung" ));
    s_CombatArtMap.SetAt( CA_Seraphim_BeeEffGee                   , CString( "BeeEffGee" ));
    s_CombatArtMap.SetAt( CA_Seraphim_EnergyBolts                 , CString( "Energieblitze" ));
    s_CombatArtMap.SetAt( CA_Seraphim_WhirlingHit                 , CString( "Wirbelschlag" ));
    s_CombatArtMap.SetAt( CA_Seraphim_HunterSeeker                , CString( "Jgersucher" ));
    s_CombatArtMap.SetAt( CA_Seraphim_MultiHit                    , CString( "Rundumschlag" ));
    s_CombatArtMap.SetAt( CA_Seraphim_HardHit                     , CString( "Harter Schlag" ));
    s_CombatArtMap.SetAt( CA_Seraphim_Attack                      , CString( "Attacke" ));
    s_CombatArtMap.SetAt( CA_Seraphim_CombatKick                  , CString( "Kampftritt" ));

    s_CombatArtMap.SetAt( CA_Gladiator_StompingJump               , CString( "Stampfsprung" ));
    s_CombatArtMap.SetAt( CA_Gladiator_BackBreaker                , CString( "Rckenbrecher" ));
    s_CombatArtMap.SetAt( CA_Gladiator_FistOfTheGods              , CString( "Fausthieb der Gtter" ));
    s_CombatArtMap.SetAt( CA_Gladiator_ThrowingBlades             , CString( "Schleuderklingen" ));
    s_CombatArtMap.SetAt( CA_Gladiator_Awe                        , CString( "Ehrfurcht" ));
    s_CombatArtMap.SetAt( CA_Gladiator_HeroicCourage              , CString( "Sturm und Drang" ));
    s_CombatArtMap.SetAt( CA_Gladiator_DaggerStare                , CString( "Blicke wie Klingen" ));
    s_CombatArtMap.SetAt( CA_Gladiator_MultiHit                   , CString( "Rundumschlag" ));
    s_CombatArtMap.SetAt( CA_Gladiator_HardHit                    , CString( "Harter Schlag" ));
    s_CombatArtMap.SetAt( CA_Gladiator_Attack                     , CString( "Attacke" ));
    s_CombatArtMap.SetAt( CA_Gladiator_CombatKick                 , CString( "Kampftritt" ));

    s_CombatArtMap.SetAt( CA_Mage_PhaseShift                      , CString( "Phasenverschiebung" ));
    s_CombatArtMap.SetAt( CA_Mage_StoneSkin                       , CString( "Steinhaut" ));
    s_CombatArtMap.SetAt( CA_Mage_WaterForm                       , CString( "Wasserform" ));
    s_CombatArtMap.SetAt( CA_Mage_FireBall                        , CString( "Feuerball" ));
    s_CombatArtMap.SetAt( CA_Mage_SpiritualHealing                , CString( "Spirituelle Heilkraft" ));
    s_CombatArtMap.SetAt( CA_Mage_FireSpiral                      , CString( "Feuerspirale" ));
    s_CombatArtMap.SetAt( CA_Mage_CircleOfFear                    , CString( "Bannkreis der Angst" ));
    s_CombatArtMap.SetAt( CA_Mage_Purgatory                       , CString( "Fegefeuer" ));
    s_CombatArtMap.SetAt( CA_Mage_FlameSkin                       , CString( "Flammenhaut" ));
    s_CombatArtMap.SetAt( CA_Mage_Petrification                   , CString( "Fleisch zu Stein" ));
    s_CombatArtMap.SetAt( CA_Mage_MeteorStrom                     , CString( "Meteoritenhagel" ));
    s_CombatArtMap.SetAt( CA_Mage_CataractOfAgility               , CString( "Katarakt der Wendigkeit" ));
    s_CombatArtMap.SetAt( CA_Mage_Whirlwind                       , CString( "Wirbelwind" ));
    s_CombatArtMap.SetAt( CA_Mage_GustOfWind                      , CString( "Windbe" ));
    s_CombatArtMap.SetAt( CA_Mage_ShieldWall                      , CString( "Schildwall" ));
    s_CombatArtMap.SetAt( CA_Mage_GhostMeadow                     , CString( "Aue des Geistes" ));
    s_CombatArtMap.SetAt( CA_Mage_Reiki                           , CString( "Reiki" ));
    s_CombatArtMap.SetAt( CA_Mage_LightningStrike                 , CString( "Kettenblitz" ));
    s_CombatArtMap.SetAt( CA_Mage_IceShards                       , CString( "Eissplitter" ));
    s_CombatArtMap.SetAt( CA_Mage_RingOfIce                       , CString( "Frostring" ));

    s_CombatArtMap.SetAt( CA_DarkElf_Cobra                        , CString( "Kobra" ));
    s_CombatArtMap.SetAt( CA_DarkElf_Mongoose                     , CString( "Mungo" ));
    s_CombatArtMap.SetAt( CA_DarkElf_SoulCatcher                  , CString( "Seelenruber" ));
    s_CombatArtMap.SetAt( CA_DarkElf_PakDain_ProjectileDeflection , CString( "Projektilumleitung (Pak-Dain)" ));
    s_CombatArtMap.SetAt( CA_DarkElf_PakNakor_MagicDeflection     , CString( "Magieumleitung (Pak-Nakor)" ));
    s_CombatArtMap.SetAt( CA_DarkElf_Testosterone                 , CString( "Testosteron" ));
    s_CombatArtMap.SetAt( CA_DarkElf_Adrenaline                   , CString( "Adrenalin" ));
    s_CombatArtMap.SetAt( CA_DarkElf_ExplosiveCharge              , CString( "Sprengsatz" ));
    s_CombatArtMap.SetAt( CA_DarkElf_BottomlessPit                , CString( "Hllenschlund" ));
    s_CombatArtMap.SetAt( CA_DarkElf_Confusion                    , CString( "Verwirrung" ));
    s_CombatArtMap.SetAt( CA_DarkElf_PoisonMist                   , CString( "Gifthauch" ));
    s_CombatArtMap.SetAt( CA_DarkElf_BattleFog                    , CString( "Schlachtennebel" ));
    s_CombatArtMap.SetAt( CA_DarkElf_SuddenFury_MultiHit          , CString( "Rundumschlag (Jhzorn)" ));
    s_CombatArtMap.SetAt( CA_DarkElf_Revege_HardHit               , CString( "Harter Schlag" ));
    s_CombatArtMap.SetAt( CA_DarkElf_Rage_Attack                  , CString( "Attacke (Rage)" ));
    s_CombatArtMap.SetAt( CA_DarkElf_CombatKick                   , CString( "Kampftritt" ));

    s_CombatArtMap.SetAt( CA_WoodElf_CompanionOfTheWoods          , CString( "Gefhrtin des Waldes" ));
    s_CombatArtMap.SetAt( CA_WoodElf_Transformation               , CString( "Verwandlung" ));
    s_CombatArtMap.SetAt( CA_WoodElf_QuickAsAFlash                , CString( "Wieselflink" ));
    s_CombatArtMap.SetAt( CA_WoodElf_ThornBush                    , CString( "Dornenkugel" ));
    s_CombatArtMap.SetAt( CA_WoodElf_PoisonedTendrils             , CString( "Giftranken" ));
    s_CombatArtMap.SetAt( CA_WoodElf_PlantCage                    , CString( "Pflanzenkfig" ));
    s_CombatArtMap.SetAt( CA_WoodElf_CallOfTheAncestors           , CString( "Ruf der Ahnen" ));
    s_CombatArtMap.SetAt( CA_WoodElf_Regeneration                 , CString( "Genesung" ));
    s_CombatArtMap.SetAt( CA_WoodElf_ExplosiveArrow               , CString( "Explosionspfeil" ));
    s_CombatArtMap.SetAt( CA_WoodElf_MultipleShot                 , CString( "Mehrfachschuss" ));
    s_CombatArtMap.SetAt( CA_WoodElf_SpiderArrow                  , CString( "Spinnenpfeil" ));
    s_CombatArtMap.SetAt( CA_WoodElf_KnockbackArrow               , CString( "Keulenpfeil" ));
    s_CombatArtMap.SetAt( CA_WoodElf_PenetratingArrow             , CString( "Klingenpfeil" ));
    s_CombatArtMap.SetAt( CA_WoodElf_MultiHit                     , CString( "Rundumschlag" ));
    s_CombatArtMap.SetAt( CA_WoodElf_HardHit                      , CString( "Harter Schlag" ));
    s_CombatArtMap.SetAt( CA_WoodElf_EyeForAnEye_Attack           , CString( "Auge um Auge (Attacke)" ));

    s_CombatArtMap.SetAt( CA_Vampire_TurnIntoVampire_Knight       , CString( "Vampirform / Ritterform" ));
    s_CombatArtMap.SetAt( CA_Vampire_TurnIntoVampire_Knight2      , CString( "Vampirform / Ritterform" ));
    s_CombatArtMap.SetAt( CA_Vampire_MindControl                  , CString( "Beherrschung" ));
    s_CombatArtMap.SetAt( CA_Vampire_MindControl2                 , CString( "Beherrschung" ));
    s_CombatArtMap.SetAt( CA_Vampire_WolfCall                     , CString( "Wolfsruf" ));
    s_CombatArtMap.SetAt( CA_Vampire_WolfCall2                    , CString( "Wolfsruf" ));
    s_CombatArtMap.SetAt( CA_Vampire_TimeControl                  , CString( "Zeitbeherrschung" ));
    s_CombatArtMap.SetAt( CA_Vampire_TimeControl2                 , CString( "Zeitbeherrschung" ));
    s_CombatArtMap.SetAt( CA_Vampire_BloodBite                    , CString( "Blutbiss" ));
    s_CombatArtMap.SetAt( CA_Vampire_MasterBite                   , CString( "Meisterbiss" ));
    s_CombatArtMap.SetAt( CA_Vampire_CombatJump                   , CString( "Klauensprung" ));
    s_CombatArtMap.SetAt( CA_Vampire_BloodKiss                    , CString( "Blutkuss" ));
    s_CombatArtMap.SetAt( CA_Vampire_AwakenDead                   , CString( "Erweckung" ));
    s_CombatArtMap.SetAt( CA_Vampire_Bats_BloodSwarm              , CString( "Fledermuse: Blutschwarm" ));
    s_CombatArtMap.SetAt( CA_Vampire_Bats_Confusion               , CString( "Fledermuse: Verwirrung" ));
    s_CombatArtMap.SetAt( CA_Vampire_Bats_Guard                   , CString( "Fledermuse: Wchter" ));
    s_CombatArtMap.SetAt( CA_Vampire_WhirlingClaws_MultiHit2      , CString( "Rundumschlag / Wirbelklauen" ));
    s_CombatArtMap.SetAt( CA_Vampire_ClawsOfDeath_HardHit2        , CString( "Harter Schlag / Todesklauen" ));
    s_CombatArtMap.SetAt( CA_Vampire_RippingClaws_Attack2         , CString( "Attacke / Reiende Klauen" ));
    s_CombatArtMap.SetAt( CA_Vampire_CombatKick2                  , CString( "Kampftritt" ));
    s_CombatArtMap.SetAt( CA_Vampire_WhirlingClaws_MultiHit       , CString( "Rundumschlag / Wirbelklauen" ));
    s_CombatArtMap.SetAt( CA_Vampire_ClawsOfDeath_HardHit         , CString( "Harter Schlag / Todesklauen" ));
    s_CombatArtMap.SetAt( CA_Vampire_RippingClaws_Attack          , CString( "Attacke / Reiende Klauen" ));
    s_CombatArtMap.SetAt( CA_Vampire_CombatKick                   , CString( "Kampftritt" ));

    s_CombatArtMap.SetAt( CA_Dwarf_Greed                          , CString( "Gier" ));
    s_CombatArtMap.SetAt( CA_Dwarf_Landmine                       , CString( "Tellerminen" ));
    s_CombatArtMap.SetAt( CA_Dwarf_Entrench                       , CString( "Eingraben" ));
    s_CombatArtMap.SetAt( CA_Dwarf_DwarvenArmor                   , CString( "Zwergenpanzer" ));
    s_CombatArtMap.SetAt( CA_Dwarf_DwarvenSteel                   , CString( "Zwergenstahl" ));
    s_CombatArtMap.SetAt( CA_Dwarf_Wrath                          , CString( "Rundumschlag" ));
    s_CombatArtMap.SetAt( CA_Dwarf_HeavyBlow                      , CString( "Harter Schlag" ));
    s_CombatArtMap.SetAt( CA_Dwarf_Assault                        , CString( "Attacke" ));
    s_CombatArtMap.SetAt( CA_Dwarf_BattleRage                     , CString( "Kriegsrausch" ));
    s_CombatArtMap.SetAt( CA_Dwarf_Recoil                         , CString( "Abschlag" ));
    s_CombatArtMap.SetAt( CA_Dwarf_Vehemence                      , CString( "Wucht" ));
    s_CombatArtMap.SetAt( CA_Dwarf_FlameThrower                   , CString( "Flammenwerfer" ));
    s_CombatArtMap.SetAt( CA_Dwarf_MortarGrenade                  , CString( "Mrsergranate" ));
    s_CombatArtMap.SetAt( CA_Dwarf_CannonBlast                    , CString( "Kanonenschuss" ));
    s_CombatArtMap.SetAt( CA_Dwarf_WarCry                         , CString( "Kriegsschrei" ));

    s_CombatArtMap.SetAt( CA_Deamon_BlazingDisc                   , CString( "Hllendiskus" ));
    s_CombatArtMap.SetAt( CA_Deamon_CallOfDeath                   , CString( "Ruf des Todes" ));
    s_CombatArtMap.SetAt( CA_Deamon_InfernalPower                 , CString( "Hllenkraft" ));
    s_CombatArtMap.SetAt( CA_Deamon_HellSphere                    , CString( "Hllenfeuer" ));
    s_CombatArtMap.SetAt( CA_Deamon_Tentacles                     , CString( "Tentakel" ));
    s_CombatArtMap.SetAt( CA_Deamon_AbysmalChoir                  , CString( "Chor der Hlle" ));
    s_CombatArtMap.SetAt( CA_Deamon_Dread                         , CString( "Hllenfurcht" ));
    s_CombatArtMap.SetAt( CA_Deamon_SoaringDaemon                 , CString( "Flugdmon Sturzflug (Harter Schlag)" ));
    s_CombatArtMap.SetAt( CA_Deamon_BattleDaemon2                 , CString( "Kampfdmon Attacke" ));
    s_CombatArtMap.SetAt( CA_Deamon_SoaringDaemon2                , CString( "Flugdmon Sturzflug (Harter Schlag)" ));
    s_CombatArtMap.SetAt( CA_Deamon_BattleDaemon                  , CString( "Kampfdmon Attacke" ));
    s_CombatArtMap.SetAt( CA_Deamon_FireDaemon2                   , CString( "Feuerdmon Flammenwand" ));
    s_CombatArtMap.SetAt( CA_Deamon_PoisonDaemon                  , CString( "Giftdmon Giftring" ));
    s_CombatArtMap.SetAt( CA_Deamon_EnergyDaemon                  , CString( "Energiedmon Energieblitze" ));
    s_CombatArtMap.SetAt( CA_Deamon_PoisonDaemon2                 , CString( "Giftdmon Giftring" ));
    s_CombatArtMap.SetAt( CA_Deamon_FireDaemon                    , CString( "Feuerdmon Flammenwand" ));
    s_CombatArtMap.SetAt( CA_Deamon_EnergyDaemon2                 , CString( "Energiedmon Energieblitze" ));
}

/*static*/ CString CPaxHelper::GetCombatArtString( CombatArt combatArt )
{
    if (CPaxHelper::s_CombatArtMap.GetCount() <= 0)
    {
        CPaxHelper::s_CombatArtMap.RemoveAll();
        CPaxHelper::InitCombatArtMap();
    }

    CString strCombatArt;
    CPaxHelper::s_CombatArtMap.Lookup( combatArt, strCombatArt );

    return strCombatArt;
}

////////////////////////////////////
// Bonuses
////////////////////////////////////

/*static*/ CBonusTypeToStringMap CPaxHelper::s_BonusTypeMap;

/*static*/ CString CPaxHelper::GetBonusCounterActsForString( BonusCounterActsFor bcaf )
{
    CString strBCAF;

    switch (bcaf)
    {
        case BCAF_None          : strBCAF= "gegen alle Gegner"; break;
        case BCAF_Helden        : strBCAF= "gegen Helden"; break;
        case BCAF_Monster       : strBCAF= "gegen Monster"; break;
        case BCAF_Neutrale      : strBCAF= "gegen Neutrale"; break;
        case BCAF_Pferde        : strBCAF= "gegen Pferde"; break;
        case BCAF_Untote        : strBCAF= "gegen Untote"; break;
        case BCAF_Tiere         : strBCAF= "gegen Tiere"; break;
        case BCAF_Soeldner      : strBCAF= "gegen Sldner"; break;
        case BCAF_Goblins       : strBCAF= "gegen Goblins"; break;
        case BCAF_Daemonen      : strBCAF= "gegen Dmonen"; break;
        case BCAF_Drachen       : strBCAF= "gegen Drachen"; break;
        case BCAF_Energiewesen  : strBCAF= "gegen Energiewesen"; break;
        case BCAF_Elfen         : strBCAF= "gegen Elfen"; break;
        case BCAF_Fernkaempfer  : strBCAF= "gegen Fernkmpfer"; break;
        case BCAF_Berittene     : strBCAF= "gegen Berittene"; break;
        default                 : strBCAF.Format( "? (%u = 0x%X)", bcaf, bcaf );
    }

    return strBCAF;
}

/*static*/ CString CPaxHelper::GetBonusActsForString( BonusActsFor baf )
{
    CString strBAF;

    switch (baf)
    {
        case BAF_All        : strBAF = "fr alle Chars"; break;
        case BAF_Seraphim   : strBAF = "nur fr Seraphim"; break;// 1,
        case BAF_Gladiator  : strBAF = "nur fr Gladiator"; break;// 2,
        case BAF_Kampfmagier: strBAF = "nur fr Kampfmagier"; break;// 3,
        case BAF_Dunkelelf  : strBAF = "nur fr Dunkelelf"; break;// 4,
        case BAF_Waldelfe   : strBAF = "nur fr Waldelfe"; break;// 5,
        case BAF_Vampirin   : strBAF = "nur fr Vampirin"; break;// 6,
        case BAF_Zwerg      : strBAF = "nur fr Zwerg"; break;// 8,
        case BAF_Daemonin   : strBAF = "nur fr Dmonin"; break;// 9,
        default             : strBAF.Format( "? (%u = 0x%X)", baf, baf );
    }

    return strBAF;
}

/*static*/ CString CPaxHelper::GetBonusTypeString( BonusType bonusType )
{
    if (CPaxHelper::s_BonusTypeMap.GetCount() <= 0)
    {
        CPaxHelper::s_BonusTypeMap.RemoveAll();
        CPaxHelper::InitBonusTypeMap();
    }

    CString strBonusType;
    CPaxHelper::s_BonusTypeMap.Lookup( bonusType, strBonusType );

    return strBonusType;
}

/*static*/ CString CPaxHelper::GetBonusTypeString( POSITION & pos, BonusType & bonusType )
{
    if (CPaxHelper::s_BonusTypeMap.GetCount() <= 0)
    {
        CPaxHelper::s_BonusTypeMap.RemoveAll();
        CPaxHelper::InitBonusTypeMap();
    }

    CString strBonusType;
    CPaxHelper::s_BonusTypeMap.GetNextAssoc( pos, bonusType, strBonusType );

    return strBonusType;
}

/*static*/ POSITION CPaxHelper::GetFirstBonusType()
{
    if (CPaxHelper::s_BonusTypeMap.GetCount() <= 0)
    {
        CPaxHelper::s_BonusTypeMap.RemoveAll();
        CPaxHelper::InitBonusTypeMap();
    }

    return CPaxHelper::s_BonusTypeMap.GetStartPosition();
}

/*static*/ void CPaxHelper::InitBonusTypeMap()
{
    s_BonusTypeMap.SetAt( BT_None                     , " <nicht vorhanden>" );// 0,
    s_BonusTypeMap.SetAt( BT_Phasenverschiebung       , "Phasenverschiebung" );// 1,
    s_BonusTypeMap.SetAt( BT_Steinhaut                , "Steinhaut" );// 2,
    s_BonusTypeMap.SetAt( BT_Gefaehrtin_des_Waldes    , "Gefhrtin des Waldes" );// 3,
    s_BonusTypeMap.SetAt( BT_Wasserform               , "Wasserform" );// 4,
    s_BonusTypeMap.SetAt( BT_Feuerball                , "Feuerball" );// 5,
    s_BonusTypeMap.SetAt( BT_Pentagramm               , "Pentagramm" );// 6,
    s_BonusTypeMap.SetAt( BT_Spirituelle_Heilkraft    , "Spirituelle Heilkraft" );// 7,
    s_BonusTypeMap.SetAt( BT_Kugelblitz               , "Kugelblitz" );// 8,
    s_BonusTypeMap.SetAt( BT_Goettliche_Gabe          , "Gttliche_Gabe" );// 9,
    s_BonusTypeMap.SetAt( BT_Morph                    , "Morph" );// 10,
    s_BonusTypeMap.SetAt( BT_Feuerspirale             , "Feuerspirale" );// 11,
    s_BonusTypeMap.SetAt( BT_Groundpoison             , "Groundpoison" );// 12,
    s_BonusTypeMap.SetAt( BT_Blitzschlag              , "Blitzschlag" );// 13,
    s_BonusTypeMap.SetAt( BT_Breeze                   , "Breeze" );// 14,
    s_BonusTypeMap.SetAt( BT_Himmelsleuchten          , "Himmelsleuchten" );// 15,
    s_BonusTypeMap.SetAt( BT_Bannkreis_der_Angst      , "Bannkreis der Angst" );// 16,
    s_BonusTypeMap.SetAt( BT_Rotierende_Lichtklingen  , "Rotierende Lichtklingen" );// 17,
    s_BonusTypeMap.SetAt( BT_Irritation               , "Irritation" );// 18,
    s_BonusTypeMap.SetAt( BT_Bekehrung                , "Bekehrung" );// 19,
    s_BonusTypeMap.SetAt( BT_Licht                    , "Licht" );// 20,
    s_BonusTypeMap.SetAt( BT_Glaubensstaerke          , "Glaubensstrke" );// 21,
    s_BonusTypeMap.SetAt( BT_Lichtschild              , "Lichtschild" );// 22,
    s_BonusTypeMap.SetAt( BT_Fegefeuer                , "Fegefeuer" );// 23,
    s_BonusTypeMap.SetAt( BT_Flammenhaut              , "Flammenhaut" );// 24,
    s_BonusTypeMap.SetAt( BT_Fleisch_zu_Stein         , "Fleisch zu Stein" );// 25,
    s_BonusTypeMap.SetAt( BT_Meteoritenhagel          , "Meteoritenhagel" );// 26,
    s_BonusTypeMap.SetAt( BT_Katarakt_der_Wendigkeit  , "Katarakt der Wendigkeit" );// 27,
    s_BonusTypeMap.SetAt( BT_Wirbelwind               , "Wirbelwind" );// 28,
    s_BonusTypeMap.SetAt( BT_Windboee                 , "Windbe" );// 29,
    s_BonusTypeMap.SetAt( BT_Schildwall               , "Schildwall" );// 30,
    s_BonusTypeMap.SetAt( BT_Aue_des_Geistes          , "Aue des Geistes" );// 31,
    s_BonusTypeMap.SetAt( BT_Reiki                    , "Reiki" );// 32,
    s_BonusTypeMap.SetAt( BT_Kettenblitz              , "Kettenblitz" );// 33,
    s_BonusTypeMap.SetAt( BT_Eissplitter              , "Eissplitter" );// 34,
    s_BonusTypeMap.SetAt( BT_Frostring                , "Frostring" );// 35,
    s_BonusTypeMap.SetAt( BT_Verwandlung              , "Verwandlung" );// 36,
    s_BonusTypeMap.SetAt( BT_Wieselflink              , "Wieselflink" );// 37,
    s_BonusTypeMap.SetAt( BT_Dornenkugel              , "Dornenkugel" );// 38,
    s_BonusTypeMap.SetAt( BT_Giftranken               , "Giftranken" );// 39,
    s_BonusTypeMap.SetAt( BT_Pflanzenkaefig           , "Pflanzenkfig" );// 40,
    s_BonusTypeMap.SetAt( BT_Ruf_der_Ahnen            , "Ruf der Ahnen" );// 41,
    s_BonusTypeMap.SetAt( BT_Genesung                 , "Genesung" );// 42,
    s_BonusTypeMap.SetAt( BT_Kriegsschrei1            , "Kriegsschrei1" );// 43,
    s_BonusTypeMap.SetAt( BT_Gier1                    , "Gier" );// 44,
    s_BonusTypeMap.SetAt( BT_Tellerminen1             , "Tellerminen" );// 45,
    s_BonusTypeMap.SetAt( BT_Eingraben1               , "Eingraben" );// 46,
    s_BonusTypeMap.SetAt( BT_Zwergenstahl1            , "Zwergenstahl" );// 47,
    s_BonusTypeMap.SetAt( BT_Zwergenpanzer1           , "Zwergenpanzer" );// 48,
    s_BonusTypeMap.SetAt( BT_Hoellendiskus1           , "Hllendiskus" );// 49,
    s_BonusTypeMap.SetAt( BT_Feuerwand1               , "Feuerwand" );// 50,
    s_BonusTypeMap.SetAt( BT_Giftwolke1               , "Giftwolke" );// 51,
    s_BonusTypeMap.SetAt( BT_Kugelblitze1             , "Kugelblitze" );// 52,
    s_BonusTypeMap.SetAt( BT_Kugelblitze2             , "Kugelblitze" );// 53,
    s_BonusTypeMap.SetAt( BT_Gier2                    , "Gier" );// 54,
    s_BonusTypeMap.SetAt( BT_Tellerminen2             , "Tellerminen" );// 55,
    s_BonusTypeMap.SetAt( BT_Eingraben2               , "Eingraben" );// 57,
    s_BonusTypeMap.SetAt( BT_Zwergenpanzer2           , "Zwergenpanzer" );// 58,
    s_BonusTypeMap.SetAt( BT_Zwergenstahl2            , "Zwergenstahl" );// 59,
    s_BonusTypeMap.SetAt( BT_Hoellendiskus2           , "Hllendiskus" );// 60,
    s_BonusTypeMap.SetAt( BT_Kugelblitze3             , "Kugelblitze" );// 61,
    s_BonusTypeMap.SetAt( BT_Ruf_des_Todes            , "Ruf des Todes" );// 62,
    s_BonusTypeMap.SetAt( BT_Hoellenkraft             , "Hllenkraft" );// 63,
    s_BonusTypeMap.SetAt( BT_Flammenwaechter          , "Flammenwchter" );// 64,
    s_BonusTypeMap.SetAt( BT_Tentakel                 , "Tentakel" );// 65,
    s_BonusTypeMap.SetAt( BT_Chor_der_Hoelle          , "Chor der Hlle" );// 66,
    s_BonusTypeMap.SetAt( BT_Hoellenfurcht            , "Hllenfurcht" );// 67,
    s_BonusTypeMap.SetAt( BT_Kugelblitze4             , "Kugelblitze" );// 68,
    s_BonusTypeMap.SetAt( BT_Kugelblitze5             , "Kugelblitze" );// 69,
    s_BonusTypeMap.SetAt( BT_Kugelblitze6             , "Kugelblitze" );// 70,
    s_BonusTypeMap.SetAt( BT_Kugelblitze7             , "Kugelblitze" );// 71,

    s_BonusTypeMap.SetAt( BT_Himmelsmagie     , "Himmelsmagie" );// 600,
    s_BonusTypeMap.SetAt( BT_Waffenkunde      , "Waffenkunde" );// 601,
    s_BonusTypeMap.SetAt( BT_Stangenwaffen    , "Stangenwaffen" );// 602,
    s_BonusTypeMap.SetAt( BT_Schwertkunde     , "Schwertkunde" );// 603,
    s_BonusTypeMap.SetAt( BT_Axtkampf         , "Axtkampf" );// 604,
    s_BonusTypeMap.SetAt( BT_Zweiwaffenkampf  , "Zweiwaffenkampf" );// 605,
    s_BonusTypeMap.SetAt( BT_Fernkampf        , "Fernkampf" );// 606,
    s_BonusTypeMap.SetAt( BT_Wendigkeit       , "Wendigkeit" );// 607,
    s_BonusTypeMap.SetAt( BT_Parade           , "Parade" );// 608,
    s_BonusTypeMap.SetAt( BT_Konstitution     , "Konstitution" );// 609,
    s_BonusTypeMap.SetAt( BT_Ruestung         , "Rstung" );// 610,
    s_BonusTypeMap.SetAt( BT_Meditation       , "Meditation" );// 611,
    s_BonusTypeMap.SetAt( BT_Klingenkampf     , "Klingenkampf" );// 612,
    s_BonusTypeMap.SetAt( BT_Magiekunde       , "Magiekunde" );// 613,
    s_BonusTypeMap.SetAt( BT_Feuermagie       , "Feuermagie" );// 614,
    s_BonusTypeMap.SetAt( BT_Wassermagie      , "Wassermagie" );// 615,
    s_BonusTypeMap.SetAt( BT_Erdmagie         , "Erdmagie" );// 616,
    s_BonusTypeMap.SetAt( BT_Luftmagie        , "Luftmagie" );// 617,
    s_BonusTypeMap.SetAt( BT_Mondmagie        , "Mondmagie" );// 618,
    s_BonusTypeMap.SetAt( BT_Vampirismus      , "Vampirismus" );// 619,
    s_BonusTypeMap.SetAt( BT_Handel           , "Handel" );// 620,
    s_BonusTypeMap.SetAt( BT_Reiten           , "Reiten" );// 621,
    s_BonusTypeMap.SetAt( BT_Entwaffnung      , "Entwaffnung" );// 622,
    s_BonusTypeMap.SetAt( BT_Faustkampf       , "Faustkampf" );// 623,
    s_BonusTypeMap.SetAt( BT_Konzentration    , "Konzentration" );// 624,
    s_BonusTypeMap.SetAt( BT_Ballistik        , "Ballistik" );// 625,
    s_BonusTypeMap.SetAt( BT_Fallenkunst      , "Fallenkunst" );// 626,
    s_BonusTypeMap.SetAt( BT_Blutrausch       , "Blutrausch" );// 627,
    s_BonusTypeMap.SetAt( BT_Waffentechnik    , "Waffentechnik" );// 628,
    s_BonusTypeMap.SetAt( BT_Zweihandwaffen   , "Zweihandwaffen" );// 629,
    s_BonusTypeMap.SetAt( BT_Zwergenkunde     , "Zwergenkunde" );// 630,
    s_BonusTypeMap.SetAt( BT_Hoellenmacht     , "Hllenmacht" );// 631,
    s_BonusTypeMap.SetAt( BT_Schmiedekunst    , "Schmiedekunst" );// 632,

    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch               , "Waffenschaden Physisch" );// 801,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer                  , "Waffenschaden Feuer" );// 802,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch                , "Waffenschaden Magisch" );// 803,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift                   , "Waffenschaden Gift" );// 804,
    s_BonusTypeMap.SetAt( BT_Physisch_Schaden_Prozent             , "Physisch Schaden (%)" );// 805,
    s_BonusTypeMap.SetAt( BT_Feuer_Schaden_Prozent                , "Feuer Schaden (%)" );// 806,
    s_BonusTypeMap.SetAt( BT_Magisch_Schaden_Prozent              , "Magisch Schaden (%)" );// 807,
    s_BonusTypeMap.SetAt( BT_Gift_Schaden_Prozent                 , "Gift Schaden (%)" );// 808,
    s_BonusTypeMap.SetAt( BT_Angriff_Prozent                      , "% auf Angriff" );// 809,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent                 , "% auf Verteidigung" );// 810,
    s_BonusTypeMap.SetAt( BT_Angriffstempo                        , "Angriffstempo" );// 811,
    s_BonusTypeMap.SetAt( BT_Geschwindigkeit                      , "Geschwindigkeit" );// 812,
    s_BonusTypeMap.SetAt( BT_Regeneration_Zauber_Prozent          , "Regeneration Zauber (%)" );// 813,
    s_BonusTypeMap.SetAt( BT_Regeneration_Special_Move_Prozent    , "Regeneration Special Move (%)" );// 814,
    s_BonusTypeMap.SetAt( BT_Staerke                              , "Strke" );// 815,
    s_BonusTypeMap.SetAt( BT_Geschick                             , "Geschicklichkeit" );// 816,
    s_BonusTypeMap.SetAt( BT_Widerstand                           , "Widerstand" );// 817,
    s_BonusTypeMap.SetAt( BT_PhysReg                              , "Physische Regeneration" );// 818,
    s_BonusTypeMap.SetAt( BT_MentReg                              , "Mentale Regeneration" );// 819,
    s_BonusTypeMap.SetAt( BT_Charisma                             , "Charisma" );// 820,

    s_BonusTypeMap.SetAt( BT_Besondere_Gegenstaende_finden            , "Besondere Gegenstnde finden" );// 840,
    s_BonusTypeMap.SetAt( BT_Leben_absaugen_Prozent                   , "Pro Schlag Gegner Leben absaugen (%)" );// 841,
    s_BonusTypeMap.SetAt( BT_Eigenes_Leben_verlieren_Prozent          , "Pro Schlag eigenes Leben verlieren (%)" );// 842,
    s_BonusTypeMap.SetAt( BT_Erfahrung_von_Gegnern_Prozent            , "Erfahrung von Gegnern (%)" );// 843,
    s_BonusTypeMap.SetAt( BT_Auf_alle_Magiesprueche                   , "Auf alle Magiesprche" );// 844,
    s_BonusTypeMap.SetAt( BT_Auf_alle_Special_Moves                   , "Auf alle Special Moves" );// 845,
    s_BonusTypeMap.SetAt( BT_Zerteilen_Prozent                        , "Zerteilen (%)" );// 846,
    s_BonusTypeMap.SetAt( BT_Alle_Resistenzen_Prozent                 , "Auf alle Resistenzen (%)" );// 847,
    s_BonusTypeMap.SetAt( BT_Angriff_und_Verteidigung_Prozent         , "Auf Angriff und Verteidigung (%)" );// 848,
    s_BonusTypeMap.SetAt( BT_Auf_alle_Fertigkeiten                    , "Auf alle Fertigkeiten" );// 849,
    s_BonusTypeMap.SetAt( BT_Verlaengerte_Nacht_Prozent               , "Verlngerte Nacht (%)" );// 850,
    s_BonusTypeMap.SetAt( BT_Verlaengerter_Tag_Prozent                , "Verlngerter Tag (%)" );// 851,
    s_BonusTypeMap.SetAt( BT_Gegner_sterben_bei_Blickkontakt_Prozent  , "Gegner sterben bei Blickkontakt (%)" );// 852,
    s_BonusTypeMap.SetAt( BT_Weitsicht_Minimap                        , "Weitsicht auf Minimap" );// 853,

    s_BonusTypeMap.SetAt( BT_Chance_Fluggegner_zu_binden_Prozent                      , "Chance, Fluggegner zu binden (%)" );// 855,
    s_BonusTypeMap.SetAt( BT_Chance_bei_Treffer_Gold_von_Gegner_zu_erhalten_Prozent   , "Chance, bei Treffer Gold von Gegner zu erhalten (%)" );// 856,
    s_BonusTypeMap.SetAt( BT_Chance_auf_offene_Wunden_Prozent                         , "Chance auf offene Wunden (%)" );// 857,
    s_BonusTypeMap.SetAt( BT_Widerstand_gegen_Zauber                                  , "Widerstand gegen Zauber" );// 858,
    s_BonusTypeMap.SetAt( BT_Kritische_Treffer_landen                                 , "Kritische Treffer landen" );// 859,
    s_BonusTypeMap.SetAt( BT_Erhoeht_alle_Schadensarten_Prozent                       , "Erhht alle Schadensarten (%)" );// 860,
    s_BonusTypeMap.SetAt( BT_Widerstand_gegen_Betaeubung                              , "Widerstand gegen Betubung" );// 861,
    s_BonusTypeMap.SetAt( BT_Gegner_schocken                                          , "Gegner schocken" );// 862,
    s_BonusTypeMap.SetAt( BT_Untote_endgueltig_bannen                                 , "Untote endgltig bannen" );// 863,
    s_BonusTypeMap.SetAt( BT_Ermoeglicht_das_Angreifen_von_Tieren                     , "Ermglicht das Angreifen von Tieren" );// 864,
    s_BonusTypeMap.SetAt( BT_Erweiterter_Lichtradius                                  , "Erweiterter_Lichtradius" );// 865,
    s_BonusTypeMap.SetAt( BT_Schaden_von_Goldvorat_abziehen_Prozent                   , "Schaden von Goldvorat abziehen (%)" );// 866,
    s_BonusTypeMap.SetAt( BT_Verwundung_erhoeht_ausgeteilten_Schaden_Prozent          , "Verwundung erhht ausgeteilten Schaden (%)" );// 867,
    s_BonusTypeMap.SetAt( BT_Zusaetzliche_Traenke_finden                              , "Zustzliche Trnke finden" );// 868,

    s_BonusTypeMap.SetAt( BT_Rundumschlag1    , "Rundumschlag" );// 1000,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag1   , "Harter Schlag" );// 1001,
    s_BonusTypeMap.SetAt( BT_Attacke1         , "Attacke" );// 1002,
    s_BonusTypeMap.SetAt( BT_Stampfsprung     , "Stampfsprung" );// 1003,
    s_BonusTypeMap.SetAt( BT_Explosionspfeil  , "Explosionspfeil" );// 1004,
    s_BonusTypeMap.SetAt( BT_Mehrfachschuss   , "Mehrfachschuss" );// 1005,
    s_BonusTypeMap.SetAt( BT_Spinnenpfeil     , "Spinnenpfeil" );// 1006,
    s_BonusTypeMap.SetAt( BT_Keulenpfeil      , "Keulenpfeil" );// 1007,
    s_BonusTypeMap.SetAt( BT_Klingenpfeil     , "Klingenpfeil" );// 1008,
    s_BonusTypeMap.SetAt( BT_Kampftritt1      , "Kampftritt1" );// 1009,
    s_BonusTypeMap.SetAt( BT_Rueckenbrecher   , "Rckenbrecher" );// 1010,

    s_BonusTypeMap.SetAt( BT_Fausthieb_der_Goetter        , "Fausthieb der Gtter" );// 1012,
    s_BonusTypeMap.SetAt( BT_Schleuderklingen             , "Schleuderklingen" );// 1013,
    s_BonusTypeMap.SetAt( BT_Ehrfurcht                    , "Ehrfurcht" );// 1014,
    s_BonusTypeMap.SetAt( BT_Sturm_und_Drang              , "Sturm und Drang" );// 1015,
    s_BonusTypeMap.SetAt( BT_Blicke_wie_Klingen           , "Blicke wie Klingen" );// 1016,
    s_BonusTypeMap.SetAt( BT_Kampfsprung                  , "Kampfsprung" );// 1017,
    s_BonusTypeMap.SetAt( BT_BeeEffGee                    , "BeeEffGee" );// 1018,
    s_BonusTypeMap.SetAt( BT_Energieblitze                , "Energieblitze" );// 1019,
    s_BonusTypeMap.SetAt( BT_Wirbelschlag                 , "Wirbelschlag" );// 1020,
    s_BonusTypeMap.SetAt( BT_Flic_Flac                    , "Flic Flac" );// 1021,
    s_BonusTypeMap.SetAt( BT_Vampirform                   , "Vampirform" );// 1022,
    s_BonusTypeMap.SetAt( BT_Ritterform                   , "Ritterform" );// 1023,
    s_BonusTypeMap.SetAt( BT_Beherrschung                 , "Beherrschung" );// 1024,
    s_BonusTypeMap.SetAt( BT_Beherrschung_Vampirin        , "Beherrschung (Vampirin)" );// 1025,
    s_BonusTypeMap.SetAt( BT_Wolfsruf                     , "Wolfsruf" );// 1026,
    s_BonusTypeMap.SetAt( BT_Wolfsruf_Vampirin            , "Wolfsruf (Vampirin)" );// 1027,
    s_BonusTypeMap.SetAt( BT_Zeitbeherrschung             , "Zeitbeherrschung" );// 1028,
    s_BonusTypeMap.SetAt( BT_Zeitbeherrschung_Vampirin    , "Zeitbeherrschung (Vampirin)" );// 1029,
    s_BonusTypeMap.SetAt( BT_Blutbiss                     , "Blutbiss" );// 1030,
    s_BonusTypeMap.SetAt( BT_Meisterbiss                  , "Meisterbiss" );// 1031,
    s_BonusTypeMap.SetAt( BT_Klauensprung                 , "Klauensprung" );// 1032,
    s_BonusTypeMap.SetAt( BT_Blutkuss                     , "Blutkuss" );// 1033,
    s_BonusTypeMap.SetAt( BT_Erweckung                    , "Erweckung" );// 1034,
    s_BonusTypeMap.SetAt( BT_Fledermaeuse_Blutschwarm     , "Fledermuse: Blutschwarm" );// 1035,
    s_BonusTypeMap.SetAt( BT_Fledermaeuse_Verwirrung      , "Fledermuse: Verwirrung" );// 1036,
    s_BonusTypeMap.SetAt( BT_Fledermaeuse_Waechter        , "Fledermuse: Wchter" );// 1037,
    s_BonusTypeMap.SetAt( BT_Rundumschlag2                , "Rundumschlag" );// 1038,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag2               , "Harter Schlag" );// 1039,
    s_BonusTypeMap.SetAt( BT_Attacke2                     , "Attacke" );// 1040,
    s_BonusTypeMap.SetAt( BT_Kampftritt2                  , "Kampftritt" );// 1041,
    s_BonusTypeMap.SetAt( BT_Kobra                        , "Kobra" );// 1042,
    s_BonusTypeMap.SetAt( BT_Mungo                        , "Mungo" );// 1043,
    s_BonusTypeMap.SetAt( BT_Seelenraeuber                , "Seelenruber" );// 1044,
    s_BonusTypeMap.SetAt( BT_Pak_Dain_Projektilumleitung  , "Pak Dain (Projektilumleitung)" );// 1045,
    s_BonusTypeMap.SetAt( BT_Pak_Nakor_Magieumleitung     , "Pak Nakor (Magieumleitung)" );// 1046,
    s_BonusTypeMap.SetAt( BT_Testosteron                  , "Testosteron" );// 1047,
    s_BonusTypeMap.SetAt( BT_Adrenalin                    , "Adrenalin" );// 1048,
    s_BonusTypeMap.SetAt( BT_Sprengsatz                   , "Sprengsatz" );// 1049,
    s_BonusTypeMap.SetAt( BT_Hoellenschlund               , "Hllenschlund" );// 1050,
    s_BonusTypeMap.SetAt( BT_Verwirrung                   , "Verwirrung" );// 1051,
    s_BonusTypeMap.SetAt( BT_Gifthauch                    , "Gifthauch" );// 1052,
    s_BonusTypeMap.SetAt( BT_Schlachtennebel              , "Schlachtennebel" );// 1053,
    s_BonusTypeMap.SetAt( BT_Jaegersucher                 , "Jgersucher" );// 1054,

    s_BonusTypeMap.SetAt( BT_Rundumschlag3                , "Rundumschlag" );// 1057,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag3               , "Harter Schlag" );// 1058,
    s_BonusTypeMap.SetAt( BT_Attacke3                     , "Attacke" );// 1059,
    s_BonusTypeMap.SetAt( BT_Kampftritt3                  , "Kampftritt" );// 1060,
    s_BonusTypeMap.SetAt( BT_Rundumschlag4                , "Rundumschlag" );// 1061,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag4               , "Harter Schlag" );// 1062,
    s_BonusTypeMap.SetAt( BT_Attacke_Auge_um_Auge         , "Attacke (Auge um Auge)" );// 1063,
    s_BonusTypeMap.SetAt( BT_Kampftritt4                  , "Kampftritt" );// 1064,
    s_BonusTypeMap.SetAt( BT_Rundumschlag_Jaehzorn        , "Rundumschlag (Jhzorn)" );// 1065,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag_Rache          , "Harter Schlag (Rache)" );// 1066,
    s_BonusTypeMap.SetAt( BT_Attacke_Rage                 , "Attacke (Rage)" );// 1067,
    s_BonusTypeMap.SetAt( BT_Kampftritt5                  , "Kampftritt" );// 1068,
    s_BonusTypeMap.SetAt( BT_Rundumschlag5                , "Rundumschlag" );// 1069,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag5               , "Harter Schlag" );// 1070,
    s_BonusTypeMap.SetAt( BT_Attacke4                     , "Attacke" );// 1071,
    s_BonusTypeMap.SetAt( BT_Kampftritt6                  , "Kampftritt" );// 1072,
    s_BonusTypeMap.SetAt( BT_Rundumschlag_Wirbelklauen    , "Rundumschlag (Wirbelklauen)" );// 1073,
    s_BonusTypeMap.SetAt( BT_Harter_Schlag_Todesklauen    , "Harter Schlag (Todesklauen)" );// 1074,
    s_BonusTypeMap.SetAt( BT_Attacke_Reissende_Klauen     , "Attacke (Reiende Klauen)" );// 1075,
    s_BonusTypeMap.SetAt( BT_Kampftritt7                  , "Kampftritt" );// 1076,

    s_BonusTypeMap.SetAt( BT_Rundumschlag6                , "Rundumschlag" );// 1078,
    s_BonusTypeMap.SetAt( BT_Rundumschlag7                , "Rundumschlag" );// 1079,
    s_BonusTypeMap.SetAt( BT_Attacke5                     , "Attacke" );// 1080,

    s_BonusTypeMap.SetAt( BT_Kriegsrausch                 , "Kriegsrausch" );// 1082,
    s_BonusTypeMap.SetAt( BT_Abschlag                     , "Abschlag" );// 1083,
    s_BonusTypeMap.SetAt( BT_Wucht                        , "Wucht" );// 1084,
    s_BonusTypeMap.SetAt( BT_Flammenwerfer                , "Flammenwerfer" );// 1085,
    s_BonusTypeMap.SetAt( BT_Moersergranate               , "Mrsergranate" );// 1086,
    s_BonusTypeMap.SetAt( BT_Kanonenschuss                , "Kanonenschuss" );// 1087,

    s_BonusTypeMap.SetAt( BT_Kriegsschrei2                , "Kriegsschrei" );// 1089,

    s_BonusTypeMap.SetAt( BT_Sturzflug                    , "Sturzflug" );// 1091,
    s_BonusTypeMap.SetAt( BT_Attacke6                     , "Attacke" );// 1092,

    s_BonusTypeMap.SetAt( BT_Sturzflug_Flugdaemon         , "Sturzflug (Flugdmon)" );// 1094,

    s_BonusTypeMap.SetAt( BT_Attacke_Kampfdaemon          , "Attacke (Kampfdmon)" );// 1097,
    s_BonusTypeMap.SetAt( BT_Feuerwand_Feuerdaemon        , "Feuerwand (Feuerdmon)" );// 1098,
    s_BonusTypeMap.SetAt( BT_Giftwolke_Giftdaemon         , "Giftwolke (Giftdmon)" );// 1099,
    s_BonusTypeMap.SetAt( BT_Energieblitze_Energiedaemon  , "Energieblitze (Energiedmon)" );// 1100,
    s_BonusTypeMap.SetAt( BT_Giftwolke2                   , "Giftwolke" );// 1101,
    s_BonusTypeMap.SetAt( BT_Feuerwand2                   , "Feuerwand" );// 1102,
    s_BonusTypeMap.SetAt( BT_Kugelblitze                  , "Kugelblitze" );// 1103,

    // Modifikation ber Strke
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch_Prozent_Staerke       , "Waffenschaden Physisch: % Strke" );//66337,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer_Prozent_Staerke          , "Waffenschaden Feuer: % Strke" );//66338,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch_Prozent_Staerke        , "Waffenschaden Magisch: % Strke" );//66339,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift_Prozent_Staerke           , "Waffenschaden Gift: % Strke" );//66340,

    s_BonusTypeMap.SetAt( BT_Angriff_Prozent_Staerke                      , "% Strke auf Angriff" );//66345,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent_Staerke                 , "% Strke auf Verteidigung" );//66346,

    // Modifikation ber Geschick
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch_Prozent_Geschick      , "Waffenschaden Physisch: % Geschick" );//131873,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer_Prozent_Geschick         , "Waffenschaden Feuer: % Geschick" );//131874,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch_Prozent_Geschick       , "Waffenschaden Magisch: % Geschick" );//131875,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift_Prozent_Geschick          , "Waffenschaden Gift: % Geschick" );//131876,

    s_BonusTypeMap.SetAt( BT_Angriff_Prozent_Geschick                     , "% Geschick auf Angriff" );//131881,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent_Geschick                , "% Geschick auf Verteidigung" );//131882,

    // Modifikation ber Widerstand
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch_Prozent_Widerstand    , "Waffenschaden Physisch: % Widerstand" );//197409,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer_Prozent_Widerstand       , "Waffenschaden Feuer: % Widerstand" );//197410,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch_Prozent_Widerstand     , "Waffenschaden Magisch: % Widerstand" );//197411,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift_Prozent_Widerstand        , "Waffenschaden Gift: % Widerstand" );//197412,

    s_BonusTypeMap.SetAt( BT_Angriff_Prozent_Widerstand                   , "% Widerstand auf Angriff" );//197417,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent_Widerstand              , "% Widerstand auf Verteidigung" );//197418,

    // Modifikation ber Physische Regeneration
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch_Prozent_PhysReg       , "Waffenschaden Physisch: % Physische Regeneration" );//262945,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer_Prozent_PhysReg          , "Waffenschaden Feuer: % Physische Regeneration" );//262946,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch_Prozent_PhysReg        , "Waffenschaden Magisch: % Physische Regeneration" );//262947,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift_Prozent_PhysReg           , "Waffenschaden Gift: % Physische Regeneration" );//262948,

    s_BonusTypeMap.SetAt( BT_Angriff_Prozent_PhysReg                      , "% Physische Regeneration auf Angriff" );//262953,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent_PhysReg                 , "% Physische Regeneration auf Verteidigung" );//262954,

    // Modifikation ber Mentale Regeneration
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch_Prozent_MentReg       , "Waffenschaden Physisch: % Mentale Regeneration" );//328481,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer_Prozent_MentReg          , "Waffenschaden Feuer: % Mentale Regeneration" );//328482,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch_Prozent_MentReg        , "Waffenschaden Magisch: % Mentale Regeneration" );//328483,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift_Prozent_MentReg           , "Waffenschaden Gift: % Mentale Regeneration" );//328484,

    s_BonusTypeMap.SetAt( BT_Angriff_Prozent_MentReg                      , "% Mentale Regeneration auf Angriff" );//328489,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent_MentReg                 , "% Mentale Regeneration auf Verteidigung" );//328490,

    // Modifikation ber Charisma
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Physisch_Prozent_Charisma      , "Waffenschaden Physisch: % Charisma" );//394017,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Feuer_Prozent_Charisma         , "Waffenschaden Feuer: % Charisma" );//394018,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Magisch_Prozent_Charisma       , "Waffenschaden Magisch: % Charisma" );//394019,
    s_BonusTypeMap.SetAt( BT_Waffenschaden_Gift_Prozent_Charisma          , "Waffenschaden Gift: % Charisma" );//394020,

    s_BonusTypeMap.SetAt( BT_Angriff_Prozent_Charisma                     , "% Charisma auf Angriff" );//394025,
    s_BonusTypeMap.SetAt( BT_Verteidigung_Prozent_Charisma                , "% Charisma auf Verteidigung" );//394026,
}
