
#ifndef _PAXHELPER_H_

#define _PAXHELPER_H_


#include "paxstructures.h"


typedef CMap<CombatArt, CombatArt, CString, CString> CCombatArtToStringMap;
typedef CMap<BonusType, BonusType, CString, CString> CBonusTypeToStringMap;


class CPaxHelper
{
private:
    CPaxHelper() {}
    ~CPaxHelper() {}

    static void InitCombatArtMap();
    static void InitBonusTypeMap();

    static CCombatArtToStringMap s_CombatArtMap;
    static CBonusTypeToStringMap s_BonusTypeMap;

public:
    static CString GetSlotTypeString( SlotType slotType );
    static CString GetItemPositionString( ItemPosition itemPosition );
    static CString GetCharClassString( CharClass charClass );
    static CString GetSeverityString( Severity severity );
    static CString GetItemClassString( ItemClass itemClass );
    static CString GetSkillString( SkillType skillType );

    static CString GetCombatArtString( CombatArt combatArt );
    static CombatArt GetAssociatedCombatArt( CombatArt combatArt );

    static CString GetBonusTypeString( BonusType bonusType );
    static CString GetBonusTypeString( POSITION & pos, BonusType & bonusType );
    static POSITION GetFirstBonusType();
    static CString GetBonusCounterActsForString( BonusCounterActsFor bcaf );
    static CString GetBonusActsForString( BonusActsFor baf );
};


#endif _PAXHELPER_H_
