// PaxSection.cpp: Implementierung der Klasse CPaxSection.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PaxSection.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CPaxSection::CPaxSection( DWORD dwType, BYTE * pData, DWORD dwLength, bool bCompressed /*=false*/ )
{
    this->m_dwType = dwType;
    this->m_dwLength = dwLength;
    this->m_pData = pData;
    this->m_bCompressed = bCompressed;
    this->m_bChanged = false;
}

CPaxSection::CPaxSection( DWORD dwType, DWORD dwLength, const BYTE const * pData, bool bCompressed /*=false*/ )
{
    this->m_dwType = dwType;
    if (dwLength == 0)
    {
        this->m_pData = NULL;
    }
    else
    {
        this->m_pData = new BYTE[dwLength];
        if (this->m_pData != NULL)
        {
            memcpy( this->m_pData, pData, dwLength );
        }
    }

    this->m_dwLength = ((this->m_pData == NULL) ? 0 : dwLength);

    this->m_bCompressed = bCompressed;
    this->m_bChanged = false;
}

CPaxSection::CPaxSection( const CPaxSection & rSection )
{
    this->m_dwType = rSection.m_dwType;
    this->m_bCompressed = rSection.m_bCompressed;
    this->m_bChanged = rSection.m_bChanged;

    if (rSection.m_dwLength == 0)
    {
        this->m_pData = NULL;
    }
    else
    {
        this->m_pData = new BYTE[rSection.m_dwLength];
        if (this->m_pData != NULL)
        {
            memcpy( this->m_pData, rSection.m_pData, rSection.m_dwLength );
        }
    }

    this->m_dwLength = ((this->m_pData == NULL) ? 0 : rSection.m_dwLength);
}

CPaxSection::~CPaxSection()
{
    if (this->m_pData != NULL)
    {
        delete[] this->m_pData;
    }
}
