// PaxSection.h: Schnittstelle fr die Klasse CPaxSection.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PAXSECTION_H__243B73ED_006A_43B0_B9CC_2FEF77ED2FAB__INCLUDED_)
#define AFX_PAXSECTION_H__243B73ED_006A_43B0_B9CC_2FEF77ED2FAB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPaxSection  
{
private:
    DWORD m_dwType;
    DWORD m_dwLength;
    BYTE* m_pData;
    bool m_bCompressed;
    bool m_bChanged;

public:
	CPaxSection( DWORD dwType, DWORD dwLength, const BYTE const * pData, bool bCompressed = false );
    CPaxSection( DWORD dwType, BYTE * pData, DWORD dwLength, bool bCompressed = false );
    CPaxSection( const CPaxSection & rSection );
	virtual ~CPaxSection();

    DWORD               GetType     () const { return this->m_dwType;       }
    DWORD               GetLength   () const { return this->m_dwLength;     }
    const BYTE const *  GetData     () const { return this->m_pData;        }
    bool                IsCompressed() const { return this->m_bCompressed;  }
    bool                IsChanged   () const { return this->m_bChanged;     }

    BYTE *  GetData   () { return this->m_pData;    }
    void    SetChanged() { this->m_bChanged = true; }

    template <class T>
    static void SetValue( T & dest, T & source, CPaxSection & section )
    {
        if (dest != source)
        {
            dest = source;
            section.SetChanged();
        }
    }
};

#endif // !defined(AFX_PAXSECTION_H__243B73ED_006A_43B0_B9CC_2FEF77ED2FAB__INCLUDED_)
