
#ifndef _PAXSTRUCTURES_H_

#define _PAXSTRUCTURES_H_


#pragma warning(disable:4200)

#pragma pack(push)
#pragma pack(1)

/*********************************/
/* Definitionen                  */
/*********************************/

#define MAX_LEVEL_CLASSIC       206
#define MAX_LEVEL_UNDERWORLD    216

#define MAX_EXP_CLASSIC         2147483646
#define MAX_EXP_UNDERWORLD      2586931599

#define SACREDITEM_STARTSIG 0xFEEDF00D
#define SACREDITEM_ENDSIG   0xBAADC0DE
#define SACREDITEM_BADSIG   0xBAADF00D

#define MAX_WEAR_COUNT  18

#define MAX_SKILL_COUNT 8
#define MAX_BONUS_COUNT 8
#define MAX_SLOT_COUNT  8

#define CHAR_CLASS_ALL_CL   0x3F
#define CHAR_CLASS_ALL_UW   0xC0

/*********************************/
/* Header                        */
/*********************************/
typedef struct tPaxHeader
{
    BYTE bHeader[3];
    BYTE bHeaderVersion;
    DWORD dwSectionCount;
    DWORD dwUnknown1;
    DWORD dwUnknown2;
    DWORD dwUnknown3;
    DWORD dwUnknown4;
    DWORD dwUnknown5;
    DWORD dwUnknown6;
    DWORD dwUnknown7;
    DWORD dwUnknown8;
    DWORD dwUnknown9;
    BYTE bNull[212];
} PAXHEADER, *LPPAXHEADER;

/*********************************/
/* Sektionen-Tabelle             */
/*********************************/
typedef struct tSectionEntry
{
    DWORD dwType;
    DWORD dwOffset;
    DWORD dwSizeUncompressed;
} SECTIONENTRY, *LPSECTIONENTRY;

typedef struct tSection
{
    DWORD dwSignature;
    DWORD dwSizeCompressed;
    BYTE bNull[24];
} SECTION, *LPSECTION;

/*********************************/
/* C3                            */
/*********************************/
typedef struct tSectionC3
{
    UINT uiLevel;                       // 0x0000
    UINT uiType;                        // 0x0004
    WCHAR pszwName[64];                 // 0x0008
    UINT uiUnknown;                     // Anzahl der Items ???
    UINT aWearItems[MAX_WEAR_COUNT];    // 0x008C - 0x00D4
    BYTE bUnknown1[24];
    BYTE bLastSeverity;                 // 0x00EC
    BYTE bBronze;                       // 0x00ED
    BYTE bSilver;                       // 0x00EE
    BYTE bGold;                         // 0x00EF
    BYTE bPlatin;                       // 0x00F0
    BYTE bNiob;                         // 0x00F1
    BYTE bUnknown2;
    BYTE bFlags1;                       // 0x00F3
    BYTE bUnknown3[5];
    BYTE bRevivals;                     // 0x00F9
    BYTE bFlags2;                       // 0x00FA
    BYTE bUnknown4;
    UINT uiExp;                         // 0x00FC
    UINT uiGold;                        // 0x0100

} SECTIONC3, *LPSECTIONC3;

/*********************************/
/* C4                            */
/*********************************/
typedef struct tSectionC4
{
    UINT uiRevivals;        // 0x0000
    UINT uiKills;           // 0x0004
    UINT uiSurvivalTime;    // 0x0008
    UINT uiRunes;           // 0x000C
    UINT uiPlayTimeHours;   // 0x0010
    UINT uiPlayTimeMinutes; // 0x0014
    UINT uiPlayTimeSeconds; // 0x0018
} SECTIONC4, *LPSECTIONC4;

/*********************************/
/* C7                            */
/*********************************/
typedef struct tCombatArtEntry
{
    USHORT usType;
    BYTE bLevel;
    BYTE bBonus;
    UINT uiUnknown1;
    UINT uiUnknown2;
    UINT uiUnknown3;
    BYTE bUnknown[6];
} COMBATARTENTRY, *LPCOMBATARTENTRY;


typedef struct tSectionC7Sub
{
    UINT uiPortals;             // 0x0367/0x03AF
    BYTE bUnknown1[42];
    UINT uiType;                // 0x0395/0x03DD
    UINT uiExp;                 // 0x0399/0x03E1
    SHORT sStrength;            // 0x039D/0x03E5
    SHORT sRefractiveness;      // 0x039F/0x03E7
    SHORT sDexterity;           // 0x03A1/0x03E9
    SHORT sPhysReg;             // 0x03A3/0x03EB
    SHORT sMentReg;             // 0x03A5/0x03ED
    SHORT sCharisma;            // 0x03A7/0x03EF
    BYTE bUnknown2[7];
    BYTE bFreeAttributePoints;  // 0x03B0/0x03F8
    BYTE aSkillType[MAX_SKILL_COUNT];
    BYTE aSkillLevel[MAX_SKILL_COUNT];
    BYTE aSkillBonus[MAX_SKILL_COUNT];
    BYTE bUnknown3[6];
    WORD wFreeSkillPoints;      // 0x03CF/0x0417
    WORD wUnusedSkillCount;     // 0x03D1/0x0419
    UINT uiGold;                // 0x03D3/0x041B
    BYTE bUnknown5[12];
    UINT uiLevel;               // 0x03e3/0x042B
    BYTE bUnknown6[156];
    BYTE bCountKK;              // 0x0483/0x04CB
    BYTE bUnknown7[5];
    COMBATARTENTRY kkEntries[]; // 0x0489/0x04D1
} SECTIONC7SUB, *LPSECTIONC7SUB;

typedef struct tSectionC7
{
    BYTE bUnknown1[30];
    UINT uiType;                // 0x001E
    BYTE bUnknown2[491];
    WORD wCheatFlag;            // 0x020D
    BYTE bUnknown3[344];
    SECTIONC7SUB subSection;    // 0x0367
} SECTIONC7, *LPSECTIONC7;

typedef struct tSectionC7UW
{
    BYTE bUnknown1[30];
    UINT uiType;                // 0x001E
    BYTE bUnknown2[491];
    WORD wCheatFlag;            // 0x020D
    BYTE bUnknown3[416];
    SECTIONC7SUB subSection;    // 0x03AF
} SECTIONC7UW, *LPSECTIONC7UW;

/*********************************/
/* CA/CB                         */
/*********************************/
typedef struct tSacredItem1
{
    UINT uiItemID1;
    UINT uiStartSig;
    UINT uiUnknown1;
    USHORT usUnknown1;
    UINT uiItemSig;
    UINT uiItemID2;
    TCHAR pszUnknown[229];
    UINT uiEndSig;
    BYTE bSlotsFilled;
} SACREDITEM1, *LPSACREDITEM1;

typedef struct tBonusModificator
{
    BYTE bCounterActsFor;
    BYTE bActsFor;
} BONUSMODIFICATOR, *LPBONUSMODIFICATOR;

typedef struct tSacredItemSlot
{
    UINT uiItemID;
    BYTE bCharClass;
    BYTE bItemClass;
    BYTE bColor;
    BYTE bSeverity;
    UINT uiPrice;
    BYTE aSlots[MAX_SLOT_COUNT];
    BYTE bMinLevel;
    BYTE bMinStrength;          // Strke
    BYTE bMinDexterity;         // Geschicklichkeit
    BYTE bMinCharisma;          // Ausstrahlung
    BYTE bMinRefractiveness;    // Widerstand
    BYTE bLevel;
    BYTE bMinSkillType;
    BYTE bMinSkillLevel;
    USHORT usPhysDamageMin;
    USHORT usFireDamageMin;
    USHORT usMagicDamageMin;
    USHORT usPoisonDamageMin;
    USHORT usPhysDamageMax;
    USHORT usFireDamageMax;
    USHORT usMagicDamageMax;
    USHORT usPoisonDamageMax;
    USHORT usAttack;
    USHORT usDefense;
    USHORT usUnknown;
    USHORT usPhysResi;
    USHORT usFireResi;
    USHORT usMagicResi;
    USHORT usPoisResi;
    BONUSMODIFICATOR bm[MAX_BONUS_COUNT];
    UINT aBonusType[MAX_BONUS_COUNT];
    short aBonusValue[MAX_BONUS_COUNT];
    TCHAR pszUnknown[8];
} SACREDITEMSLOT, *LPSACREDITEMSLOT;

typedef struct tSacredItem2 : tSacredItemSlot
{
    TCHAR pszUnknown2[8];
    UINT uiEndSig;
} SACREDITEM2, *LPSACREDITEM2;

/*********************************/
/* CA/CB                         */
/*********************************/
typedef struct tBaggageEntry
{
    UINT uiItemSig;
    BYTE bUnknown1;
    BYTE bWidth;
    BYTE bHeight;
    BYTE bUnkown2;
    UINT uiItemID;
} BAGGAGEENTRY, *LPBAGGAGEENTRY;

typedef struct tWeaponSlotEntry
{
    UINT uiItemSig;
    UINT uiUnknown1;
    UINT uiUnknown2;
} WEAPONSLOTENTRY, *LPWEAPONSLOTENTRY;

typedef struct tSectionCA
{
    BYTE bUnknown1[1036];
    BAGGAGEENTRY aInventory[160];       // 0x040C - 0x0B8C
    BYTE bUnknown2[1152];
    WEAPONSLOTENTRY aWeaponSlots[10];   // 0x100C
    BYTE bUnknown3[200];
    BYTE bActiveSlot;                   // 0x114C
    // TODO: Books?
} SECTIONCA, *LPSECTIONCA;

typedef struct tSectionCB
{
    BYTE bUnknown1[1036];
    BAGGAGEENTRY aChest[200];       // 0x040C - 0x0D6C
} SECTIONCB, *LPSECTIONCB;


/*********************************/
/* CD                            */
/*********************************/
typedef struct tSectionCDHeader
{
    UINT uiHeaderStartSig;
    UINT uiSectorCount;
    UINT uiUnknown1;
    UINT uiUnknown2;
    UINT uiUnknown3;
    UINT uiHeaderEndSig;
} SECTIONCDHEADER, *LPSECTIONCDHEADER;

typedef struct tSectionCDEntry
{
    UINT uiSector;
    UINT uiUnknown;
    BYTE aSectorInfo[128];
} SECTIONCDENTRY, *LPSECTIONCDENTRY;

typedef struct tSectionCD
{
    SECTIONCDHEADER header;
    SECTIONCDENTRY entries[];
} SECTIONCD, *LPSECTIONCD;


/*********************************/
/* CD                            */
/*********************************/
typedef struct tSectionCE
{
    TCHAR pszData[100];
} SECTIONCE, *LPSECTIONCE;

#pragma pack(pop)


/*********************************/
/* Enumerations                  */
/*********************************/
typedef enum _Attribute
{
    A_Staerke,
    A_Widerstand,
    A_Geschick,
    A_PhysReg,
    A_MentReg,
    A_Charisma,
} Attribute;

typedef enum _BonusActsFor
{
    // unteres Halbbyte (Werte)
    BAF_All         = 0,
    BAF_Seraphim    = 1,
    BAF_Gladiator   = 2,
    BAF_Kampfmagier = 3,
    BAF_Dunkelelf   = 4,
    BAF_Waldelfe    = 5,
    BAF_Vampirin    = 6,
    BAF_Zwerg       = 8,
    BAF_Daemonin    = 9,

    // oberes Halbbyte (Flags)
    BAF_Schaden     = 0x10,
    BAF_Zauber      = 0x20,
    BAF_Waffe       = 0x40,
    BAF_Resistenz   = 0x80,

} BonusActsFor;

typedef enum _BonusCounterActsFor
{
    BCAF_None           = 0,
    BCAF_Helden         = 1,
    BCAF_Monster        = 2,
    BCAF_Neutrale       = 3,
    BCAF_Pferde         = 4,
    BCAF_Untote         = 5,
    BCAF_Tiere          = 6,
    BCAF_Soeldner       = 7,
    BCAF_Goblins        = 8,
    BCAF_Daemonen       = 9,
    BCAF_Drachen        = 10,
    BCAF_Energiewesen   = 11,
    BCAF_Elfen          = 12,
    BCAF_Fernkaempfer   = 128,
    BCAF_Berittene      = 129,
} BonusCounterActsFor;

typedef enum _BonusTypeModificator
{
    BTM_Staerke     = 0x10000,
    BTM_Geschick    = 0x20000,
    BTM_Widerstand  = 0x30000,
    BTM_PhysReg     = 0x40000,
    BTM_MentReg     = 0x50000,
    BTM_Charisma    = 0x60000,
} BonusTypeModificator;

typedef enum _BonusType
{
    BT_None                     = 0,
    BT_Phasenverschiebung       = 1,
    BT_Steinhaut                = 2,
    BT_Gefaehrtin_des_Waldes    = 3,
    BT_Wasserform               = 4,
    BT_Feuerball                = 5,
    BT_Pentagramm               = 6,
    BT_Spirituelle_Heilkraft    = 7,
    BT_Kugelblitz               = 8,
    BT_Goettliche_Gabe          = 9,
    BT_Morph                    = 10,
    BT_Feuerspirale             = 11,
    BT_Groundpoison             = 12,
    BT_Blitzschlag              = 13,
    BT_Breeze                   = 14,
    BT_Himmelsleuchten          = 15,
    BT_Bannkreis_der_Angst      = 16,
    BT_Rotierende_Lichtklingen  = 17,
    BT_Irritation               = 18,
    BT_Bekehrung                = 19,
    BT_Licht                    = 20,
    BT_Glaubensstaerke          = 21,
    BT_Lichtschild              = 22,
    BT_Fegefeuer                = 23,
    BT_Flammenhaut              = 24,
    BT_Fleisch_zu_Stein         = 25,
    BT_Meteoritenhagel          = 26,
    BT_Katarakt_der_Wendigkeit  = 27,
    BT_Wirbelwind               = 28,
    BT_Windboee                 = 29,
    BT_Schildwall               = 30,
    BT_Aue_des_Geistes          = 31,
    BT_Reiki                    = 32,
    BT_Kettenblitz              = 33,
    BT_Eissplitter              = 34,
    BT_Frostring                = 35,
    BT_Verwandlung              = 36,
    BT_Wieselflink              = 37,
    BT_Dornenkugel              = 38,
    BT_Giftranken               = 39,
    BT_Pflanzenkaefig           = 40,
    BT_Ruf_der_Ahnen            = 41,
    BT_Genesung                 = 42,
    BT_Kriegsschrei1            = 43,
    BT_Gier1                    = 44,
    BT_Tellerminen1             = 45,
    BT_Eingraben1               = 46,
    BT_Zwergenstahl1            = 47,
    BT_Zwergenpanzer1           = 48,
    BT_Hoellendiskus1           = 49,
    BT_Feuerwand1               = 50,
    BT_Giftwolke1               = 51,
    BT_Kugelblitze1             = 52,
    BT_Kugelblitze2             = 53,
    BT_Gier2                    = 54,
    BT_Tellerminen2             = 55,
    BT_Eingraben2               = 57,
    BT_Zwergenpanzer2           = 58,
    BT_Zwergenstahl2            = 59,
    BT_Hoellendiskus2           = 60,
    BT_Kugelblitze3             = 61,
    BT_Ruf_des_Todes            = 62,
    BT_Hoellenkraft             = 63,
    BT_Flammenwaechter          = 64,
    BT_Tentakel                 = 65,
    BT_Chor_der_Hoelle          = 66,
    BT_Hoellenfurcht            = 67,
    BT_Kugelblitze4             = 68,
    BT_Kugelblitze5             = 69,
    BT_Kugelblitze6             = 70,
    BT_Kugelblitze7             = 71,

    BT_Himmelsmagie     = 600,
    BT_Waffenkunde      = 601,
    BT_Stangenwaffen    = 602,
    BT_Schwertkunde     = 603,
    BT_Axtkampf         = 604,
    BT_Zweiwaffenkampf  = 605,
    BT_Fernkampf        = 606,
    BT_Wendigkeit       = 607,
    BT_Parade           = 608,
    BT_Konstitution     = 609,
    BT_Ruestung         = 610,
    BT_Meditation       = 611,
    BT_Klingenkampf     = 612,
    BT_Magiekunde       = 613,
    BT_Feuermagie       = 614,
    BT_Wassermagie      = 615,
    BT_Erdmagie         = 616,
    BT_Luftmagie        = 617,
    BT_Mondmagie        = 618,
    BT_Vampirismus      = 619,
    BT_Handel           = 620,
    BT_Reiten           = 621,
    BT_Entwaffnung      = 622,
    BT_Faustkampf       = 623,
    BT_Konzentration    = 624,
    BT_Ballistik        = 625,
    BT_Fallenkunst      = 626,
    BT_Blutrausch       = 627,
    BT_Waffentechnik    = 628,
    BT_Zweihandwaffen   = 629,
    BT_Zwergenkunde     = 630,
    BT_Hoellenmacht     = 631,
    BT_Schmiedekunst    = 632,

    BT_Waffenschaden_Physisch               = 801,
    BT_Waffenschaden_Feuer                  = 802,
    BT_Waffenschaden_Magisch                = 803,
    BT_Waffenschaden_Gift                   = 804,
    BT_Physisch_Schaden_Prozent             = 805,
    BT_Feuer_Schaden_Prozent                = 806,
    BT_Magisch_Schaden_Prozent              = 807,
    BT_Gift_Schaden_Prozent                 = 808,
    BT_Angriff_Prozent                      = 809,
    BT_Verteidigung_Prozent                 = 810,
    BT_Angriffstempo                        = 811,
    BT_Geschwindigkeit                      = 812,
    BT_Regeneration_Zauber_Prozent          = 813,
    BT_Regeneration_Special_Move_Prozent    = 814,
    BT_Staerke                              = 815,
    BT_Geschick                             = 816,
    BT_Widerstand                           = 817,
    BT_PhysReg                              = 818,
    BT_MentReg                              = 819,
    BT_Charisma                             = 820,

    BT_Besondere_Gegenstaende_finden            = 840,
    BT_Leben_absaugen_Prozent                   = 841,
    BT_Eigenes_Leben_verlieren_Prozent          = 842,
    BT_Erfahrung_von_Gegnern_Prozent            = 843,
    BT_Auf_alle_Magiesprueche                   = 844,
    BT_Auf_alle_Special_Moves                   = 845,
    BT_Zerteilen_Prozent                        = 846,
    BT_Alle_Resistenzen_Prozent                 = 847,
    BT_Angriff_und_Verteidigung_Prozent         = 848,
    BT_Auf_alle_Fertigkeiten                    = 849,
    BT_Verlaengerte_Nacht_Prozent               = 850,
    BT_Verlaengerter_Tag_Prozent                = 851,
    BT_Gegner_sterben_bei_Blickkontakt_Prozent  = 852,
    BT_Weitsicht_Minimap                        = 853,

    BT_Chance_Fluggegner_zu_binden_Prozent                      = 855,
    BT_Chance_bei_Treffer_Gold_von_Gegner_zu_erhalten_Prozent   = 856,
    BT_Chance_auf_offene_Wunden_Prozent                         = 857,
    BT_Widerstand_gegen_Zauber                                  = 858,
    BT_Kritische_Treffer_landen                                 = 859,
    BT_Erhoeht_alle_Schadensarten_Prozent                       = 860,
    BT_Widerstand_gegen_Betaeubung                              = 861,
    BT_Gegner_schocken                                          = 862,
    BT_Untote_endgueltig_bannen                                 = 863,
    BT_Ermoeglicht_das_Angreifen_von_Tieren                     = 864,
    BT_Erweiterter_Lichtradius                                  = 865,
    BT_Schaden_von_Goldvorat_abziehen_Prozent                   = 866,
    BT_Verwundung_erhoeht_ausgeteilten_Schaden_Prozent          = 867,
    BT_Zusaetzliche_Traenke_finden                              = 868,

    BT_Rundumschlag1    = 1000,
    BT_Harter_Schlag1   = 1001,
    BT_Attacke1         = 1002,
    BT_Stampfsprung     = 1003,
    BT_Explosionspfeil  = 1004,
    BT_Mehrfachschuss   = 1005,
    BT_Spinnenpfeil     = 1006,
    BT_Keulenpfeil      = 1007,
    BT_Klingenpfeil     = 1008,
    BT_Kampftritt1      = 1009,
    BT_Rueckenbrecher   = 1010,

    BT_Fausthieb_der_Goetter        = 1012,
    BT_Schleuderklingen             = 1013,
    BT_Ehrfurcht                    = 1014,
    BT_Sturm_und_Drang              = 1015,
    BT_Blicke_wie_Klingen           = 1016,
    BT_Kampfsprung                  = 1017,
    BT_BeeEffGee                    = 1018,
    BT_Energieblitze                = 1019,
    BT_Wirbelschlag                 = 1020,
    BT_Flic_Flac                    = 1021,
    BT_Vampirform                   = 1022,
    BT_Ritterform                   = 1023,
    BT_Beherrschung                 = 1024,
    BT_Beherrschung_Vampirin        = 1025,
    BT_Wolfsruf                     = 1026,
    BT_Wolfsruf_Vampirin            = 1027,
    BT_Zeitbeherrschung             = 1028,
    BT_Zeitbeherrschung_Vampirin    = 1029,
    BT_Blutbiss                     = 1030,
    BT_Meisterbiss                  = 1031,
    BT_Klauensprung                 = 1032,
    BT_Blutkuss                     = 1033,
    BT_Erweckung                    = 1034,
    BT_Fledermaeuse_Blutschwarm     = 1035,
    BT_Fledermaeuse_Verwirrung      = 1036,
    BT_Fledermaeuse_Waechter        = 1037,
    BT_Rundumschlag2                = 1038,
    BT_Harter_Schlag2               = 1039,
    BT_Attacke2                     = 1040,
    BT_Kampftritt2                  = 1041,
    BT_Kobra                        = 1042,
    BT_Mungo                        = 1043,
    BT_Seelenraeuber                = 1044,
    BT_Pak_Dain_Projektilumleitung  = 1045,
    BT_Pak_Nakor_Magieumleitung     = 1046,
    BT_Testosteron                  = 1047,
    BT_Adrenalin                    = 1048,
    BT_Sprengsatz                   = 1049,
    BT_Hoellenschlund               = 1050,
    BT_Verwirrung                   = 1051,
    BT_Gifthauch                    = 1052,
    BT_Schlachtennebel              = 1053,
    BT_Jaegersucher                 = 1054,

    BT_Rundumschlag3                = 1057,
    BT_Harter_Schlag3               = 1058,
    BT_Attacke3                     = 1059,
    BT_Kampftritt3                  = 1060,
    BT_Rundumschlag4                = 1061,
    BT_Harter_Schlag4               = 1062,
    BT_Attacke_Auge_um_Auge         = 1063,
    BT_Kampftritt4                  = 1064,
    BT_Rundumschlag_Jaehzorn        = 1065,
    BT_Harter_Schlag_Rache          = 1066,
    BT_Attacke_Rage                 = 1067,
    BT_Kampftritt5                  = 1068,
    BT_Rundumschlag5                = 1069,
    BT_Harter_Schlag5               = 1070,
    BT_Attacke4                     = 1071,
    BT_Kampftritt6                  = 1072,
    BT_Rundumschlag_Wirbelklauen    = 1073,
    BT_Harter_Schlag_Todesklauen    = 1074,
    BT_Attacke_Reissende_Klauen     = 1075,
    BT_Kampftritt7                  = 1076,

    BT_Rundumschlag6                = 1078,
    BT_Rundumschlag7                = 1079,
    BT_Attacke5                     = 1080,

    BT_Kriegsrausch                 = 1082,
    BT_Abschlag                     = 1083,
    BT_Wucht                        = 1084,
    BT_Flammenwerfer                = 1085,
    BT_Moersergranate               = 1086,
    BT_Kanonenschuss                = 1087,

    BT_Kriegsschrei2                = 1089,

    BT_Sturzflug                    = 1091,
    BT_Attacke6                     = 1092,

    BT_Sturzflug_Flugdaemon         = 1094,

    BT_Attacke_Kampfdaemon          = 1097,
    BT_Feuerwand_Feuerdaemon        = 1098,
    BT_Giftwolke_Giftdaemon         = 1099,
    BT_Energieblitze_Energiedaemon  = 1100,
    BT_Giftwolke2                   = 1101,
    BT_Feuerwand2                   = 1102,
    BT_Kugelblitze                  = 1103,

    // Modifikation ber Strke
    BT_Waffenschaden_Physisch_Prozent_Staerke       = BT_Waffenschaden_Physisch | BTM_Staerke, //66337,
    BT_Waffenschaden_Feuer_Prozent_Staerke          = BT_Waffenschaden_Feuer    | BTM_Staerke, //66338,
    BT_Waffenschaden_Magisch_Prozent_Staerke        = BT_Waffenschaden_Magisch  | BTM_Staerke, //66339,
    BT_Waffenschaden_Gift_Prozent_Staerke           = BT_Waffenschaden_Gift     | BTM_Staerke, //66340,

    BT_Angriff_Prozent_Staerke                      = BT_Angriff_Prozent        | BTM_Staerke, //66345,
    BT_Verteidigung_Prozent_Staerke                 = BT_Verteidigung_Prozent   | BTM_Staerke, //66346,

    // Modifikation ber Geschick
    BT_Waffenschaden_Physisch_Prozent_Geschick      = BT_Waffenschaden_Physisch | BTM_Geschick, //131873,
    BT_Waffenschaden_Feuer_Prozent_Geschick         = BT_Waffenschaden_Feuer    | BTM_Geschick, //131874,
    BT_Waffenschaden_Magisch_Prozent_Geschick       = BT_Waffenschaden_Magisch  | BTM_Geschick, //131875,
    BT_Waffenschaden_Gift_Prozent_Geschick          = BT_Waffenschaden_Gift     | BTM_Geschick, //131876,

    BT_Angriff_Prozent_Geschick                     = BT_Angriff_Prozent        | BTM_Geschick, //131881,
    BT_Verteidigung_Prozent_Geschick                = BT_Verteidigung_Prozent   | BTM_Geschick, //131882,

    // Modifikation ber Widerstand
    BT_Waffenschaden_Physisch_Prozent_Widerstand    = BT_Waffenschaden_Physisch | BTM_Widerstand, //197409,
    BT_Waffenschaden_Feuer_Prozent_Widerstand       = BT_Waffenschaden_Feuer    | BTM_Widerstand, //197410,
    BT_Waffenschaden_Magisch_Prozent_Widerstand     = BT_Waffenschaden_Magisch  | BTM_Widerstand, //197411,
    BT_Waffenschaden_Gift_Prozent_Widerstand        = BT_Waffenschaden_Gift     | BTM_Widerstand, //197412,

    BT_Angriff_Prozent_Widerstand                   = BT_Angriff_Prozent        | BTM_Widerstand, //197417,
    BT_Verteidigung_Prozent_Widerstand              = BT_Verteidigung_Prozent   | BTM_Widerstand, //197418,

    // Modifikation ber Physische Regeneration
    BT_Waffenschaden_Physisch_Prozent_PhysReg       = BT_Waffenschaden_Physisch | BTM_PhysReg, //262945,
    BT_Waffenschaden_Feuer_Prozent_PhysReg          = BT_Waffenschaden_Feuer    | BTM_PhysReg, //262946,
    BT_Waffenschaden_Magisch_Prozent_PhysReg        = BT_Waffenschaden_Magisch  | BTM_PhysReg, //262947,
    BT_Waffenschaden_Gift_Prozent_PhysReg           = BT_Waffenschaden_Gift     | BTM_PhysReg, //262948,

    BT_Angriff_Prozent_PhysReg                      = BT_Angriff_Prozent        | BTM_PhysReg, //262953,
    BT_Verteidigung_Prozent_PhysReg                 = BT_Verteidigung_Prozent   | BTM_PhysReg, //262954,

    // Modifikation ber Mentale Regeneration
    BT_Waffenschaden_Physisch_Prozent_MentReg       = BT_Waffenschaden_Physisch | BTM_MentReg, //328481,
    BT_Waffenschaden_Feuer_Prozent_MentReg          = BT_Waffenschaden_Feuer    | BTM_MentReg, //328482,
    BT_Waffenschaden_Magisch_Prozent_MentReg        = BT_Waffenschaden_Magisch  | BTM_MentReg, //328483,
    BT_Waffenschaden_Gift_Prozent_MentReg           = BT_Waffenschaden_Gift     | BTM_MentReg, //328484,

    BT_Angriff_Prozent_MentReg                      = BT_Angriff_Prozent        | BTM_MentReg, //328489,
    BT_Verteidigung_Prozent_MentReg                 = BT_Verteidigung_Prozent   | BTM_MentReg, //328490,

    // Modifikation ber Charisma
    BT_Waffenschaden_Physisch_Prozent_Charisma      = BT_Waffenschaden_Physisch | BTM_Charisma, //394017,
    BT_Waffenschaden_Feuer_Prozent_Charisma         = BT_Waffenschaden_Feuer    | BTM_Charisma, //394018,
    BT_Waffenschaden_Magisch_Prozent_Charisma       = BT_Waffenschaden_Magisch  | BTM_Charisma, //394019,
    BT_Waffenschaden_Gift_Prozent_Charisma          = BT_Waffenschaden_Gift     | BTM_Charisma, //394020,

    BT_Angriff_Prozent_Charisma                     = BT_Angriff_Prozent        | BTM_Charisma, //394025,
    BT_Verteidigung_Prozent_Charisma                = BT_Verteidigung_Prozent   | BTM_Charisma, //394026,

} BonusType;

typedef enum _CharClass
{
    CC_None         = 0,
    CC_Seraphim     = 1,
    CC_Gladiator    = 2,
    CC_Mage         = 4,
    CC_Darkelf      = 8,
    CC_Woodelf      = 16,
    CC_Vampire      = 32,
    CC_Dwarf        = 64,
    CC_Daemon       = 128,
    CC_All          = CHAR_CLASS_ALL_CL,
} CharClass;

typedef enum _CharType
{
    CT_NoCharType,
    CT_Seraphim,
    CT_Gladiator,
    CT_Mage,
    CT_Darkelf,
    CT_Woodelf,
    CT_Vampire,
    CT_Vampire2,
    CT_Dwarf,
    CT_Daemon,
    CT_Last
} CharType;

typedef enum _CombatArt
{
    CA_None                                 = 0x0000,

    CA_Seraphim_LightningStrike             = 0x000D,   // Blitzschlag
    CA_Seraphim_CelestialLight              = 0x000F,   // Himmelsleuchten
    CA_Seraphim_RotatingBladesOfLight       = 0x0011,   // Rotierende Lichtklingen
    CA_Seraphim_Irritation                  = 0x0012,   // Irritation
    CA_Seraphim_Conversion                  = 0x0013,   // Bekehrung
    CA_Seraphim_Light                       = 0x0014,   // Licht
    CA_Seraphim_StrengthOfFaith             = 0x0015,   // Glaubensstrke
    CA_Seraphim_ShieldOfLight               = 0x0016,   // Lichtschild
    CA_Seraphim_CombatJump                  = 0x03F9,   // Kampfsprung
    CA_Seraphim_BeeEffGee                   = 0x03FA,   // BeeEffGee
    CA_Seraphim_EnergyBolts                 = 0x03FB,   // Energieblitze
    CA_Seraphim_WhirlingHit                 = 0x03FC,   // Wirbelschlag
    CA_Seraphim_HunterSeeker                = 0x041E,   // Jgersucher
    CA_Seraphim_MultiHit                    = 0x042D,   // Rundumschlag
    CA_Seraphim_HardHit                     = 0x042E,   // Harter Schlag
    CA_Seraphim_Attack                      = 0x042F,   // Attacke
    CA_Seraphim_CombatKick                  = 0x0430,   // Kampftritt

    CA_Gladiator_StompingJump               = 0x03EB,   // Stampfsprung
    CA_Gladiator_BackBreaker                = 0x03F2,   // Rckenbrecher
    CA_Gladiator_FistOfTheGods              = 0x03F4,   // Fausthieb der Gtter
    CA_Gladiator_ThrowingBlades             = 0x03F5,   // Schleuderklingen
    CA_Gladiator_Awe                        = 0x03F6,   // Ehrfurcht
    CA_Gladiator_HeroicCourage              = 0x03F7,   // Sturm und Drang
    CA_Gladiator_DaggerStare                = 0x03F8,   // Blicke wie Klingen
    CA_Gladiator_MultiHit                   = 0x0421,   // Rundumschlag
    CA_Gladiator_HardHit                    = 0x0422,   // Harter Schlag
    CA_Gladiator_Attack                     = 0x0423,   // Attacke
    CA_Gladiator_CombatKick                 = 0x0424,   // Kampftritt

    CA_Mage_PhaseShift                      = 0x0001,   // Phasenverschiebung
    CA_Mage_StoneSkin                       = 0x0002,   // Steinhaut
    CA_Mage_WaterForm                       = 0x0004,   // Wasserform
    CA_Mage_FireBall                        = 0x0005,   // Feuerball
    CA_Mage_SpiritualHealing                = 0x0007,   // Spirituelle Heilkraft
    CA_Mage_FireSpiral                      = 0x000B,   // Feuerspirale
    CA_Mage_CircleOfFear                    = 0x0010,   // Bannkreis der Angst
    CA_Mage_Purgatory                       = 0x0017,   // Fegefeuer
    CA_Mage_FlameSkin                       = 0x0018,   // Flammenhaut
    CA_Mage_Petrification                   = 0x0019,   // Fleisch zu Stein
    CA_Mage_MeteorStrom                     = 0x001A,   // Meteoritenhagel
    CA_Mage_CataractOfAgility               = 0x001B,   // Katarakt der Wendigkeit
    CA_Mage_Whirlwind                       = 0x001C,   // Wirbelwind
    CA_Mage_GustOfWind                      = 0x001D,   // Windbe
    CA_Mage_ShieldWall                      = 0x001E,   // Schildwall
    CA_Mage_GhostMeadow                     = 0x001F,   // Aue des Geistes
    CA_Mage_Reiki                           = 0x0020,   // Reiki
    CA_Mage_LightningStrike                 = 0x0021,   // Kettenblitz
    CA_Mage_IceShards                       = 0x0022,   // Eissplitter
    CA_Mage_RingOfIce                       = 0x0023,   // Frostring

    CA_DarkElf_Cobra                        = 0x0412,   // Kobra
    CA_DarkElf_Mongoose                     = 0x0413,   // Mungo
    CA_DarkElf_SoulCatcher                  = 0x0414,   // Seelenruber
    CA_DarkElf_PakDain_ProjectileDeflection = 0x0415,   // Projektilumleitung (Pak-Dain)
    CA_DarkElf_PakNakor_MagicDeflection     = 0x0416,   // Magieumleitung (Pak-Nakor)
    CA_DarkElf_Testosterone                 = 0x0417,   // Testosteron
    CA_DarkElf_Adrenaline                   = 0x0418,   // Adrenalin
    CA_DarkElf_ExplosiveCharge              = 0x0419,   // Sprengsatz
    CA_DarkElf_BottomlessPit                = 0x041A,   // Hllenschlund
    CA_DarkElf_Confusion                    = 0x041B,   // Verwirrung
    CA_DarkElf_PoisonMist                   = 0x041C,   // Gifthauch
    CA_DarkElf_BattleFog                    = 0x041D,   // Schlachtennebel
    CA_DarkElf_SuddenFury_MultiHit          = 0x0429,   // Rundumschlag (Jhzorn)
    CA_DarkElf_Revege_HardHit               = 0x042A,   // Harter Schlag
    CA_DarkElf_Rage_Attack                  = 0x042B,   // Attacke (Rage)
    CA_DarkElf_CombatKick                   = 0x042C,   // Kampftritt

    CA_WoodElf_CompanionOfTheWoods          = 0x0003,   // Gefhrte des Waldes
    CA_WoodElf_Transformation               = 0x0024,   // Verwandlung
    CA_WoodElf_QuickAsAFlash                = 0x0025,   // Wieselflink
    CA_WoodElf_ThornBush                    = 0x0026,   // Dornenbusch
    CA_WoodElf_PoisonedTendrils             = 0x0027,   // Giftranken
    CA_WoodElf_PlantCage                    = 0x0028,   // Pflanzenkfig
    CA_WoodElf_CallOfTheAncestors           = 0x0029,   // Ruf der Ahnen
    CA_WoodElf_Regeneration                 = 0x002A,   // Genesung
    CA_WoodElf_ExplosiveArrow               = 0x03EC,   // Explosionspfeil
    CA_WoodElf_MultipleShot                 = 0x03ED,   // Mehrfachschuss
    CA_WoodElf_SpiderArrow                  = 0x03EE,   // Spinnenpfeil
    CA_WoodElf_KnockbackArrow               = 0x03EF,   // Keulenpfeil
    CA_WoodElf_PenetratingArrow             = 0x03F0,   // Klingenpfeil
    CA_WoodElf_MultiHit                     = 0x0425,   // Rundumschlag
    CA_WoodElf_HardHit                      = 0x0426,   // Harter Schlag
    CA_WoodElf_EyeForAnEye_Attack           = 0x0427,   // Auge um Auge (Attacke)

    CA_Vampire_TurnIntoVampire_Knight       = 0x03FE,   // Vampirform / Ritterform
    CA_Vampire_TurnIntoVampire_Knight2      = 0x03FF,   // Vampirform / Ritterform
    CA_Vampire_MindControl                  = 0x0400,   // Beherrschung
    CA_Vampire_MindControl2                 = 0x0401,   // Beherrschung
    CA_Vampire_WolfCall                     = 0x0402,   // Wolfsruf
    CA_Vampire_WolfCall2                    = 0x0403,   // Wolfsruf
    CA_Vampire_TimeControl                  = 0x0404,   // Zeitbeherrschung
    CA_Vampire_TimeControl2                 = 0x0405,   // Zeitbeherrschung
    CA_Vampire_BloodBite                    = 0x0406,   // Blutbiss
    CA_Vampire_MasterBite                   = 0x0407,   // Meisterbiss
    CA_Vampire_CombatJump                   = 0x0408,   // Klauensprung
    CA_Vampire_BloodKiss                    = 0x0409,   // Blutkuss
    CA_Vampire_AwakenDead                   = 0x040A,   // Erweckung
    CA_Vampire_Bats_BloodSwarm              = 0x040B,   // Fledermuse: Blutschwarm
    CA_Vampire_Bats_Confusion               = 0x040C,   // Fledermuse: Verwirrung
    CA_Vampire_Bats_Guard                   = 0x040D,   // Fledermuse: Wchter
    CA_Vampire_WhirlingClaws_MultiHit2      = 0x040E,   // Rundumschlag / Wirbelklauen
    CA_Vampire_ClawsOfDeath_HardHit2        = 0x040F,   // Harter Schlag / Todesklauen
    CA_Vampire_RippingClaws_Attack2         = 0x0410,   // Attacke / Reiende Klauen
    CA_Vampire_CombatKick2                  = 0x0411,   // Kampftritt
    CA_Vampire_WhirlingClaws_MultiHit       = 0x0431,   // Rundumschlag / Wirbelklauen
    CA_Vampire_ClawsOfDeath_HardHit         = 0x0432,   // Harter Schlag / Todesklauen
    CA_Vampire_RippingClaws_Attack          = 0x0433,   // Attacke / Reiende Klauen
    CA_Vampire_CombatKick                   = 0x0434,   // Kampftritt

    CA_Dwarf_Greed                          = 0x0037,   // Gier
    CA_Dwarf_Landmine                       = 0x0038,   // Tellerminen
    CA_Dwarf_Entrench                       = 0x0039,   // Eingraben
    CA_Dwarf_DwarvenArmor                   = 0x003A,   // Zwergenpanzer
    CA_Dwarf_DwarvenSteel                   = 0x003B,   // Zwergenstahl
    CA_Dwarf_Wrath                          = 0x0436,   // Rundumschlag
    CA_Dwarf_HeavyBlow                      = 0x0437,   // Harter Schlag
    CA_Dwarf_Assault                        = 0x0438,   // Attacke
    CA_Dwarf_BattleRage                     = 0x043A,   // Kriegsrausch
    CA_Dwarf_Recoil                         = 0x043B,   // Abschlag
    CA_Dwarf_Vehemence                      = 0x043C,   // Wucht
    CA_Dwarf_FlameThrower                   = 0x043D,   // Flammenwerfer
    CA_Dwarf_MortarGrenade                  = 0x043E,   // Mrsergranate
    CA_Dwarf_CannonBlast                    = 0x043F,   // Kanonenschuss
    CA_Dwarf_WarCry                         = 0x0441,   // Kriegsschrei

    CA_Deamon_BlazingDisc                   = 0x003C,   // Hllendiskus
    CA_Deamon_CallOfDeath                   = 0x003E,   // Ruf des Todes
    CA_Deamon_InfernalPower                 = 0x003F,   // Hllenkraft
    CA_Deamon_HellSphere                    = 0x0040,   // Hllenfeuer
    CA_Deamon_Tentacles                     = 0x0041,   // Tentakel
    CA_Deamon_AbysmalChoir                  = 0x0042,   // Chor der Hlle
    CA_Deamon_Dread                         = 0x0043,   // Hllenfurcht
    CA_Deamon_SoaringDaemon                 = 0x0443,   // Flugdmon Sturzflug (Harter Schlag)
    CA_Deamon_BattleDaemon2                 = 0x0444,   // Kampfdmon Attacke
    CA_Deamon_SoaringDaemon2                = 0x0446,   // Flugdmon Sturzflug (Harter Schlag)
    CA_Deamon_BattleDaemon                  = 0x0449,   // Kampfdmon Attacke
    CA_Deamon_FireDaemon2                   = 0x044A,   // Feuerdmon Flammenwand
    CA_Deamon_PoisonDaemon                  = 0x044B,   // Giftdmon Giftring
    CA_Deamon_EnergyDaemon                  = 0x044C,   // Energiedmon Energieblitze
    CA_Deamon_PoisonDaemon2                 = 0x044D,   // Giftdmon Giftring
    CA_Deamon_FireDaemon                    = 0x044E,   // Feuerdmon Flammenwand
    CA_Deamon_EnergyDaemon2                 = 0x044F,   // Energiedmon Energieblitze
} CombatArt;

typedef enum _ItemClass
{
    IC_Bad              = 0,
    IC_Dolch            = 1,
    IC_Schwert          = 3,
    IC_Zweihandschwert  = 4,
    IC_Axt              = 5,
    IC_Zweihandaxt      = 6,
    IC_Schild           = 7,
    IC_Bogen            = 8,
    IC_Armbrust         = 9,
    IC_Faustwaffe       = 10,
    IC_Ruestung         = 13,
    IC_Ring             = 14,
    IC_Amulett          = 15,
    IC_Helm             = 16,
    IC_Armschutz        = 17,
    IC_Beinschutz       = 18,
    IC_Guertel          = 19,
    IC_Schulterpanzer   = 20,
    IC_Stangenwaffe1    = 21,
    IC_Wuchtwaffe       = 22,
    IC_Stangenwaffe2    = 23,
    IC_Stab             = 24,
    IC_Zaumzeug         = 25,
    IC_Schuhe           = 26,
    IC_Handschuhe       = 27,
    IC_Fluegel          = 28,
    IC_Sonderitem       = 29,
    IC_Pistole          = 30,
    IC_Gewehr           = 31,
    IC_Kanone           = 32,
} ItemClass;

typedef enum _ItemPosition
{
    IP_Slot1,           // Waffenslot 1
    IP_Slot2,           // Waffenslot 2
    IP_Slot3,           // Waffenslot 3
    IP_Slot4,           // Waffenslot 4
    IP_Slot5,           // Waffenslot 5
    IP_Inventory,       // Inventar
    IP_Chest,           // Truhe
    IP_Helmet,          // Helm
    IP_Cuirass,         // Rstung
    IP_Belt,            // Grtel
    IP_Shoes,           // Schuhe
    IP_Gloves,          // Handschuhe
    IP_Bracers,         // Armschienen
    IP_Amulet1,         // Amulett 1
    IP_Amulet2,         // Amulett 2
    IP_Ring1,           // Ring 1
    IP_Ring2,           // Ring 2
    IP_Ring3,           // Ring 3
    IP_Ring4,           // Ring 4
    IP_WeaponSlotRight, // Waffenslot rechts 
    IP_WeaponSlotLeft,  // Waffenslot links
    IP_Gun,             // Kanone
    IP_Shoulder,        // Schulterpanzer
    IP_Greaves,         // Beinschienen
    IP_Swing,           // Schwingen
    IP_Horse,           // Pferd
    IP_Saddle,          // Sattel auf dem Pferd
    IP_Unknown,
} ItemPosition;

typedef enum _Portal
{
    P_CL_Schoenblick    = (1 <<  0),    // Schnblick
    P_CL_PortoVallum    = (1 <<  1),    // Porto Vallum
    P_CL_Eisbachpass    = (1 <<  2),    // Eisbachpass
    P_CL_EbeneUrkuk     = (1 <<  3),    // Ebene von Urkuk
    P_CL_Biberingen     = (1 <<  4),    // Biberingen
    P_CL_Mascarell      = (1 <<  5),    // Mascarell
    P_CL_KhoradNur      = (1 <<  6),    // Khorad-Nur
    P_CL_Hohenmut       = (1 <<  7),    // Burg Hohenmut
    P_CL_Klosterfeste   = (1 <<  8),    // Klosterfeste der Seraphim
    P_CL_Heckenheim     = (1 <<  9),    // Heckenheim
    P_CL_ZhuragNar      = (1 << 10),    // Tal von Zhurag-Nar
    P_CL_Sternental     = (1 << 11),    // Burg Sternental
    P_CL_ShaddarNur     = (1 << 12),    // Shaddar-Nur
    P_UW_Zwergenruinen  = (1 << 14),    // Zwergenruinen
    P_UW_Purgatori      = (1 << 15),    // Purgatori
    P_UW_NukNukWald     = (1 << 16),    // Nuk-Nuk Wald
    P_UW_PiratenInseln  = (1 << 17),    // Piraten Inseln
    P_UW_Dryadenwald    = (1 << 18),    // Dryaden-Wald
    P_UW_GratDerHoelle  = (1 << 19),    // Grat der Hlle
    P_UW_TalDerTraenen  = (1 << 20),    // Tal der Trnen
    P_Last
} Portal;

typedef enum _Severity
{
    S_None,
    S_Bronze,
    S_Silver,
    S_Gold,
    S_Platin,
    S_Niob,
} Severity;

typedef enum _SkillNumber
{
    S_Skill1,
    S_Skill2,
    S_Skill3,
    S_Skill4,
    S_Skill5,
    S_Skill6,
    S_Skill7,
    S_Skill8,
} SkillNumber;

typedef enum _SkillType
{
    ST_NichtAusgewaehlt,
    ST_Himmelsmagie,
    ST_Waffenkunde,
    ST_Stangenwaffen,
    ST_Schwertkunde,
    ST_Axtkampf,
    ST_Zweiwaffenkampf,
    ST_Fernkampf,
    ST_Wendigkeit,
    ST_Parade,
    ST_Konstitution,
    ST_Ruestung,
    ST_Meditation,
    ST_Klingenkampf,
    ST_Magiekunde,
    ST_Feuermagie,
    ST_Wassermagie,
    ST_Erdmagie,
    ST_Luftmagie,
    ST_Mondmagie,
    ST_Vampirismus,
    ST_Handel,
    ST_Reiten,
    ST_Entwaffnung,
    ST_Faustkampf,
    ST_Konzentration,
    ST_Ballistik,
    ST_Fallenkunst,
    ST_Blutrausch,
    ST_Waffentechnik,
    ST_Zweihandwaffen,
    ST_Zwergenkunde,
    ST_Hoellenmacht,
    ST_Schmiedekunst,
    ST_LastSkill
} SkillType;

typedef enum _SlotType
{
    ST_None,
    ST_Bronze,
    ST_Silver,
    ST_Gold,
    ST_Green,
    ST_Platinum,
} SlotType;


#pragma warning(default:4200)


/*********************************/
/* zustzliche Datentypen        */
/*********************************/

typedef CMap<UINT,UINT,ItemPosition,ItemPosition> CItemPositionMap;



#endif _PAXSTRUCTURES_H_
