// PortalsDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "PortalsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CPortalsDlg 


CPortalsDlg::CPortalsDlg(CEventDispatcher & rEventDispatcher) : CModelessDlg(CPortalsDlg::IDD, rEventDispatcher)
{
	//{{AFX_DATA_INIT(CPortalsDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CPortalsDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessDlg::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK01, m_Portals[0]);
	DDX_Control(pDX, IDC_CHECK02, m_Portals[1]);
	DDX_Control(pDX, IDC_CHECK03, m_Portals[2]);
	DDX_Control(pDX, IDC_CHECK04, m_Portals[3]);
	DDX_Control(pDX, IDC_CHECK05, m_Portals[4]);
	DDX_Control(pDX, IDC_CHECK06, m_Portals[5]);
	DDX_Control(pDX, IDC_CHECK07, m_Portals[6]);
	DDX_Control(pDX, IDC_CHECK08, m_Portals[7]);
	DDX_Control(pDX, IDC_CHECK09, m_Portals[8]);
	DDX_Control(pDX, IDC_CHECK10, m_Portals[9]);
	DDX_Control(pDX, IDC_CHECK11, m_Portals[10]);
	DDX_Control(pDX, IDC_CHECK12, m_Portals[11]);
	DDX_Control(pDX, IDC_CHECK13, m_Portals[12]);
	DDX_Control(pDX, IDC_CHECK14, m_Portals[13]);
	DDX_Control(pDX, IDC_CHECK15, m_Portals[14]);
	DDX_Control(pDX, IDC_CHECK16, m_Portals[15]);
	DDX_Control(pDX, IDC_CHECK17, m_Portals[16]);
	DDX_Control(pDX, IDC_CHECK18, m_Portals[17]);
	DDX_Control(pDX, IDC_CHECK19, m_Portals[18]);
	DDX_Control(pDX, IDC_CHECK20, m_Portals[19]);
	DDX_Control(pDX, IDC_CHECK21, m_Portals[20]);
	//{{AFX_DATA_MAP(CPortalsDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPortalsDlg, CModelessDlg)
	//{{AFX_MSG_MAP(CPortalsDlg)
	ON_BN_CLICKED(IDC_ACTIVATE, OnActivate)
	ON_BN_CLICKED(IDC_INVERT, OnInvert)
	ON_BN_CLICKED(IDC_DEACTIVATE, OnDeactivate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CPaxSection* CPortalsDlg::GetC7Section( bool & bUW )
{
    bUW = false;

    if (this->m_pSHF != NULL)
    {
        if ( (this->m_pSHF->GetHeader() != NULL) && (this->m_pSHF->GetHeader()->GetLength() >= sizeof( PAXHEADER )))
        {
            LPPAXHEADER pHeader = (LPPAXHEADER)this->m_pSHF->GetHeader()->GetData();
            if (pHeader != NULL)
            {
                bUW = (pHeader->bHeaderVersion >= 0x1A);
            }
        }

        UINT ui, uiCount = this->m_pSHF->GetSectionCount();
        for (ui = 0; ui < uiCount; ++ui)
        {
            CPaxSection* pSection = this->m_pSHF->GetSection( ui );
            if ((pSection != NULL) && (pSection->GetType() == 0xC7))
            {
                return pSection;
            }
        }
    }

    return NULL;
}

LPSECTIONC7SUB CPortalsDlg::GetC7SubSection( CPaxSection* pSection, bool bUW )
{
    LPSECTIONC7SUB pC7SubSection = NULL;

    if ((pSection != NULL) && (pSection->GetType() == 0xC7))
    {
        if (bUW)
        {
            if (pSection->GetLength() >= sizeof( SECTIONC7UW ))
            {
                LPSECTIONC7UW pC7UW = (LPSECTIONC7UW)pSection->GetData();
                if (pC7UW != NULL)
                {
                    pC7SubSection = &(pC7UW->subSection);
                }
            }
        }
        else
        {
            if (pSection->GetLength() >= sizeof( SECTIONC7 ))
            {
                LPSECTIONC7 pC7 = (LPSECTIONC7)pSection->GetData();
                if (pC7 != NULL)
                {
                    pC7SubSection = &(pC7->subSection);
                }
            }
        }
    }

    return pC7SubSection;
}

static UINT s_PortalIDArray[21] =
{
    1 << 0,
    1 << 1,
    1 << 2,
    1 << 3,
    1 << 4,
    1 << 5,
    1 << 6,
    1 << 7,
    1 << 8,
    1 << 9,
    1 << 10,
    1 << 11,
    1 << 12,
    0,//1 << 13,
    1 << 14,
    1 << 15,
    1 << 16,
    1 << 17,
    1 << 18,
    1 << 19,
    1 << 20,
};

void CPortalsDlg::Refresh()
{
    bool bUW = false;
    CPaxSection* pC7Section = this->GetC7Section(bUW);
    LPSECTIONC7SUB pC7SubSection = this->GetC7SubSection( pC7Section, bUW );

    if (pC7SubSection != NULL)
    {
        for (int i = 0; i < 21; ++i)
        {
            this->m_Portals[i].SetCheck( (pC7SubSection->uiPortals & s_PortalIDArray[i]) == s_PortalIDArray[i] );
            this->m_Portals[i].EnableWindow( TRUE );
        }
    }
    else
    {
        for (int i = 0; i < 21; ++i)
        {
            this->m_Portals[i].SetCheck( 0 );
            this->m_Portals[i].EnableWindow( FALSE );
        }
    }
}

void CPortalsDlg::Save()
{
//*
    bool bUW = false;
    CPaxSection* pC7Section = this->GetC7Section(bUW);
    LPSECTIONC7SUB pC7SubSection = this->GetC7SubSection( pC7Section, bUW );

    if (pC7SubSection != NULL)
    {
        UINT uiPortals = 0;
        for (int i = 0; i < 21; ++i)
        {
            if (this->m_Portals[i].GetCheck() != 0)
            {
                uiPortals |= s_PortalIDArray[i];
            }
        }

        if (uiPortals != pC7SubSection->uiPortals)
        {
            pC7SubSection->uiPortals = uiPortals;
            pC7Section->SetChanged();
        }
    }
//*/
}

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CPortalsDlg 

void CPortalsDlg::OnActivate() 
{
    for (int i = 0; i < 21; ++i)
    {
        this->m_Portals[i].SetCheck( 1 );
    }
}

void CPortalsDlg::OnInvert() 
{
    for (int i = 0; i < 21; ++i)
    {
        this->m_Portals[i].SetCheck( this->m_Portals[i].GetCheck() == 0 ? 1 : 0 );
    }
}

void CPortalsDlg::OnDeactivate() 
{
    for (int i = 0; i < 21; ++i)
    {
        this->m_Portals[i].SetCheck( 0 );
    }
}

/*virtual*/ UINT CPortalsDlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;
/*
    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }
*/
    return uiRet;
}
