/* -----------------------------------------------------------------------------
 *  Project: BHVS
 *  Class:   CResizeDialog
 *  Description: Resizes the dialog automatically depending from information
 *               provided by the derived class.
 * -----------------------------------------------------------------------------
 * $Log: /BHVS/ResizeDialog.h $
 * 
 * 3     5.10.05 15:14 B7rtt5
 * Anzeigefehler bei Minimieren und Wiederherstellen
 * 
 * -----------------------------------------------------------------------------
 * Copyright: Copyright (c) SacredVault Team
 * developed by Uwe Posselt
 * -----------------------------------------------------------------------------
 */

#if !defined(AFX_RESIZEDIALOG_H__47AEE4B2_E6F2_4FB9_9EFF_E84981F64738__INCLUDED_)
#define AFX_RESIZEDIALOG_H__47AEE4B2_E6F2_4FB9_9EFF_E84981F64738__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ResizeDialog.h : Header-Datei
//

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CResizeDialog 

#ifndef RESIZEDIALOG_PARENT_CLASS
#define RESIZEDIALOG_PARENT_CLASS DLG_PARENT_CLASS_STANDARD
#endif  RESIZEDIALOG_PARENT_CLASS

#define MOVE_X              0x01
#define MOVE_HALF_X         0x02
#define SIZE_X              0x03
#define SIZE_HALF_X         0x04
#define MOVE_SIZE_HALF_X    0x05

#define MOVE_Y              0x10
#define MOVE_HALF_Y         0x20
#define SIZE_Y              0x30
#define SIZE_HALF_Y         0x40
#define MOVE_SIZE_HALF_Y    0x50

class CResizeDialog : public RESIZEDIALOG_PARENT_CLASS
{
// Konstruktion
public:
	CResizeDialog( UINT nIDTemplate, CWnd* pParent = NULL );   // Standardkonstruktor

	//{{AFX_DATA(CResizeDialog)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CResizeDialog)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

    virtual UINT GetChildMoveSize( UINT uiID) = 0;

    //{{AFX_MSG(CResizeDialog)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnGetMinMaxInfo( MINMAXINFO FAR* lpMMI );
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    long m_lMinX;                       // minimale Breite des Dialogfeldes, wird bei der Initialisierung des Dialoges gesetzt
    long m_lMinY;                       // minimale Hhe des Dialogfeldes, wird bei der Initialisierung des Dialoges gesetzt
    int m_iLastX;                       // letzte Breite des Dialogfeldes bei der Grennderung
    int m_iLastY;                       // letzte Hhe des Dialogfeldes bei der Grennderung
    CMap<UINT,UINT,UINT,UINT> m_ChildMap;
    CStatic m_Edge;
    bool m_bMinimized;

    static BOOL CALLBACK EnumChilds( HWND hwnd, LPARAM lParam );

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_RESIZEDIALOG_H__47AEE4B2_E6F2_4FB9_9EFF_E84981F64738__INCLUDED_
