// SacredHeroFile.h: Schnittstelle fr die Klasse CSacredHeroFile.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SACREDHEROFILE_H__45358ED2_B3FE_457F_85CE_286EFF84DBA9__INCLUDED_)
#define AFX_SACREDHEROFILE_H__45358ED2_B3FE_457F_85CE_286EFF84DBA9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "PaxSection.h"
#include "PaxStructures.h"


typedef CArray<CPaxSection*,CPaxSection*> CSectionArray;

class CSacredHeroFile  
{
private:
	CString m_strFileName;
    CSectionArray m_Sections;
    CSectionArray m_CompressedSections;
    CPaxSection* m_pHeader;
    CPaxSection* m_pTable;

	void DeleteBuffers();
    bool StoreSection( const SECTIONENTRY & rSectionEntry, BYTE* pFileBytes, DWORD dwMaxSize );

    static const DWORD s_dwSignatureCompression;

    static BYTE * Compress( const BYTE* pUncompressedData,  DWORD dwUncompressedSize, DWORD &dwCompressedSize );
    static bool Decompress( const BYTE* pCompressedData, DWORD dwCompressedSize, BYTE* pUncompressedData, DWORD dwUncompressedSize );
    static bool RawWrite( HANDLE hFile, LPCVOID pData, DWORD dwDataSize );

public:
	CSacredHeroFile();
	virtual ~CSacredHeroFile();

	virtual bool Load( const CString & strFileName );
    bool IsLoaded() const { return (this->m_strFileName.IsEmpty() == FALSE); }

    virtual bool Save() const;
    virtual bool SaveAs( const CString & strFileName ) const;

    const CPaxSection* GetTable() const { return this->m_pTable; }
    const CPaxSection* GetHeader() const { return this->m_pHeader; }

    UINT GetSectionCount() const;
    CPaxSection* GetSection( UINT uiIndex );
    const CPaxSection* GetSection( UINT uiIndex ) const;
};

#endif // !defined(AFX_SACREDHEROFILE_H__45358ED2_B3FE_457F_85CE_286EFF84DBA9__INCLUDED_)
