// SacredHeroFileEx.h: Schnittstelle fr die Klasse CSacredHeroFileEx.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SACREDHEROFILEEX_H__3809EEE6_3993_435F_AFB1_18732423FE16__INCLUDED_)
#define AFX_SACREDHEROFILEEX_H__3809EEE6_3993_435F_AFB1_18732423FE16__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CSacredHeroFileEx;    // Forward-Deklaration


#include "SacredHeroFile.h"
#include "PaxStructures.h"
#include "ItemList.h"


class CSacredHeroFileEx : public CSacredHeroFile  
{
private:
    CItemList * m_pItemList;

public:
	CSacredHeroFileEx();
	virtual ~CSacredHeroFileEx();

	virtual bool Load( const CString & strFileName );

    CItemList & GetItemList();

    bool IsUW() const;

    CPaxSection* GetC3Section() { return this->GetTypedSection( 0xC3 ); }
    CPaxSection* GetC4Section() { return this->GetTypedSection( 0xC4 ); }
    CPaxSection* GetC7Section() { return this->GetTypedSection( 0xC7 ); }
    CPaxSection* GetC8Section() { return this->GetTypedSection( 0xC8 ); }
    CPaxSection* GetCASection() { return this->GetTypedSection( 0xCA ); }
    CPaxSection* GetCBSection() { return this->GetTypedSection( 0xCB ); }
    CPaxSection* GetCDSection() { return this->GetTypedSection( 0xCD ); }
    CPaxSection* GetCESection() { return this->GetTypedSection( 0xCE ); }
    CPaxSection* GetTypedSection( UINT uiType );

    const CPaxSection* GetC3Section() const { return this->GetTypedSection( 0xC3 ); }
    const CPaxSection* GetC4Section() const { return this->GetTypedSection( 0xC4 ); }
    const CPaxSection* GetC7Section() const { return this->GetTypedSection( 0xC7 ); }
    const CPaxSection* GetC8Section() const { return this->GetTypedSection( 0xC8 ); }
    const CPaxSection* GetCASection() const { return this->GetTypedSection( 0xCA ); }
    const CPaxSection* GetCBSection() const { return this->GetTypedSection( 0xCB ); }
    const CPaxSection* GetCDSection() const { return this->GetTypedSection( 0xCD ); }
    const CPaxSection* GetCESection() const { return this->GetTypedSection( 0xCE ); }
    const CPaxSection* GetTypedSection( UINT uiType ) const;

    LPPAXHEADER GetHeaderStruct();
    LPSECTIONC3 GetC3Struct();
    LPSECTIONC4 GetC4Struct();
    LPSECTIONC7 GetC7Struct();
    LPSECTIONC7UW GetC7UWStruct();
    LPSECTIONC7SUB GetC7SubStruct();
    LPSECTIONCA GetCAStruct();
    LPSECTIONCB GetCBStruct();
    LPSECTIONCD GetCDStruct();

    const LPPAXHEADER GetHeaderStruct() const;
    const LPSECTIONC3 GetC3Struct() const;
    const LPSECTIONC4 GetC4Struct() const;
    const LPSECTIONC7 GetC7Struct() const;
    const LPSECTIONC7UW GetC7UWStruct() const;
    const LPSECTIONC7SUB GetC7SubStruct() const;
    const LPSECTIONCA GetCAStruct() const;
    const LPSECTIONCB GetCBStruct() const;
    const LPSECTIONCD GetCDStruct() const;
};


#endif // !defined(AFX_SACREDHEROFILEEX_H__3809EEE6_3993_435F_AFB1_18732423FE16__INCLUDED_)
