// SlotItem.h: Schnittstelle fr die Klasse CSlotItem.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SLOTITEM_H__3FC4632F_70AE_46FD_A18E_A659D4A2BE2A__INCLUDED_)
#define AFX_SLOTITEM_H__3FC4632F_70AE_46FD_A18E_A659D4A2BE2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CSlotItem; // Forward-Deklaration


#include "PaxSection.h"
#include "PaxStructures.h"


class CSlotItem  
{
private:
    CPaxSection* m_pC8Section;
    LPSACREDITEMSLOT m_pSlotItem;
    SlotType m_SlotType;

public:
	CSlotItem();
	virtual ~CSlotItem();

    void Initialize( CPaxSection & rC8Section, LPSACREDITEMSLOT pSlotItem, SlotType slotType );
    bool IsInitialized() const;

    SlotType GetSlotType() const;

    UINT GetItemID() const;
    CharClass GetCharClass() const;
    ItemClass GetItemClass() const;
    BYTE GetColor() const;
    Severity GetSeverity() const;
    UINT GetPrice() const;
    UINT GetMaxSlotCount() const;
    SlotType GetSlotType( UINT uiSlot ) const;
    BYTE GetMinLevel() const;
    BYTE GetMinStrength() const;
    BYTE GetMinDexterity() const;
    BYTE GetMinCharisma() const;
    BYTE GetMinRefractiveness() const;
    BYTE GetLevel() const;
    SkillType GetMinSkillType() const;
    BYTE GetMinSkillLevel() const;
    USHORT GetPhysDamageMin() const;
    USHORT GetFireDamageMin() const;
    USHORT GetMagicDamageMin() const;
    USHORT GetPoisonDamageMin() const;
    USHORT GetPhysDamageMax() const;
    USHORT GetFireDamageMax() const;
    USHORT GetMagicDamageMax() const;
    USHORT GetPoisonDamageMax() const;
    USHORT GetAttack() const;
    USHORT GetDefense() const;
    USHORT GetUnknown() const;
    USHORT GetPhysResi() const;
    USHORT GetFireResi() const;
    USHORT GetMagicResi() const;
    USHORT GetPoisonResi() const;

    bool GetBonus( UINT uiBonus, BYTE & bCounterActsFor, BYTE & bActsFor, UINT & uiBonusType, short & sBonusValue ) const;

    bool SetCharClass( CharClass charClass );
    bool SetItemClass( ItemClass itemClass ) const;
    bool SetColor( BYTE bColor ) const;
    bool SetSeverity( Severity severity ) const;
    bool SetPrice( UINT uiPrice ) const;
    bool SetSlotType( UINT uiSlot, SlotType slotType ) const;
    bool SetMinLevel( BYTE bMinLevel ) const;
    bool SetMinStrength( BYTE bMinStrength ) const;
    bool SetMinDexterity( BYTE bMinDexterity ) const;
    bool SetMinCharisma( BYTE bMinCharisma ) const;
    bool SetMinRefractiveness( BYTE bMinRefractiveness ) const;
    bool SetLevel( BYTE bLevel ) const;
    bool SetMinSkillType( SkillType skillType ) const;
    bool SetMinSkillLevel( BYTE bMinSkillLevel ) const;
    bool SetPhysDamageMin( USHORT usPhysDamageMin ) const;
    bool SetFireDamageMin( USHORT usFireDamageMin ) const;
    bool SetMagicDamageMin( USHORT usMagicDamageMin ) const;
    bool SetPoisonDamageMin( USHORT usPoisonDamageMin ) const;
    bool SetPhysDamageMax( USHORT usPhysDamageMax ) const;
    bool SetFireDamageMax( USHORT usFireDamageMax ) const;
    bool SetMagicDamageMax( USHORT usMagicDamageMax ) const;
    bool SetPoisonDamageMax( USHORT usPoisonDamageMax ) const;
    bool SetAttack( USHORT usAttack ) const;
    bool SetDefense( USHORT usDefense ) const;
    bool SetUnknown( USHORT usUnknown ) const;
    bool SetPhysResi( USHORT usPhysResi ) const;
    bool SetFireResi( USHORT usFireResi ) const;
    bool SetMagicResi( USHORT usMagixResi ) const;
    bool SetPoisonResi( USHORT usPosionResi ) const;

    bool SetBonus( UINT uiBonus, BYTE bCounterActsFor, BYTE bActsFor, UINT uiBonusType, short sBonusValue );
};

#endif // !defined(AFX_SLOTITEM_H__3FC4632F_70AE_46FD_A18E_A659D4A2BE2A__INCLUDED_)
