// sheDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "she.h"
#include "sheDlg.h"
#include "C3Dlg.h"
#include "C4Dlg.h"
#include "CDDlg.h"
#include "PortalsDlg.h"
#include "C7CommonDlg.h"
#include "C7AttributeSkillDlg.h"
#include "C7CombatArtsDlg.h"
#include "C8Dlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSheDlg Dialogfeld

CSheDlg::CSheDlg(CWnd* pParent /*=NULL*/) : SHE_DLG_PARENT_CLASS(CSheDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSheDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	this->m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    this->m_DlgArray.Add( new CC3Dlg( *this ) );
    this->m_DlgArray.Add( new CC4Dlg( *this ) );
    this->m_DlgArray.Add( new CC7CommonDlg( *this ) );
    this->m_DlgArray.Add( new CC7AttributeSkillDlg( *this ) );
    this->m_DlgArray.Add( new CC7CombatArtsDlg( *this ) );
    this->m_DlgArray.Add( new CCDDlg( *this ) );
    this->m_DlgArray.Add( new CPortalsDlg( *this ) );
    this->m_DlgArray.Add( new CC8Dlg( *this ) );
}

CSheDlg::~CSheDlg()
{
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_DlgArray[i] != NULL)
        {
            delete this->m_DlgArray[i];
        }
    }
}

void CSheDlg::DoDataExchange(CDataExchange* pDX)
{
	SHE_DLG_PARENT_CLASS::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSheDlg)
	DDX_Control(pDX, IDC_BROWSE, m_ButtonBrowse);
	DDX_Control(pDX, IDC_TAB, m_TabCtrl);
	DDX_Control(pDX, IDC_EDIT_NAME, m_EditFileName);
	DDX_Control(pDX, IDC_SAVEAS, m_ButtonSaveAs);
	DDX_Control(pDX, IDC_SAVE, m_ButtonSave);
	DDX_Control(pDX, IDC_REFRESH, m_ButtonRefresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSheDlg, SHE_DLG_PARENT_CLASS)
	//{{AFX_MSG_MAP(CSheDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_SAVEAS, OnSaveAs)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSheDlg Nachrichten-Handler

BOOL CSheDlg::OnInitDialog()
{
	SHE_DLG_PARENT_CLASS::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

    int i, iCount = this->m_DlgArray.GetSize();
    if (iCount > 0)
    {
        RECT rectTab, rectDlg;
        this->m_TabCtrl.GetWindowRect( &rectTab );
        this->m_TabCtrl.GetWindowRect( &rectDlg );

        for (i = 0; i < iCount; ++i)
        {
            if (this->m_DlgArray[i] != NULL)
            {
                this->m_DlgArray[i]->CreateModeless( &this->m_TabCtrl );
                this->m_DlgArray[i]->GetWindowRect( &rectDlg );
            }
        }

        rectDlg.top += rectTab.bottom - rectDlg.bottom - 5;
        rectDlg.bottom = rectTab.bottom - 4;
        rectDlg.left++;
        rectDlg.right++;
        this->m_TabCtrl.ScreenToClient( &rectDlg );

	    TC_ITEM tcItem;
        CString strCaption;
        for (i = 0; i < iCount; ++i)
        {
            if (this->m_DlgArray[i] != NULL)
            {
                strCaption = this->m_DlgArray[i]->GetCaption();
		        tcItem.mask = TCIF_TEXT;
                tcItem.pszText = (LPTSTR)(LPCTSTR)strCaption;
		        tcItem.cchTextMax = strCaption.GetLength();
		        this->m_TabCtrl.InsertItem(i,&tcItem);
                this->m_DlgArray[i]->MoveWindow( &rectDlg );
                this->m_TabCtrl.AttachControlToTab( this->m_DlgArray[i], i );
            }
        }

        this->m_TabCtrl.SetCurSel(0);
    }
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CSheDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		SHE_DLG_PARENT_CLASS::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CSheDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CSheDlg::PreTranslateMessage(MSG* pMsg) 
{
    if (pMsg->message == WM_KEYDOWN)
    {
        // ESC soll nicht dazu fhren, dass sich das Programm schliesst
        // Da wir die Taste nicht brauchen, wird sie einfach ignoriert.
        if (pMsg->wParam == VK_ESCAPE)
        {
            return TRUE;
        }

        // ENTER ist nur fr die 4 Buttons zulssig
        if (pMsg->wParam == VK_RETURN)
        {
            if (    (pMsg->hwnd != this->m_ButtonRefresh.GetSafeHwnd())
                &&  (pMsg->hwnd != this->m_ButtonSave.GetSafeHwnd())
                &&  (pMsg->hwnd != this->m_ButtonSaveAs.GetSafeHwnd())
                &&  (pMsg->hwnd != this->m_ButtonBrowse.GetSafeHwnd())
                )
            {
                return TRUE;
            }
        }
    }
	
	return SHE_DLG_PARENT_CLASS::PreTranslateMessage(pMsg);
}

int CSheDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (SHE_DLG_PARENT_CLASS::OnCreate(lpCreateStruct) == -1) return -1;

	return 0;
}

void CSheDlg::OnDestroy() 
{
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if ((this->m_DlgArray[i] != NULL) && (this->m_DlgArray[i]->GetSafeHwnd() != NULL))
        {
            this->m_DlgArray[i]->DestroyWindow();
        }
    }

	SHE_DLG_PARENT_CLASS::OnDestroy();
}

void CSheDlg::OnOK() 
{
	this->OnCancel();
}

void CSheDlg::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	SHE_DLG_PARENT_CLASS::OnCancel();
}

void CSheDlg::OnBrowse() 
{
    TCHAR pszFilePathName[_MAX_PATH];
    memset( pszFilePathName, 0, _MAX_PATH );
    strncpy( pszFilePathName, (LPCTSTR)this->m_strFileName, _MAX_PATH );

    TCHAR pszFilter[1024];
    memset( pszFilter, 0, 1024 );
    _snprintf( pszFilter, 1024, "Sacred Hero Dateien (*.pax)|*.pax|Alle Dateien (*.*)|*.*|" );
    LPTSTR pch = pszFilter;
	while ((pch = _tcschr(pch, '|')) != NULL)
    {
		*pch++ = '\0';
    }

    OPENFILENAME ofn;
    memset( &ofn, 0, sizeof( ofn ) );

    ofn.lStructSize = sizeof( ofn );
    ofn.hwndOwner = this->GetSafeHwnd();
    ofn.lpstrFilter = pszFilter;
    ofn.lpstrFile = pszFilePathName;
    ofn.nMaxFile = _MAX_PATH;
    ofn.lpstrTitle = "Sacred Hero Datei auswhlen ...";
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_ENABLESIZING | OFN_PATHMUSTEXIST;
    ofn.lpstrDefExt = "pax";

    if (0 != ::GetOpenFileName( &ofn ))
    {
        this->m_strFileName = pszFilePathName;
        this->m_EditFileName.SetWindowText( this->m_strFileName );
        this->OnRefresh();
    }
}

void CSheDlg::OnRefresh() 
{
    bool bOK = false;

    if (!this->m_strFileName.IsEmpty())
    {
        bOK = this->m_SHF.Load( this->m_strFileName );

        if (!bOK)
        {
            DWORD dwError = ::GetLastError();
            CString strError;
            strError.Format( "Fehler %lu beim Laden der Datei\n\n%s", dwError, (LPCTSTR)this->m_strFileName );
            ::AfxMessageBox( strError );
        }
    }

    CSacredHeroFileEx* pSHF = NULL;
    if (bOK)
    {
        pSHF = &this->m_SHF;
    }

    this->m_bSuppressEvents = true;
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_DlgArray[i] != NULL)
        {
            this->m_DlgArray[i]->SetHero( pSHF );
        }
    }
    this->m_bSuppressEvents = false;

    this->m_ButtonRefresh.EnableWindow( bOK );
//*
    this->m_ButtonSave.EnableWindow( bOK );
    this->m_ButtonSaveAs.EnableWindow( bOK );
//*/
}

void CSheDlg::OnSave() 
{
//*
    int i, iCount = this->m_DlgArray.GetSize();
    for (i = 0; i < iCount; ++i)
    {
        if (this->m_DlgArray[i] != NULL)
        {
            this->m_DlgArray[i]->Save();
        }
    }

    if (!this->m_SHF.Save())
    {
        DWORD dwError = ::GetLastError();
        CString strError;
        strError.Format( "Fehler %lu beim Speichern der Datei\n\n%s", dwError, (LPCTSTR)this->m_strFileName );
        ::AfxMessageBox( strError );
    }
//*/
}

void CSheDlg::OnSaveAs() 
{
//*
    TCHAR pszFilePathName[_MAX_PATH];
    memset( pszFilePathName, 0, _MAX_PATH );
    strncpy( pszFilePathName, (LPCTSTR)this->m_strFileName, _MAX_PATH );

    TCHAR pszFilter[1024];
    memset( pszFilter, 0, 1024 );
    _snprintf( pszFilter, 1024, "Sacred Hero Dateien (*.pax)|*.pax|Alle Dateien (*.*)|*.*|" );
    LPTSTR pch = pszFilter;
	while ((pch = _tcschr(pch, '|')) != NULL)
    {
		*pch++ = '\0';
    }

    OPENFILENAME ofn;
    memset( &ofn, 0, sizeof( ofn ) );

    ofn.lStructSize = sizeof( ofn );
    ofn.hwndOwner = this->GetSafeHwnd();
    ofn.lpstrFilter = pszFilter;
    ofn.lpstrFile = pszFilePathName;
    ofn.nMaxFile = _MAX_PATH;
    ofn.lpstrTitle = "Sacred Hero Datei speichern ...";
    ofn.Flags = OFN_ENABLESIZING | OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "pax";

    if (0 != ::GetSaveFileName( &ofn ))
    {
        int i, iCount = this->m_DlgArray.GetSize();
        for (i = 0; i < iCount; ++i)
        {
            if (this->m_DlgArray[i] != NULL)
            {
                this->m_DlgArray[i]->Save();
            }
        }

        if (this->m_SHF.SaveAs( pszFilePathName ))
        {
            this->m_strFileName = pszFilePathName;
            this->m_EditFileName.SetWindowText( this->m_strFileName );
        }
        else
        {
            DWORD dwError = ::GetLastError();
            CString strError;
            strError.Format( "Fehler %lu beim Speichern der Datei\n\n%s", dwError, pszFilePathName );
            ::AfxMessageBox( strError );
        }
    }
//*/
}

/*virtual*/ UINT CSheDlg::GetChildMoveSize( UINT uiID)
{
    UINT uiRet = 0;

    switch (uiID)
    {
        case IDC_EDIT_NAME: uiRet = SIZE_X; break;
        case IDC_BROWSE:
        case IDC_REFRESH: uiRet = 0; break;
        case IDC_SAVE:
        case IDC_SAVEAS: uiRet = MOVE_X; break;
        case IDC_TAB: uiRet = SIZE_X | SIZE_Y; break;
        default: TRACE("CSheDlg::GetChildMoveSize - unbekannte ID %u\n", uiID ); break;
    }

    return uiRet;
}
